// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"
#include "SetVar.h"
#include "Dlg2.h"
#include "Dlg3.h"

#include "WinconSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define CARD1	1
#define CARD2	2
#define CARD3	3

i8091CardType card1;
int CmdNo=0;

int slot91=1;

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_BUTTON1, m_Btn28);
	DDX_Control(pDX, IDC_BtnStopY, m_Btn27);
	DDX_Control(pDX, IDC_BtnStopX, m_Btn26);
	DDX_Control(pDX, IDC_BtnStopAll, m_Btn25);
	DDX_Control(pDX, IDC_BtnSlowStop, m_Btn24);
	DDX_Control(pDX, IDC_BtnSlowDown, m_Btn23);
	DDX_Control(pDX, IDC_BtnSetVar, m_Btn22);
	DDX_Control(pDX, IDC_BtnSetServoON, m_Btn21);
	DDX_Control(pDX, IDC_BtnSetNC, m_Btn20);
	DDX_Control(pDX, IDC_BtnSetMode, m_Btn19);
	DDX_Control(pDX, IDC_BtnSetDefDir, m_Btn18);
	DDX_Control(pDX, IDC_BtnResetSystem, m_Btn17);
	DDX_Control(pDX, IDC_BtnLspPulseMove, m_Btn16);
	DDX_Control(pDX, IDC_BtnLspOrg, m_Btn15);
	DDX_Control(pDX, IDC_BtnLspMove, m_Btn14);
	DDX_Control(pDX, IDC_BtnLimitY, m_Btn13);
	DDX_Control(pDX, IDC_BtnLimitX, m_Btn12);
	DDX_Control(pDX, IDC_BtnIsYStop, m_Btn11);
	DDX_Control(pDX, IDC_BtnIsXStop, m_Btn10);
	DDX_Control(pDX, IDC_BtnIntpPulse, m_Btn9);
	DDX_Control(pDX, IDC_BtnIntpLine02, m_Btn8);
	DDX_Control(pDX, IDC_BtnIntpLine, m_Btn7);
	DDX_Control(pDX, IDC_BtnHspPulseMove, m_Btn6);
	DDX_Control(pDX, IDC_BtnHspOrg, m_Btn5);
	DDX_Control(pDX, IDC_BtnHspMove, m_Btn4);
	DDX_Control(pDX, IDC_BtnCspMove, m_Btn3);
	DDX_Control(pDX, IDC_BtnCircle02, m_Btn2);
	DDX_Control(pDX, IDC_BtnArc02, m_Btn1);
	DDX_Control(pDX, IDC_COMBO1, m_Slot);
	DDX_Control(pDX, IDC_LISTMsg, m_ListMsg);
	DDX_Control(pDX, IDC_EditYSON, m_YSON);
	DDX_Control(pDX, IDC_EditYMODE, m_YMODE);
	DDX_Control(pDX, IDC_EditYDIR, m_YDIR);
	DDX_Control(pDX, IDC_EditXSON, m_XSON);
	DDX_Control(pDX, IDC_EditXMODE, m_XMODE);
	DDX_Control(pDX, IDC_EditXDIR, m_XDIR);
	DDX_Control(pDX, IDC_EditNC, m_NC);
	DDX_Control(pDX, IDC_EditLSP, m_LSP);
	DDX_Control(pDX, IDC_EditHSP, m_HSP);
	DDX_Control(pDX, IDC_EditAD, m_AD);
	DDX_Control(pDX, IDC_EditDDA, m_DDA);
	DDX_Control(pDX, IDC_EDITCMD, m_EditCmd);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_BN_CLICKED(IDC_BtnResetSystem, OnBtnResetSystem)
	ON_BN_CLICKED(IDC_BtnSetVar, OnBtnSetVar)
	ON_BN_CLICKED(IDC_BtnSetDefDir, OnBtnSetDefDir)
	ON_BN_CLICKED(IDC_BtnSetMode, OnBtnSetMode)
	ON_BN_CLICKED(IDC_BtnSetServoON, OnBtnSetServoON)
	ON_BN_CLICKED(IDC_BtnSetNC, OnBtnSetNC)
	ON_BN_CLICKED(IDC_BtnIsXStop, OnBtnIsXStop)
	ON_BN_CLICKED(IDC_BtnIsYStop, OnBtnIsYStop)
	ON_BN_CLICKED(IDC_BtnLimitX, OnBtnLimitX)
	ON_BN_CLICKED(IDC_BtnLimitY, OnBtnLimitY)
	ON_BN_CLICKED(IDC_BtnExit, OnBtnExit)
	ON_BN_CLICKED(IDC_BtnStopX, OnBtnStopX)
	ON_BN_CLICKED(IDC_BtnStopY, OnBtnStopY)
	ON_BN_CLICKED(IDC_BtnStopAll, OnBtnStopAll)
	ON_BN_CLICKED(IDC_BtnLspOrg, OnBtnLspOrg)
	ON_BN_CLICKED(IDC_BtnHspOrg, OnBtnHspOrg)
	ON_BN_CLICKED(IDC_BtnLspPulseMove, OnBtnLspPulseMove)
	ON_BN_CLICKED(IDC_BtnHspPulseMove, OnBtnHspPulseMove)
	ON_BN_CLICKED(IDC_BtnLspMove, OnBtnLspMove)
	ON_BN_CLICKED(IDC_BtnHspMove, OnBtnHspMove)
	ON_BN_CLICKED(IDC_BtnCspMove, OnBtnCspMove)
	ON_BN_CLICKED(IDC_BtnSlowStop, OnBtnSlowStop)
	ON_BN_CLICKED(IDC_BtnSlowDown, OnBtnSlowDown)
	ON_BN_CLICKED(IDC_BtnIntpPulse, OnBtnIntpPulse)
	ON_BN_CLICKED(IDC_BtnIntpLine, OnBtnIntpLine)
	ON_BN_CLICKED(IDC_BtnIntpLine02, OnBtnIntpLine02)
	ON_BN_CLICKED(IDC_BtnCircle02, OnBtnCircle02)
	ON_BN_CLICKED(IDC_BtnArc02, OnBtnArc02)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	TCHAR Temp[40];
	char string1[20];
	unsigned char ModuleID;

	for (int i=1;i<8;i++)
	{
		ModuleID=GetNameOfModule(i,string1);
		if (ModuleID==91)
		{
			slot91=i;
			m_Slot.SetCurSel(slot91-1);

			m_Btn1.EnableWindow(true);
			m_Btn2.EnableWindow(true);
			m_Btn3.EnableWindow(true);
			m_Btn4.EnableWindow(true);
			m_Btn5.EnableWindow(true);
			m_Btn6.EnableWindow(true);
			m_Btn7.EnableWindow(true);
			m_Btn8.EnableWindow(true);
			m_Btn9.EnableWindow(true);
			m_Btn10.EnableWindow(true);
			m_Btn11.EnableWindow(true);
			m_Btn12.EnableWindow(true);
			m_Btn13.EnableWindow(true);
			m_Btn14.EnableWindow(true);
			m_Btn15.EnableWindow(true);
			m_Btn16.EnableWindow(true);
			m_Btn17.EnableWindow(true);
			m_Btn18.EnableWindow(true);
			m_Btn19.EnableWindow(true);
			m_Btn20.EnableWindow(true);
			m_Btn21.EnableWindow(true);
			m_Btn22.EnableWindow(true);
			m_Btn23.EnableWindow(true);
			m_Btn24.EnableWindow(true);
			m_Btn25.EnableWindow(true);
			m_Btn26.EnableWindow(true);
			m_Btn27.EnableWindow(true);
			m_Btn28.EnableWindow(true);
			break;
		}
	}

	card1.slot=slot91;
	card1.DDA=10;
	card1.AD=3;
	card1.LSP=5;
	card1.HSP=150;
	card1.xmode=CW_CCW;
	card1.ymode=CW_CCW;
	card1.xdir=NORMAL_DIR;
	card1.ydir=NORMAL_DIR;
	card1.xson=ON;
	card1.yson=ON;
	card1.NCmode=OFF;

	swprintf(Temp,_T("%d"),card1.DDA);
	m_DDA.SetWindowText(Temp);
	swprintf(Temp,_T("%d"),card1.AD);
	m_AD.SetWindowText(Temp);
	swprintf(Temp,_T("%d"),card1.LSP);
	m_LSP.SetWindowText(Temp);
	swprintf(Temp,_T("%d"),card1.HSP);
	m_HSP.SetWindowText(Temp);
	m_XMODE.SetWindowText(_T("CW_CCW"));
	m_YMODE.SetWindowText(_T("CW_CCW"));
	m_XDIR.SetWindowText(_T("NORMAL"));
	m_YDIR.SetWindowText(_T("NORMAL"));
	m_XSON.SetWindowText(_T("ON"));
	m_YSON.SetWindowText(_T("ON"));
	m_NC.SetWindowText(_T("OFF"));

	//-------Initail function--------------
	i8091_REGISTRATION(CARD1, card1.slot);
	i8091_RESET_SYSTEM(CARD1);
	i8091_SET_VAR(CARD1, card1.DDA, card1.AD, card1.LSP, card1.HSP);
	i8091_SET_DEFDIR(CARD1, card1.xdir, card1.ydir);
	i8091_SET_MODE(CARD1, card1.xmode, card1.ymode);
	i8091_SET_SERVO_ON(CARD1, card1.xson, card1.yson);
	i8091_SET_NC(CARD1, card1.NCmode);
	Sleep(100);
	//-------------------------------------
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnBtnResetSystem() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Reset System"));
	i8091_RESET_SYSTEM(CARD1);
}

void CDemoDlg::OnBtnSetVar() 
{
	// TODO: Add your control notification handler code here
	TCHAR Temp[40];

	m_EditCmd.SetWindowText(_T("i8091 Set Var"));
	SetVar SetVarForm=new SetVar();

	SetVarForm.m_DDAValue=card1.DDA;
	SetVarForm.m_ADValue=card1.AD;
	SetVarForm.m_LSPValue=card1.LSP;
	SetVarForm.m_HSPValue=card1.HSP;
	
	int nResponse=SetVarForm.DoModal();
	if (nResponse == IDOK)
	{
		card1.DDA=SetVarForm.m_DDAValue;
		card1.AD=SetVarForm.m_ADValue;
		card1.LSP=SetVarForm.m_LSPValue;
		card1.HSP=SetVarForm.m_HSPValue;

		i8091_SET_VAR(CARD1, card1.DDA, card1.AD, card1.LSP, card1.HSP);
	}
	swprintf(Temp,_T("%d"),card1.DDA);
	m_DDA.SetWindowText(Temp);
	swprintf(Temp,_T("%d"),card1.AD);
	m_AD.SetWindowText(Temp);
	swprintf(Temp,_T("%d"),card1.LSP);
	m_LSP.SetWindowText(Temp);
	swprintf(Temp,_T("%d"),card1.HSP);
	m_HSP.SetWindowText(Temp);
}

void CDemoDlg::OnBtnSetDefDir() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Set Def Dir"));
	CmdNo=i8091_Set_Defdir;
	Dlg2 dlgForm=new Dlg2();

	dlgForm.m_CHK1=(card1.xdir==NORMAL_DIR)?0:-1;
	dlgForm.m_CHK2=(card1.xdir!=NORMAL_DIR)?0:-1;
	dlgForm.m_CHK3=(card1.ydir==NORMAL_DIR)?0:-1;
	dlgForm.m_CHK4=(card1.ydir!=NORMAL_DIR)?0:-1;

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)
	{
		if (dlgForm.m_CHK1==0)
		{
			card1.xdir=NORMAL_DIR;
			m_XDIR.SetWindowText(_T("NORMAL"));
		}
		else
		{
			card1.xdir=REVERSE_DIR;
			m_XDIR.SetWindowText(_T("REVERSE"));
		}
		if (dlgForm.m_CHK3==0)
		{
			card1.ydir=NORMAL_DIR;
			m_YDIR.SetWindowText(_T("NORMAL"));
		}
		else
		{
			card1.ydir=REVERSE_DIR;
			m_YDIR.SetWindowText(_T("REVERSE"));
		}

		i8091_SET_DEFDIR(CARD1, card1.xdir, card1.ydir);
	}

}

void CDemoDlg::OnBtnSetMode() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Set Mode"));
	CmdNo=i8091_Set_Mode;
	Dlg2 dlgForm=new Dlg2();
	
	dlgForm.m_CHK1=(card1.xmode==CW_CCW)?0:-1;
	dlgForm.m_CHK2=(card1.xmode!=CW_CCW)?0:-1;
	dlgForm.m_CHK3=(card1.ymode==CW_CCW)?0:-1;
	dlgForm.m_CHK4=(card1.ymode!=CW_CCW)?0:-1;	

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)
	{
		if (dlgForm.m_CHK1==0)
		{
			card1.xmode=CW_CCW;
			m_XMODE.SetWindowText(_T("CW_CCW"));
		}
		else
		{
			card1.xmode=PULSE_DIR;
			m_XMODE.SetWindowText(_T("PULSE_DIR"));
		}
		if (dlgForm.m_CHK3==0)
		{
			card1.ymode=NORMAL_DIR;
			m_YMODE.SetWindowText(_T("CW_CCW"));
		}
		else
		{
			card1.ymode=PULSE_DIR;
			m_YMODE.SetWindowText(_T("PULSE_DIR"));
		}

		i8091_SET_MODE(CARD1, card1.xmode, card1.ymode);
	}
}

void CDemoDlg::OnBtnSetServoON() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Set Servo ON"));
	CmdNo=i8091_Set_Servo_On;
	Dlg2 dlgForm=new Dlg2();
	
	dlgForm.m_CHK1=(card1.xson==OFF)?0:-1;
	dlgForm.m_CHK2=(card1.xson!=OFF)?0:-1;
	dlgForm.m_CHK3=(card1.yson==OFF)?0:-1;
	dlgForm.m_CHK4=(card1.yson!=OFF)?0:-1;	

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)
	{
		if (dlgForm.m_CHK1==0)
		{
			card1.xson=OFF;
			m_XSON.SetWindowText(_T("OFF"));
		}
		else
		{
			card1.xson=ON;
			m_XSON.SetWindowText(_T("ON"));
		}
		if (dlgForm.m_CHK3==0)
		{
			card1.yson=OFF;
			m_YSON.SetWindowText(_T("OFF"));
		}
		else
		{
			card1.yson=ON;
			m_YSON.SetWindowText(_T("ON"));
		}

		i8091_SET_SERVO_ON(CARD1, card1.xson, card1.yson);	
	}
}

void CDemoDlg::OnBtnSetNC() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Set NC"));
	CmdNo=i8091_Set_Nc;
	Dlg2 dlgForm=new Dlg2();
	
	dlgForm.m_CHK1=(card1.NCmode==OFF)?0:-1;
	dlgForm.m_CHK2=(card1.NCmode!=OFF)?0:-1;

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)
	{
		if (dlgForm.m_CHK1==0)
		{
			card1.NCmode=OFF;
			m_NC.SetWindowText(_T("OFF"));
		}
		else
		{
			card1.NCmode=ON;
			m_NC.SetWindowText(_T("ON"));
		}

		i8091_SET_NC(CARD1, card1.NCmode);	
	}	
}

void CDemoDlg::OnBtnIsXStop() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Is X Stop"));	
	m_ListMsg.ResetContent();
	if (i8091_IS_X_STOP(CARD1)==YES) 
		m_ListMsg.AddString(_T("YES"));
	else
		m_ListMsg.AddString(_T("NO"));
	
}

void CDemoDlg::OnBtnIsYStop() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Is Y Stop"));	
	m_ListMsg.ResetContent();
	if (i8091_IS_Y_STOP(CARD1)==YES) 
		m_ListMsg.AddString(_T("YES"));
	else
		m_ListMsg.AddString(_T("NO"));	
}

void CDemoDlg::OnBtnLimitX() 
{
	// TODO: Add your control notification handler code here
	TCHAR TempStr[40];
	unsigned char temp;
	m_EditCmd.SetWindowText(_T("i8091 Limit X"));
	m_ListMsg.ResetContent();

	temp=i8091_LIMIT_X(CARD1);
	swprintf(TempStr,_T("/ORG1=%d"),(temp&0x01));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/LS11=%d"),((temp&0x02)>>1));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("xxx=%d"),((temp&0x04)>>2));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("xxx=%d"),((temp&0x08)>>3));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/LS14=%d"),((temp&0x10)>>4));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/FFEF=%d"),((temp&0x20)>>5));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/FFFF=%d"),((temp&0x40)>>6));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/EMG=%d"),((temp&0x40)>>7));
	m_ListMsg.AddString(TempStr);
}

void CDemoDlg::OnBtnLimitY() 
{
	// TODO: Add your control notification handler code here
	TCHAR TempStr[40];
	unsigned char temp;
	m_EditCmd.SetWindowText(_T("i8091 Limit Y"));
	m_ListMsg.ResetContent();

	temp=i8091_LIMIT_Y(CARD1);
	swprintf(TempStr,_T("/ORG2=%d"),(temp&0x01));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/LS21=%d"),((temp&0x02)>>1));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("xxx=%d"),((temp&0x04)>>2));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("xxx=%d"),((temp&0x08)>>3));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/LS24=%d"),((temp&0x10)>>4));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("CPUS=%d"),((temp&0x20)>>5));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/XSTOP=%d"),((temp&0x40)>>6));
	m_ListMsg.AddString(TempStr);
	swprintf(TempStr,_T("/YSTOP=%d"),((temp&0x40)>>7));
	m_ListMsg.AddString(TempStr);	
}

void CDemoDlg::OnBtnExit() 
{
	// TODO: Add your control notification handler code here
		
}

void CDemoDlg::OnBtnStopX() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Stop X"));
	i8091_STOP_X(CARD1);		
}

void CDemoDlg::OnBtnStopY() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Stop Y"));
	i8091_STOP_Y(CARD1);	
}

void CDemoDlg::OnBtnStopAll() 
{
	// TODO: Add your control notification handler code here
	m_EditCmd.SetWindowText(_T("i8091 Stop All"));
	i8091_STOP_ALL(CARD1);	
}

void CDemoDlg::OnBtnLspOrg() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0;
	m_EditCmd.SetWindowText(_T("i8091 Lsp Org"));
	CmdNo=i8091_Lsp_Org;
	Dlg2 dlgForm=new Dlg2();

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		if (axis!=0)
			i8091_LSP_ORG(CARD1, CCW, axis);
	}
}

void CDemoDlg::OnBtnHspOrg() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0;
	m_EditCmd.SetWindowText(_T("i8091 Hsp Org"));
	CmdNo=i8091_Hsp_Org;
	Dlg2 dlgForm=new Dlg2();

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		if (axis!=0)
			i8091_HSP_ORG(CARD1, CCW, axis);
	}	
}

void CDemoDlg::OnBtnLspPulseMove() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0;
	long		pulse=0;
	m_EditCmd.SetWindowText(_T("i8091 Lsp Pulse Move"));
	CmdNo=i8091_Lsp_Pulse_Move;
	Dlg2 dlgForm=new Dlg2();
	dlgForm.m_Edit1=0;

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		pulse=dlgForm.m_Edit1;
		if (axis!=0)
			i8091_LSP_PULSE_MOVE(CARD1, axis, pulse);
	}	
}

void CDemoDlg::OnBtnHspPulseMove() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0;
	long		pulse=0;
	m_EditCmd.SetWindowText(_T("i8091 Hsp Pulse Move"));
	CmdNo=i8091_Hsp_Pulse_Move;
	Dlg2 dlgForm=new Dlg2();
	dlgForm.m_Edit1=0;

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		pulse=dlgForm.m_Edit1;
		if (axis!=0)
			i8091_HSP_PULSE_MOVE(CARD1, axis, pulse);
	}	
}

void CDemoDlg::OnBtnLspMove() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0,dir=0;
	m_EditCmd.SetWindowText(_T("i8091 Lsp Move"));
	CmdNo=i8091_Lsp_Move;
	Dlg2 dlgForm=new Dlg2();
	dlgForm.m_CHK3=0;

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		if (dlgForm.m_CHK3==0)
			dir=CW;
		else
			dir=CCW;
		if (axis!=0)
			i8091_LSP_MOVE(CARD1, dir, axis);
	}		
}

void CDemoDlg::OnBtnHspMove() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0,dir=0;
	m_EditCmd.SetWindowText(_T("i8091 Hsp Move"));
	CmdNo=i8091_Hsp_Move;
	Dlg2 dlgForm=new Dlg2();
	dlgForm.m_CHK3=0;

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		if (dlgForm.m_CHK3==0)
			dir=CW;
		else
			dir=CCW;
		if (axis!=0)
			i8091_HSP_MOVE(CARD1, dir, axis);
	}	
}

void CDemoDlg::OnBtnCspMove() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0,dir=0;
	int speed=0;
	m_EditCmd.SetWindowText(_T("i8091 Csp Move"));
	CmdNo=i8091_Csp_Move;
	Dlg2 dlgForm=new Dlg2();
	dlgForm.m_CHK3=0;
	dlgForm.m_Edit1=0;
	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		if (dlgForm.m_CHK3==0)
			dir=CW;
		else
			dir=CCW;
		speed=dlgForm.m_Edit1;
		if ((axis!=0)&&(speed>=0)&&(speed<=2040))
			i8091_CSP_MOVE(CARD1, dir, axis, speed);
	}		
}

void CDemoDlg::OnBtnSlowStop() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0;
	m_EditCmd.SetWindowText(_T("i8091 Slow Stop"));
	CmdNo=i8091_Slow_Stop;
	Dlg2 dlgForm=new Dlg2();

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		if (axis!=0)
			i8091_SLOW_STOP(CARD1, axis);
	}	
}

void CDemoDlg::OnBtnSlowDown() 
{
	// TODO: Add your control notification handler code here
	unsigned char axis=0;
	m_EditCmd.SetWindowText(_T("i8091 Slow Down"));
	CmdNo=i8091_Slow_Down;
	Dlg2 dlgForm=new Dlg2();

	int nResponse=dlgForm.DoModal();

	if (nResponse == IDOK)	
	{
		if (dlgForm.m_CHK1==0)
			axis=X_axis;
		if (dlgForm.m_CHK2==0)
			axis=Y_axis;
		if (axis!=0)
			i8091_SLOW_DOWN(CARD1, axis);
	}		
}

void CDemoDlg::OnBtnIntpPulse() 
{
	// TODO: Add your control notification handler code here
	int xpulse=0,ypulse=0;
	m_EditCmd.SetWindowText(_T("i8091 Intp Pulse"));
	CmdNo=i8091_Intp_Pulse;
	Dlg3 dlgForm=new Dlg3();
	dlgForm.m_X=0;
	dlgForm.m_Y=0;
	int nResponse=dlgForm.DoModal();
	if (nResponse == IDOK)	
	{
		xpulse=dlgForm.m_X;
		ypulse=dlgForm.m_Y;
		if ((abs(xpulse)<=2047)&&(abs(ypulse)<=2047))
			i8091_INTP_PULSE(CARD1, xpulse, ypulse);
	}
}

void CDemoDlg::OnBtnIntpLine() 
{
	// TODO: Add your control notification handler code here
	long x=0,y=0;
	m_EditCmd.SetWindowText(_T("i8091 Intp Line"));
	CmdNo=i8091_Intp_Line;
	Dlg3 dlgForm=new Dlg3();
	dlgForm.m_X=0;
	dlgForm.m_Y=0;
	int nResponse=dlgForm.DoModal();
	if (nResponse == IDOK)	
	{
		x=dlgForm.m_X;
		y=dlgForm.m_Y;
		if ((abs(x)<=524287)&&(abs(y)<=524287))
			i8091_INTP_LINE(CARD1, x, y);
	}	
}

void CDemoDlg::OnBtnIntpLine02() 
{
	// TODO: Add your control notification handler code here
	unsigned int speed;
	long x=0,y=0;
	m_EditCmd.SetWindowText(_T("i8091_Intp_Line02"));
	CmdNo=i8091_Intp_Line02;
	Dlg3 dlgForm=new Dlg3();
	dlgForm.m_X=0;
	dlgForm.m_Y=0;
	dlgForm.m_Speed=card1.LSP;
	int nResponse=dlgForm.DoModal();
	if (nResponse == IDOK)	
	{
		x=dlgForm.m_X;
		y=dlgForm.m_Y;
		speed=dlgForm.m_Speed;
		if ((speed>=card1.LSP)&&(speed<=2040))
		{
			i8091_INTP_LINE02(CARD1, x, y, speed, 0);
			do{
			} while (i8091_INTP_STOP()!=READY);
		}
	}	
}

void CDemoDlg::OnBtnCircle02() 
{
	// TODO: Add your control notification handler code here
	unsigned int speed;
	unsigned char dir;
	long x=0,y=0;
	m_EditCmd.SetWindowText(_T("i8091_Intp_Circle02"));
	CmdNo=i8091_Intp_Circle02;
	Dlg3 dlgForm=new Dlg3();
	dlgForm.m_X=0;
	dlgForm.m_Y=0;
	dlgForm.m_Speed=card1.LSP;
	dlgForm.m_CHK1=0;
	int nResponse=dlgForm.DoModal();
	if (nResponse == IDOK)	
	{
		x=dlgForm.m_X;
		y=dlgForm.m_Y;
		speed=dlgForm.m_Speed;
		if (dlgForm.m_CHK1==0)
			dir=CW;
		else
			dir=CCW;
		if ((speed>=card1.LSP)&&(speed<=2040))
		{
			i8091_INTP_CIRCLE02(CARD1, x, y, dir, speed, 0);
			do{
			} while (i8091_INTP_STOP()!=READY);
		}
	}		
}

void CDemoDlg::OnBtnArc02() 
{
	// TODO: Add your control notification handler code here
	unsigned int speed;
	unsigned char dir;
	long x=0,y=0,R=0;
	m_EditCmd.SetWindowText(_T("i8091_Intp_Arc02"));
	CmdNo=i8091_Intp_Arc02;
	Dlg3 dlgForm=new Dlg3();
	dlgForm.m_X=0;
	dlgForm.m_Y=0;
	dlgForm.m_R=0;
	dlgForm.m_Speed=card1.LSP;
	dlgForm.m_CHK1=0;
	int nResponse=dlgForm.DoModal();
	if (nResponse == IDOK)	
	{
		x=dlgForm.m_X;
		y=dlgForm.m_Y;
		R=dlgForm.m_R;
		speed=dlgForm.m_Speed;
		if (dlgForm.m_CHK1==0)
			dir=CW;
		else
			dir=CCW;
		if ((speed>=card1.LSP)&&(speed<=2040))
		{
			i8091_INTP_ARC02(CARD1, x, y, R, dir, speed, 0);
			do{
			} while (i8091_INTP_STOP()!=READY);
		}
	}	
}

void CDemoDlg::OnSelchangeCombo1() 
{
	// TODO: Add your control notification handler code here
	int i;
	char string1[20];
	unsigned char ModuleID;

	i=m_Slot.GetCurSel()+1;
	ModuleID=GetNameOfModule(i,string1);
	if (ModuleID==91)
	{
		slot91=i;
		card1.slot=slot91;

		i8091_REGISTRATION(CARD1, card1.slot);
		i8091_RESET_SYSTEM(CARD1);
		i8091_SET_VAR(CARD1, card1.DDA, card1.AD, card1.LSP, card1.HSP);
		i8091_SET_DEFDIR(CARD1, card1.xdir, card1.ydir);
		i8091_SET_MODE(CARD1, card1.xmode, card1.ymode);
		i8091_SET_SERVO_ON(CARD1, card1.xson, card1.yson);
		i8091_SET_NC(CARD1, card1.NCmode);
		Sleep(100);

		m_Btn1.EnableWindow(true);
		m_Btn2.EnableWindow(true);
		m_Btn3.EnableWindow(true);
		m_Btn4.EnableWindow(true);
		m_Btn5.EnableWindow(true);
		m_Btn6.EnableWindow(true);
		m_Btn7.EnableWindow(true);
		m_Btn8.EnableWindow(true);
		m_Btn9.EnableWindow(true);
		m_Btn10.EnableWindow(true);
		m_Btn11.EnableWindow(true);
		m_Btn12.EnableWindow(true);
		m_Btn13.EnableWindow(true);
		m_Btn14.EnableWindow(true);
		m_Btn15.EnableWindow(true);
		m_Btn16.EnableWindow(true);
		m_Btn17.EnableWindow(true);
		m_Btn18.EnableWindow(true);
		m_Btn19.EnableWindow(true);
		m_Btn20.EnableWindow(true);
		m_Btn21.EnableWindow(true);
		m_Btn22.EnableWindow(true);
		m_Btn23.EnableWindow(true);
		m_Btn24.EnableWindow(true);
		m_Btn25.EnableWindow(true);
		m_Btn26.EnableWindow(true);
		m_Btn27.EnableWindow(true);
		m_Btn28.EnableWindow(true);
	}
	else
	{
		m_Btn1.EnableWindow(false);
		m_Btn2.EnableWindow(false);
		m_Btn3.EnableWindow(false);
		m_Btn4.EnableWindow(false);
		m_Btn5.EnableWindow(false);
		m_Btn6.EnableWindow(false);
		m_Btn7.EnableWindow(false);
		m_Btn8.EnableWindow(false);
		m_Btn9.EnableWindow(false);
		m_Btn10.EnableWindow(false);
		m_Btn11.EnableWindow(false);
		m_Btn12.EnableWindow(false);
		m_Btn13.EnableWindow(false);
		m_Btn14.EnableWindow(false);
		m_Btn15.EnableWindow(false);
		m_Btn16.EnableWindow(false);
		m_Btn17.EnableWindow(false);
		m_Btn18.EnableWindow(false);
		m_Btn19.EnableWindow(false);
		m_Btn20.EnableWindow(false);
		m_Btn21.EnableWindow(false);
		m_Btn22.EnableWindow(false);
		m_Btn23.EnableWindow(false);
		m_Btn24.EnableWindow(false);
		m_Btn25.EnableWindow(false);
		m_Btn26.EnableWindow(false);
		m_Btn27.EnableWindow(false);
		m_Btn28.EnableWindow(false);
	}
}



BOOL CDemoDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_KEYDOWN)
	{
		pMsg->message = WM_HOTKEY;
	}	
	return CDialog::PreTranslateMessage(pMsg);
}
