// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"
#include "WinconSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
int slot90,find90;
int timerOn=0;
/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_BUTTON2, m_BtnReset);
	DDX_Control(pDX, IDC_BUTTON1, m_BtnRead);
	DDX_Control(pDX, IDC_STATIC1, m_Msg);
	DDX_Control(pDX, IDC_COMBO1, m_ComboSlot);
	DDX_Control(pDX, IDC_EDIT3, m_Z);
	DDX_Control(pDX, IDC_EDIT2, m_Y);
	DDX_Control(pDX, IDC_EDIT1, m_X);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON1, OnBtnReadEncoder)
	ON_BN_CLICKED(IDC_BUTTON2, OnBtnReset)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeComboSlot)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	TCHAR MsgText[40];
	if (find90==1)
	{
		swprintf(MsgText,_T("I-8090 Card in %d Slot"),slot90);
		m_Msg.SetWindowText(MsgText);
		m_BtnRead.EnableWindow(true);
		m_BtnReset.EnableWindow(true);
	}
	else
	{
		swprintf(MsgText,_T("I-8090 Card all slot not found"));
		m_Msg.SetWindowText(MsgText);
		m_BtnRead.EnableWindow(false);
		m_BtnReset.EnableWindow(false);
	}
	m_ComboSlot.SetCurSel(slot90-1);
	//swprintf(MsgText,_T("%d"),slot90);
	//m_AOSlot.SetWindowText(MsgText);
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	long x,y,z;
	TCHAR Msg[40];
	if (find90==1)
	{
		i8090_ENCODER32_ISR(CARD1);
		x=i8090_GET_ENCODER32(CARD1, X_axis);
		swprintf(Msg,_T("%d"),x);
		m_X.SetWindowText(Msg);

		y=i8090_GET_ENCODER32(CARD1, Y_axis);
		swprintf(Msg,_T("%d"),y);
		m_Y.SetWindowText(Msg);

		z=i8090_GET_ENCODER32(CARD1, Z_axis);
		swprintf(Msg,_T("%d"),z);
		m_Z.SetWindowText(Msg);
	}
	CDialog::OnTimer(nIDEvent);
}

void CDemoDlg::OnBtnReadEncoder() 
{
	// TODO: Add your control notification handler code here
	if (timerOn==1)
	{
		timerOn=0;
		KillTimer(100);
		m_BtnRead.SetWindowText(_T("Read Encoder Enable"));
	}
	else
	{
		timerOn=1;
		SetTimer(100,5,NULL);
		m_BtnRead.SetWindowText(_T("Read Encoder Disable"));
	}
}

void CDemoDlg::OnBtnReset() 
{
	// TODO: Add your control notification handler code here
	if (find90==1)
	{
		i8090_RESET_ENCODER32(CARD1,X_axis);	
		i8090_RESET_ENCODER32(CARD1,Y_axis);
		i8090_RESET_ENCODER32(CARD1,Z_axis);
	}
}

void CDemoDlg::OnSelchangeComboSlot() 
{
	// TODO: Add your control notification handler code here
	CString m_SelSlot;
	int temp;
	TCHAR MsgText[40];
	char strTemp[20];

	m_ComboSlot.GetLBText(m_ComboSlot.GetCurSel(), m_SelSlot);
	temp=_ttoi(m_SelSlot);
	if (GetNameOfModule(temp, strTemp)==90)
	{
		slot90=temp;
		swprintf(MsgText,_T("I-8090 Card in %d Slot"),slot90);
		m_Msg.SetWindowText(MsgText);
		swprintf(MsgText,_T("%d"),slot90);
		m_ComboSlot.SetWindowText(MsgText);
		m_BtnRead.EnableWindow(true);
		m_BtnReset.EnableWindow(true);
	}
	else
	{
		swprintf(MsgText,_T("I-8090 Card %d Slot not found"),temp);
		m_Msg.SetWindowText(MsgText);
		m_BtnRead.EnableWindow(false);
		m_BtnReset.EnableWindow(false);
	}	
}


BOOL CDemoDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_KEYDOWN)
	{
		pMsg->message = WM_HOTKEY;
	}	
	return CDialog::PreTranslateMessage(pMsg);
}
