// Dlg3.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "Dlg3.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int CmdNo;
/////////////////////////////////////////////////////////////////////////////
// Dlg3 dialog


Dlg3::Dlg3(CWnd* pParent /*=NULL*/)
	: CDialog(Dlg3::IDD, pParent)
{
	//{{AFX_DATA_INIT(Dlg3)
	m_X = 0;
	m_Y = 0;
	m_R = 0;
	m_Speed = 0;
	m_CHK1 = -1;
	m_CHK2 = -1;
	//}}AFX_DATA_INIT
}


void Dlg3::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Dlg3)
	DDX_Control(pDX, IDC_EDIT2, m_CEdit2);
	DDX_Control(pDX, IDC_EDIT1, m_CEdit1);
	DDX_Control(pDX, IDC_STATIC5, m_Label5);
	DDX_Control(pDX, IDC_STATIC4, m_Label4);
	DDX_Control(pDX, IDC_STATIC3, m_Label3);
	DDX_Control(pDX, IDC_STATIC2, m_Label2);
	DDX_Control(pDX, IDC_STATIC1, m_Label1);
	DDX_Control(pDX, IDC_RADIO2, m_Radio2);
	DDX_Control(pDX, IDC_RADIO1, m_Radio1);
	DDX_Control(pDX, IDC_EDIT4, m_CEdit4);
	DDX_Control(pDX, IDC_EDIT3, m_CEdit3);
	DDX_Text(pDX, IDC_EDIT1, m_X);
	DDX_Text(pDX, IDC_EDIT2, m_Y);
	DDX_Text(pDX, IDC_EDIT3, m_R);
	DDX_Text(pDX, IDC_EDIT4, m_Speed);
	DDX_Radio(pDX, IDC_RADIO1, m_CHK1);
	DDX_Radio(pDX, IDC_RADIO2, m_CHK2);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Dlg3, CDialog)
	//{{AFX_MSG_MAP(Dlg3)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Dlg3 message handlers

BOOL Dlg3::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	switch (CmdNo)
	{
		case i8091_Intp_Pulse:
			break;
		case i8091_Intp_Line:
			SetWindowText(_T("i8091_Intp_Line"));
			m_Label1.SetWindowText(_T("X pulse number(+- 524287)"));
			m_Label2.SetWindowText(_T("Y pulse number(+- 524287)"));
			break;
		case i8091_Intp_Line02:
			SetWindowText(_T("i8091_Intp_Line02"));
			m_Label1.SetWindowText(_T("X pulse number(+- 2^31-1)"));
			m_Label2.SetWindowText(_T("Y pulse number(+- 2^31-1)"));
			m_Label4.ShowWindow(1);
			m_CEdit4.ShowWindow(1);
			break;
		case i8091_Intp_Circle02:
			SetWindowText(_T("i8091_Intp_Circle02"));
			m_Label1.SetWindowText(_T("Center point X"));
			m_Label2.SetWindowText(_T("Center point Y"));
			m_Label4.ShowWindow(1);
			m_CEdit4.ShowWindow(1);
			m_Label5.ShowWindow(1);
			m_Radio1.ShowWindow(1);
			m_Radio2.ShowWindow(1);
			break;
		case i8091_Intp_Arc02:
			SetWindowText(_T("i8091_Intp_Arc02"));
			m_Label1.SetWindowText(_T("Center point X"));
			m_Label2.SetWindowText(_T("Center point Y"));
			m_Label3.ShowWindow(1);
			m_CEdit3.ShowWindow(1);
			m_Label4.ShowWindow(1);
			m_CEdit4.ShowWindow(1);
			m_Label5.ShowWindow(1);
			m_Radio1.ShowWindow(1);
			m_Radio2.ShowWindow(1);
			break;
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Dlg3::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	m_Radio2.SetCheck(0);	
}

void Dlg3::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	m_Radio1.SetCheck(0);	
}
