// I8080Dlg.h : header file
//

#if !defined(AFX_I8080DLG_H__78BABF55_4FC9_4487_9A77_F34983BD49F4__INCLUDED_)
#define AFX_I8080DLG_H__78BABF55_4FC9_4487_9A77_F34983BD49F4__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CI8080Dlg dialog

class CI8080Dlg : public CDialog
{
// Construction
public:
	CI8080Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CI8080Dlg)
	enum { IDD = IDD_I8080_DIALOG };
	CButton	m_DiXorBtn;
	CButton	m_RegisterBtn;
	CButton	m_ReadFreqConfigBtn;
	CButton	m_SetFreqConfigBtn;
	CButton	m_SetChannelModeBtn;
	CEdit	m_DiXor;
	CEdit	m_Register;
	CButton	m_ClearB3Btn;
	CButton	m_ClearA3Btn;
	CButton	m_ClearB2Btn;
	CButton	m_ClearA2Btn;
	CButton	m_ClearB1Btn;
	CButton	m_ClearA1Btn;
	CButton	m_ClearB0Btn;
	CButton	m_ClearA0Btn;
	CEdit	m_MB3;
	CEdit	m_MA3;
	CEdit	m_MB2;
	CEdit	m_MA2;
	CEdit	m_MB1;
	CEdit	m_MA1;
	CEdit	m_MB0;
	CEdit	m_MA0;
	CComboBox	m_ComboChannel;
	CButton	m_AutoScanBtn;
	CButton	m_ReadBtn;
	CEdit	m_VA0;
	CEdit	m_OB2;
	CEdit	m_OA2;
	CEdit	m_OB3;
	CEdit	m_OB1;
	CEdit	m_OA1;
	CEdit	m_OA3;
	CEdit	m_OB0;
	CEdit	m_OA0;
	CEdit	m_VB2;
	CEdit	m_VA2;
	CEdit	m_VB3;
	CEdit	m_VB1;
	CEdit	m_VA1;
	CEdit	m_VA3;
	CEdit	m_VB0;
	CEdit	m_Slot;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CI8080Dlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CI8080Dlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSetModeBtn();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnClearA0();
	afx_msg void OnClearB0();
	afx_msg void OnClearA1();
	afx_msg void OnClearB1();
	afx_msg void OnClearA2();
	afx_msg void OnClearB2();
	afx_msg void OnClearA3();
	afx_msg void OnClearB3();
	afx_msg void OnReadBtn();
	afx_msg void OnAutoScanBtn();
	afx_msg void OnSelchangeComboChannel();
	afx_msg void OnReadRegisterBtn();
	afx_msg void OnReadDiXorBtn();
	afx_msg void OnReadFreqConfigBtn();
	afx_msg void OnSetFreqConfigBtn();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_I8080DLG_H__78BABF55_4FC9_4487_9A77_F34983BD49F4__INCLUDED_)
