// lSetDlg.cpp : implementation file
//

#include "stdafx.h"
#include "I8080.h"
#include "lSetDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int slot;
extern int channel;
extern short mode[8];
extern short tempmode;
extern short tempFreq;
extern bool tempSelect;
extern bool tempLowAlarm;
extern bool tempHighAlarm;
extern bool tempXor;

/////////////////////////////////////////////////////////////////////////////
// ClSetDlg dialog


ClSetDlg::ClSetDlg(CWnd* pParent /*=NULL*/)
	: CDialog(ClSetDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(ClSetDlg)
	//}}AFX_DATA_INIT
}


void ClSetDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ClSetDlg)
	DDX_Control(pDX, IDC_CHECK4, m_Xor);
	DDX_Control(pDX, IDC_CHECK3, m_Select);
	DDX_Control(pDX, IDC_CHECK2, m_HighAlarm);
	DDX_Control(pDX, IDC_CHECK1, m_LowAlarm);
	DDX_Control(pDX, IDC_EDIT4, m_Channel);
	DDX_Control(pDX, IDC_COMBO3, m_ComboFreq);
	DDX_Control(pDX, IDC_COMBO2, m_ComboMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(ClSetDlg, CDialog)
	//{{AFX_MSG_MAP(ClSetDlg)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeComboMode)
	ON_CBN_SELCHANGE(IDC_COMBO3, OnSelchangeComboFreq)
	ON_BN_CLICKED(IDC_CHECK1, OnCheckLowAlarm)
	ON_BN_CLICKED(IDC_CHECK2, OnCheckHighAlarm)
	ON_BN_CLICKED(IDC_CHECK3, OnCheckLowPass)
	ON_BN_CLICKED(IDC_CHECK4, OnCheckXor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ClSetDlg message handlers


BOOL ClSetDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	TCHAR temp[20];
	swprintf(temp,_T("%d"), channel);
	m_Channel.SetWindowText(temp);
	m_ComboMode.SetCurSel(tempmode&0x0003);
	if ((tempmode&0x03)==0x02)
	{
		m_ComboFreq.SetCurSel(((tempmode&0x000F)>>2));
	}
	else
	{
		tempFreq=0;
		m_ComboFreq.SetCurSel(0);
		m_ComboFreq.EnableWindow(FALSE);
	}
	m_LowAlarm.SetCheck((tempLowAlarm)?1:0);
	m_HighAlarm.SetCheck((tempHighAlarm)?1:0);
	m_Select.SetCheck((tempSelect)?1:0);
	m_Xor.SetCheck((tempXor)?1:0);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void ClSetDlg::OnSelchangeComboMode() 
{
	// TODO: Add your control notification handler code here
	tempmode=m_ComboMode.GetCurSel();
	if (tempmode==2)
	{
		m_ComboFreq.EnableWindow(TRUE);
	}
	else
	{
		m_ComboFreq.SetCurSel(0);
		m_ComboFreq.EnableWindow(FALSE);
		tempFreq=0;
	}
}



void ClSetDlg::OnSelchangeComboFreq() 
{
	// TODO: Add your control notification handler code here
	tempFreq=m_ComboFreq.GetCurSel();	
}

void ClSetDlg::OnCheckLowAlarm() 
{
	// TODO: Add your control notification handler code here
	if (m_LowAlarm.GetCheck())
		tempLowAlarm=true;
	else
		tempLowAlarm=false;
}

void ClSetDlg::OnCheckHighAlarm() 
{
	// TODO: Add your control notification handler code here
	if (m_HighAlarm.GetCheck())
		tempHighAlarm=true;
	else
		tempHighAlarm=false;	
}

void ClSetDlg::OnCheckLowPass() 
{
	// TODO: Add your control notification handler code here
	if (m_Select.GetCheck())
		tempSelect=true;
	else
		tempSelect=false;	
}

void ClSetDlg::OnCheckXor() 
{
	// TODO: Add your control notification handler code here
	if (m_Xor.GetCheck())
		tempXor=true;
	else
		tempXor=false;	
}
