// UpCount1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "UpCount1.h"
#include "UpCount1Dlg.h"
#include "WinconSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int slot=1;
bool AutoRead=false;
int chA0=0;
int chB3=7;
/////////////////////////////////////////////////////////////////////////////
// CUpCount1Dlg dialog

CUpCount1Dlg::CUpCount1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUpCount1Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUpCount1Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUpCount1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUpCount1Dlg)
	DDX_Control(pDX, IDC_EDIT16, m_B3);
	DDX_Control(pDX, IDC_EDIT15, m_B2);
	DDX_Control(pDX, IDC_EDIT14, m_B1);
	DDX_Control(pDX, IDC_EDIT13, m_B0);
	DDX_Control(pDX, IDC_EDIT12, m_A3);
	DDX_Control(pDX, IDC_EDIT11, m_A2);
	DDX_Control(pDX, IDC_EDIT10, m_A1);
	DDX_Control(pDX, IDC_EDIT9, m_A0);
	DDX_Control(pDX, IDC_EDIT8, m_SetMode);
	DDX_Control(pDX, IDC_EDIT7, m_Edit7);
	DDX_Control(pDX, IDC_EDIT6, m_Edit6);
	DDX_Control(pDX, IDC_EDIT5, m_OB3);
	DDX_Control(pDX, IDC_EDIT4, m_VB3);
	DDX_Control(pDX, IDC_BUTTON1, m_AutoReadBtn);
	DDX_Control(pDX, IDC_BUTTON4, m_ReadBtn);
	DDX_Control(pDX, IDC_EDIT3, m_Overflow);
	DDX_Control(pDX, IDC_EDIT2, m_CounterValue);
	DDX_Control(pDX, IDC_EDIT1, m_Slot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUpCount1Dlg, CDialog)
	//{{AFX_MSG_MAP(CUpCount1Dlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON4, OnReadCounter)
	ON_BN_CLICKED(IDC_BUTTON1, OnAutoReadBtn)
	ON_BN_CLICKED(IDC_BUTTON2, OnClearA0)
	ON_BN_CLICKED(IDC_BUTTON3, OnClearB3)
	ON_BN_CLICKED(IDC_BUTTON5, OnRegisterBtn)
	ON_BN_CLICKED(IDC_BUTTON6, OnReadDiXorBtn)
	ON_BN_CLICKED(IDC_BUTTON7, OnSetModeBtn)
	ON_BN_CLICKED(IDC_BUTTON8, OnReadModeBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUpCount1Dlg message handlers

BOOL CUpCount1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	int i;
	TCHAR temp[20];
	int mode=0x03;

	swprintf(temp,_T("%d"), mode);

	m_SetMode.SetWindowText(temp);

	for(slot=1; slot<8; slot++)
	{
		i=i8080_InitDriver(slot);
		if (!i)
		{
			swprintf(temp, _T("%d"), slot);
			m_Slot.SetWindowText(temp);
			//Set8080ChannelMode(slot,chA0,0x03);
			//Set8080ChannelMode(slot,chB3,0x03);
			SetTimer(100, 3, NULL);   // scan every 3 ms
			break;
		}
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CUpCount1Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	unsigned long cnt32U;
	unsigned short overflow;
	TCHAR temp[80];

	switch (nIDEvent)
	{
		case 100:
			i8080_AutoScan();
			break;
		case 101:
			i8080_ReadCntUp(slot,0,&cnt32U,&overflow);  // Read i-8080 CountUp Value
			swprintf(temp,_T("%u"),cnt32U);
			m_CounterValue.SetWindowText(temp);   // Show CounterValue to CounterValue Box
			swprintf(temp,_T("%d"),overflow);
			m_Overflow.SetWindowText(temp);	      // Show Overflow Value to Overflow Box

			i8080_ReadCntUp(slot,7,&cnt32U,&overflow);  // Read i-8080 CountUp Value
			swprintf(temp,_T("%u"),cnt32U);
			m_VB3.SetWindowText(temp);   // Show CounterValue to CounterValue Box
			swprintf(temp,_T("%d"),overflow);
			m_OB3.SetWindowText(temp);	
			break;
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CUpCount1Dlg::OnReadCounter() 
{
	// TODO: Add your control notification handler code here
	unsigned long cnt32U;
	unsigned short overflow;
	TCHAR temp[80];

	i8080_ReadCntUp(slot,chA0,&cnt32U,&overflow);  // Read i-8080 CountUp Value Channel A0

	swprintf(temp,_T("%u"),cnt32U);    
	m_CounterValue.SetWindowText(temp);   // Show CounterValue to CounterValue Box

	swprintf(temp,_T("%d"),overflow);
	m_Overflow.SetWindowText(temp);	   // Show Overflow Value to Overflow Box

	i8080_ReadCntUp(slot,chB3,&cnt32U,&overflow);  // Read i-8080 CountUp Value Channel B3
	swprintf(temp,_T("%u"),cnt32U);
	m_VB3.SetWindowText(temp);   // Show CounterValue to CounterValue Box
	swprintf(temp,_T("%d"),overflow);
	m_OB3.SetWindowText(temp);
}

void CUpCount1Dlg::OnAutoReadBtn() 
{
	// TODO: Add your control notification handler code here
	if (!AutoRead)
	{
		SetTimer(101,100,NULL);	
		m_AutoReadBtn.SetWindowText(_T("Disable Auto Read"));
		AutoRead=true;
		m_ReadBtn.EnableWindow(false);		
	}
	else
	{
		KillTimer(101);
		m_AutoReadBtn.SetWindowText(_T("Enable Auto Read"));
		AutoRead=false;
		m_ReadBtn.EnableWindow(true);
	}			
}

void CUpCount1Dlg::OnClearA0() 
{
	// TODO: Add your control notification handler code here
	i8080_ClrCnt(slot,chA0);  // clear  counter A0	
}

void CUpCount1Dlg::OnClearB3() 
{
	// TODO: Add your control notification handler code here
	i8080_ClrCnt(slot,chB3);	// clear  counter B3	
}

void CUpCount1Dlg::OnRegisterBtn() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[80];
	short j;
	i8080_ReadXorRegister(slot,&j);
	swprintf(temp,_T("%2X"),j);
	m_Edit6.SetWindowText(temp);
}

void CUpCount1Dlg::OnReadDiXorBtn() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[80];
	short j;
	i8080_ReadDiXor(slot,&j);
	swprintf(temp,_T("%2X"),j);
	m_Edit7.SetWindowText(temp);	
}

void CUpCount1Dlg::OnSetModeBtn() 
{
	// TODO: Add your control notification handler code here
	int mode=3;
	TCHAR temp[10];

	m_SetMode.GetWindowText(temp,10);
	mode=_ttoi(temp);

	i8080_SetChannelMode(slot,chA0,mode);// Channel_A0, Up Counting mode=0x03
				       // Disable Low Pass Filter
	i8080_SetChannelMode(slot,chB3,mode);// Channel_B3, Up Counting mode=0x03
				       // Disable Low Pass Filter
				       // Xor=0, isolated + active_Low
}

void CUpCount1Dlg::OnReadModeBtn() 
{
	// TODO: Add your control notification handler code here
	int i;
	short mode=3;
	short V[8];
	TCHAR temp[20];
	for (i=0; i<8; i++)
	{
		i8080_ReadChannelMode(slot,i,&mode);
		V[i]=mode;
	}

	swprintf(temp,_T("%02X"),V[0]);
	m_A0.SetWindowText(temp);
	
	swprintf(temp,_T("%02X"),V[1]);
	m_A1.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[2]);
	m_A2.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[3]);
	m_A3.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[4]);
	m_B0.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[5]);
	m_B1.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[6]);
	m_B2.SetWindowText(temp);

	swprintf(temp,_T("%02X"),V[7]);
	m_B3.SetWindowText(temp);
}
