﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _8k_di
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            cmbSlot.SelectedIndex = 1;
        }

        private void btnDIRead_Click(object sender, EventArgs e)
        {
            uint intbufer = 0;
            bool iRet;

            //Get int state Slot data
            Int32 intSlot = Convert.ToInt32(cmbSlot.Text);

            //8k module have not using com port to write or read data and use pac_ReadDI read data
            iRet = PACNET.PAC_IO.ReadDI((IntPtr)null, intSlot, Convert.ToInt32(txtDIChannel.Text), ref intbufer);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
            else
            {
                txtDIValue.Text = intbufer.ToString("x");
            }           
        }
    }
}