﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _7k_DI_latch
{
    public partial class Form1 : Form
    {
        IntPtr hPort;
		uint DiValue = 0;
		uint HighValue = 0;
		uint LowValue = 0;
		//byte byteOnoff = 0;
        public Form1()
        {
            InitializeComponent();
            cmbComPort.SelectedIndex = 0;
        }

       /* private void btnOpenCom_Click(object sender, EventArgs e)
        {
            //Open com port
            hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text);

            if (hPort == (IntPtr)(-1))
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }
            else
            {
                btnCloseCom.Enabled = true;
                btnOpenCom.Enabled = false;
            }
        }

        private void btnCloseCom_Click(object sender, EventArgs e)
        {
            //Close com port
            PACNET.UART.Close(hPort);
            btnOpenCom.Enabled = true;
            btnCloseCom.Enabled = false;
        }*/

		private void btnOn_Click_1(object sender, EventArgs e)
		{
			int intChannel = int.Parse(txtTotalChannel.Text);
			bool iRet;

			//Open com port
			hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text);

			if (hPort == (IntPtr)(-1))
			{
				uint ec = PACNET.ErrHandling.GetLastError();
				MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
			}

			//Read module data
			
			iRet = PACNET.PAC_IO.ReadDI(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), Convert.ToInt16(txtTotalChannel.Text), ref DiValue);

			if (!iRet)
			{
				uint ec = PACNET.ErrHandling.GetLastError();
				MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
			}
			txtReadDIValue.Text = DiValue.ToString();
			//////////////////////////////////////

			//Read DI High latch Data
			HighValue = 0;
			iRet = PACNET.PAC_IO.ReadDILatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intChannel, 1, ref HighValue);

			if (!iRet)
			{
				uint ec = PACNET.ErrHandling.GetLastError();
				MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
			}

			txtHighValue.Text = HighValue.ToString();

			//Read DI Low latch Data
			LowValue = 0;
			iRet = PACNET.PAC_IO.ReadDILatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)), intChannel, 0, ref LowValue);

			if (!iRet)
			{
				uint ec = PACNET.ErrHandling.GetLastError();
				MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
			}

			txtLowValue.Text = LowValue.ToString();
			
			//close com port
			PACNET.UART.Close(hPort);
		}	

		private void btnOff_Click(object sender, EventArgs e)
		{
			//Open com port
			hPort = PACNET.UART.Open("COM" + cmbComPort.Text + "," + txtBaudRate.Text);

			if (hPort == (IntPtr)(-1))
			{
				uint ec = PACNET.ErrHandling.GetLastError();
				MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
			}
			
			//Clear DI latch data
			bool iRet = PACNET.PAC_IO.ClearDILatch(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(Convert.ToInt32(txtAddress.Text)));

			if (!iRet)
			{
				uint ec = PACNET.ErrHandling.GetLastError();
				MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
			}

			//Close com port
			PACNET.UART.Close(hPort);

			txtReadDIValue.Text = "0";
			txtHighValue.Text = "0";
			txtLowValue.Text = "0";
		}
    }
}