﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace UART
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            tbConnStr.Text = "COM2,115200,8,N,1";
        }

        private void button1_Click(object sender, EventArgs e)  //send and receive
        {
            byte[] cmd = new byte[64];
            byte[] result = new byte[64];

            IntPtr h = PACNET.UART.Open(tbConnStr.Text);
            
            //the default timeout value for uart_SendCmd may be too short to receive.
            PACNET.UART.SetTimeOut(h, 1000, PACNET.UART.CTO_TIMEOUT_ALL);

            cmd = PACNET.MISC.AnsiString(tbSend.Text);

            bool iRet = PACNET.UART.SendCmdExt(h, cmd,64, result,64);            

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            } 

            tbReceive.Text = PACNET.MISC.WideString(result);

            PACNET.UART.Close(h);
        }        
    }
}