﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using Microsoft.Win32;
using System.Threading;

namespace USB_driver_uninstall
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        [DllImport("Coredll.Dll")]
        public extern static bool DeactivateDevice(IntPtr hDevice);

        [DllImport("coredll.dll", SetLastError = true)]
        private extern static IntPtr ActivateDevice(string lpszDevKey, Int32 dwClientInfo);

        private void Form1_Load(object sender, EventArgs e)
        {

        }
        public static int LoadDriver(string strKeyPath)
        {
            try
            {
                IntPtr handle = new IntPtr();
                handle = ActivateDevice(strKeyPath, 0);
                return handle.ToInt32();
            }
            catch (Exception ex)
            {

            }
            return 0;
        }
        public static int UninstallDriver(string strKeyPath)
        {
            int len;
            RegistryKey rkey = Registry.LocalMachine;
            RegistryKey rkey_sub2 = rkey.OpenSubKey("Drivers\\Active", true);
            string[] names2 = rkey_sub2.GetSubKeyNames();
            rkey_sub2.Close();
            len = names2.Length;

            IntPtr ptr = (IntPtr)null;
            while (len > 0)
            {
                RegistryKey key = rkey.OpenSubKey("Drivers\\Active\\" + names2[len - 1]);

                string str = (string)key.GetValue("Key");
                if (str != null)
                {
                    if (str.IndexOf(strKeyPath) != -1)
                    {
                        int value = (int)key.GetValue("Hnd");
                        ptr = (IntPtr)value;
                    }
                }
                key.Close();
                if (ptr != (IntPtr)null) { DeactivateDevice(ptr); break; }
                len--;
            }
            return 1;
        }


        private void button2_Click(object sender, EventArgs e)
        {
            UninstallDriver("OHCI");
            label1.Text = "Uninstall the USB driver.";
            label1.ForeColor = System.Drawing.Color.Red;
            Application.DoEvents();
            Thread.Sleep(1000);
            label1.Text = "The driver will be reinstall after 10 seconds.";
            label1.ForeColor = System.Drawing.Color.Black;
            Application.DoEvents();

            Thread.Sleep(10000);
            LoadDriver(@"\Drivers\BuiltOut\OHCI\");
            label1.Text = "Reinstall the USB driver.";
            label1.ForeColor = System.Drawing.Color.Blue;
            Application.DoEvents();
        }
    }
}