﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WatchDog
{
    public partial class Form1 : Form
    {
        int WD_TYPE = PACNET.Sys.WDT.PAC_WDT_OS;
        uint WatchDogTime;

        public Form1()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = 1;
        }

        DateTime t1;

        int second = 0;

        private void button1_Click(object sender, EventArgs e)  //Enable
        {
            if (comboBox1.SelectedIndex == 0)
                WD_TYPE = PACNET.Sys.WDT.PAC_WDT_HW;

            WatchDogTime = Convert.ToUInt32(textBox1.Text);

            bool iRet = PACNET.Sys.WDT.EnableWatchDog(WD_TYPE, WatchDogTime);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            t1 = DateTime.Now;
            second = 0;
            timer1.Enabled = true;
        }

        private void button2_Click(object sender, EventArgs e)  //Disable
        {
            PACNET.Sys.WDT.DisableWatchDog(WD_TYPE);
            timer1.Enabled = false;
            label1.Text = "0";
            second = 0;
        }

        private void button3_Click(object sender, EventArgs e)  //Refresh
        {
            PACNET.Sys.WDT.RefreshWatchDog(WD_TYPE);
            second = 0;
        }

        private void timer1_Tick(object sender, EventArgs e)  //used for count-down
        {
            //label1.Text = ((TimeSpan)(DateTime.Now - t1)).TotalSeconds.ToString();

            second++;

            label1.Text = second.ToString()+"00";
        }
    }
}