﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Error
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

          private void buttonTest_Click(object sender, EventArgs e)
        {
            IntPtr hPort;
            byte[] result = new byte[128];
            bool ret;
            uint errno;
            string errMessage = new string(' ', 128);

            hPort = PACNET.UART.Open("COM7:");
            PACNET.UART.SetTimeOut(hPort, 1000, 0);
            PACNET.UART.EnableCheckSum(hPort, true);

            ret = PACNET.UART.Recv(hPort, result);

            if (ret == false)
            {
                errno = PACNET.ErrHandling.GetLastError();
                PACNET.ErrHandling.GetErrorMessage(errno, errMessage);
                MessageBox.Show("Receive data faild with error " + errno.ToString("x") + ":" + errMessage);
            }
        }
    }
}