﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using gma.System.Windows;
using System.Runtime.InteropServices;

namespace KMevent
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        UserActivityHook actHook;
        private void Form1_Load(object sender, EventArgs e)
        {

            actHook = new UserActivityHook(); // crate an instance with global hooks
            // hang on events
            actHook.OnMouseActivity += new MouseEventHandler(MouseMoved);
            actHook.KeyDown += new KeyEventHandler(MyKeyDown);
            actHook.KeyPress += new KeyPressEventHandler(MyKeyPress);
            actHook.KeyUp += new KeyEventHandler(MyKeyUp);

            actHook.Start();
        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            actHook.Stop();
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            actHook.Start();
        }

        public void MouseMoved(object sender, MouseEventArgs e)
        {
        }
        /// <summary>
        /// ///////////////////////
        /// private const UInt32 MOUSEEVENTF_MOVE = 0x0001;
        private const UInt32 MOUSEEVENTF_LEFTDOWN = 0x0002;
        private const UInt32 MOUSEEVENTF_LEFTUP = 0x0004;
        private const UInt32 MOUSEEVENTF_RIGHTDOWN = 0x0008;
        private const UInt32 MOUSEEVENTF_RIGHTUP = 0x0010;
        private const UInt32 MOUSEEVENTF_MIDDLEDOWN = 0x0020;
        private const UInt32 MOUSEEVENTF_MIDDLEUP = 0x0040;
        int nMoveVal = 5;

        [DllImport("coredll.dll")]
        static extern bool SetCursorPos(int X, int Y);
        [DllImport("coredll.dll")]
        private static extern void mouse_event(
        UInt32 dwFlags,
        UInt32 dx,
        UInt32 dy,
        UInt32 dwData,
        int dwExtraInfo
        );
        class CursorPointClass
        {
            [DllImport("coredll.dll")]
            public static extern bool GetCursorPos(ref Point pt);
        }
        /// ///////////////////////
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void MyKeyDown(object sender, KeyEventArgs e)
        {
            //LogWrite("KeyDown1 	- " + e.KeyData.ToString());
            
            Point pt = new Point(0, 0);
            if (CursorPointClass.GetCursorPos(ref pt))
            {
                //LogWrite("x = " + pt.X.ToString() + " y = " + pt.Y.ToString());
            }
            int speed = 10;
            try
            {
                speed = 10;//Int16.Parse(tBMouseSpeed.Text);
            }
            catch (Exception es)
            {
                speed = 10;
            }
            switch (e.KeyData.ToString()) 
            {
                case "Up":
                    SetCursorPos(pt.X, pt.Y - speed);
                break;
                case "Down":
                    SetCursorPos(pt.X, pt.Y + speed);
                break;
                case "Right":
                    SetCursorPos(pt.X + speed, pt.Y);
                break;
                case "Left":
                    SetCursorPos(pt.X - speed, pt.Y);
                break;
            }
            if (e.KeyData.ToString() == tbMouseleft.Text)//"F2")                
            {
                    mouse_event(MOUSEEVENTF_LEFTDOWN, 0, 0, 0, 0);  
            }
            if (e.KeyData.ToString() == tbMouseRight.Text)//"F3")
            {
                mouse_event(MOUSEEVENTF_RIGHTDOWN, 0, 0, 0, 0);
            }
            
        }

        public void MyKeyPress(object sender, KeyPressEventArgs e)
        {
            //LogWrite("KeyPress 	- " + e.KeyChar);
        }

        public void MyKeyUp(object sender, KeyEventArgs e)
        {
           // LogWrite("KeyUp 		- " + e.KeyData.ToString());
            if (e.KeyData.ToString() == tbMouseleft.Text)//"F2") 
            {
                mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
                mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
                mouse_event(MOUSEEVENTF_LEFTUP, 0, 0, 0, 0);
            }
            if (e.KeyData.ToString() == tbMouseRight.Text)//"F3")
            {
                mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
                mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
                mouse_event(MOUSEEVENTF_RIGHTUP, 0, 0, 0, 0);
            }
        }

        private void LogWrite(string txt)
        {
            //textBox.Text += (txt + "\r\n");
            //textBox.SelectionStart = textBox.Text.Length;
            //textBox.TabIndex++;
        }

        private void button1_Click(object sender, EventArgs e)
        {
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {

        }

        private void tBMouseSpeed_TextChanged(object sender, EventArgs e)
        {

        }

        private void textBox_TextChanged(object sender, EventArgs e)
        {

        }

        //private void tbMouseleft_TextChanged(object sender, EventArgs e)
        //{
        //    if (tbMouseleft.Text != "F2" || tbMouseleft.Text != "F3" || tbMouseleft.Text != "F4" || tbMouseleft.Text != "F5" || tbMouseleft.Text != "F6") 
        //    {
        //        tbMouseleft.Text = "F2";
        //    }
        //}

        //private void tbMouseRight_TextChanged(object sender, EventArgs e)
        //{
        //    if (tbMouseleft.Text != "F2" || tbMouseleft.Text != "F3" || tbMouseleft.Text != "F4" || tbMouseleft.Text != "F5" || tbMouseleft.Text != "F6")
        //    {
        //        tbMouseleft.Text = "F2";
        //    }
        //}
    }
}