﻿using System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO; //for Path.GetDirectoryName

namespace relativePathDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        [System.Runtime.InteropServices.DllImport("coredll.dll")]
        private static extern uint GetModuleFileName(IntPtr hModule, System.Text.StringBuilder lpFileName, int nSize); 

        private void btnGetCurDir_Click(object sender, EventArgs e)
        {
            //txtbGetCurDir.Text = getCurrDir();
            txtbGetCurDir.Text = PACNET.MISC.GetCurrentDirectory();
        }

        private void btnGetAppPath_Click(object sender, EventArgs e)
        {
            //txtbGetAppPath.Text = getAppPath();
            txtbGetCurDir.Text = PACNET.MISC.GetAppPath();
        }

        public static string getAppPath()
        {
            string temp = System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase;
            return Path.GetDirectoryName(temp);
        }

        public string getCurrDir() //get current directory
        {
            string currDir = "";

            System.Text.StringBuilder sb = new System.Text.StringBuilder(256);

            if (GetModuleFileName(IntPtr.Zero, sb, sb.Capacity) > 0)
                currDir = sb.ToString();
            else
                return "";

            return Path.GetDirectoryName(currDir);
        }
    }
}