﻿Public Class Form1

    Dim hPort As IntPtr
    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        hPort = PACNET.UART.Open("")
        If (hPort = -1) Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            btnClose.Enabled = True
            btnOpen.Enabled = False
        End If
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        PACNET.UART.Close(hPort)
        btnClose.Enabled = False
        btnOpen.Enabled = True
    End Sub

    Private Sub btnSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        Dim respon(20) As Byte
        PACNET.Sys.ChangeSlot(Convert.ToSByte(cmbSlot.Text))
        Dim iret As Boolean = PACNET.UART.SendCmdExt(hPort, PACNET.MISC.AnsiString(txtSend.Text), txtSend.Text.Length, respon, respon.Length)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
        txtRespone.Text = PACNET.MISC.WideString(respon)
        End If
    End Sub
End Class
