﻿Public Class Form1

    Dim DIValue As Integer
    Dim HightValue As Integer = 0
    Dim LowValue As Integer = 0

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtChannel.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")
        LowValue = 0

        Dim iret As Boolean = PACNET.PAC_IO.ReadDI(hPort, slot, channel, DIValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtDIValue.Text = DIValue.ToString("X")

        iret = PACNET.PAC_IO.ReadDILatch(hPort, slot, channel, 1, HightValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtHighValue.Text = HightValue.ToString("X")

        iret = PACNET.PAC_IO.ReadDILatch(hPort, slot, channel, 0, LowValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
        txtLowValue.Text = LowValue.ToString("X")

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Dim slot As Integer = cmbSlot.Text
        Dim hPort As IntPtr = PACNET.UART.Open("")

        Dim iret As Boolean = PACNET.PAC_IO.ClearDILatch(hPort, slot)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtDIValue.Text = "0"
        txtHighValue.Text = "0"
        txtLowValue.Text = "0"
    End Sub
End Class
