﻿Public Class Form1



    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtDOChannel.Text
        Dim value As UInteger = Convert.ToUInt32(txtDOValue.Text, 16)
        '8k module have not using com port send data and use pac_WriteDO write do data
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(0, slot, channel, value)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If

    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        Dim slot As Integer = cmbSlot.Text
        Dim channel As Integer = txtDOChannel.Text
        '8k module have not using com port send data and use pac_WrieDO write '0' to clear 
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(0, slot, channel, 0)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim slot As Integer = cmbSlot.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim DIChannel As Integer = txtDIChannel.Text
        Dim DIValue As UInteger

        '8k module have not using com port send data and use pac_ReadDI read di data
        Dim iret As Boolean = PACNET.PAC_IO.ReadDI(0, slot, DIChannel, DIValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtDIValue.Text = DIValue.ToString("X")
        End If

    End Sub
End Class
