﻿Imports pac8024WNet
Public Class Form1
    Private typeStr As String() = New String(4) {}
    Private slotStr As String() = New String(7) {}
    Private chStr As String() = New String(3) {}
    Private slotIndex As Integer = -1

  
    

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        typeStr(0) = "Voltage(+/- 10.0)(unit: V)"
        typeStr(1) = "Current(0.0 ~ 20.0)(unit: mA)"
        typeStr(2) = "Voltage(-32768~32767)(unit: none)"
        typeStr(3) = "Current(0~32768)(unit: none)"

        slotStr(0) = "Slot 0"
        slotStr(1) = "Slot 1"
        slotStr(2) = "Slot 2"
        slotStr(3) = "Slot 3"
        slotStr(4) = "Slot 4"
        slotStr(5) = "Slot 5"
        slotStr(6) = "Slot 6"
        slotStr(7) = "Slot 7"

        chStr(0) = "Channel 0"
        chStr(1) = "Channel 1"
        chStr(2) = "Channel 2"
        chStr(3) = "Channel 3"

        Dim i As Integer = 0
        For i = 0 To 3
            cboRange.Items.Add(typeStr(i))
        Next i

        For i = 0 To 7
            cboSlotIndex.Items.Add(slotStr(i))
        Next i

        For i = 0 To 3
            cboChIndex.Items.Add(chStr(i))
        Next i
        txtLibVer.Text = [String].Format("{0:X4}", pac8024W.LibVersion())
        txtLibDate.Text = pac8024W.LibDate()
    End Sub

  
    Private Sub cboSlotIndex_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlotIndex.SelectedIndexChanged
        Dim ret As Int16 = -1

        slotIndex = cboSlotIndex.SelectedIndex
        ret = pac8024W.Init(slotIndex)
        If ret = 0 Then
            lbID.Text = "Find a 8024W at slot " + slotIndex.ToString()
        Else
            lbID.Text = "No 8024W at slot " + slotIndex.ToString()
        End If

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()

    End Sub

    Private Sub btnAO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAO.Click
        Dim chIndex As Integer

        If slotIndex <> -1 Then


            chIndex = cboChIndex.SelectedIndex

            Select Case cboRange.SelectedIndex
                Case 0
                    If Convert.ToSingle(txtAO.Text) > 10.0 OrElse Convert.ToSingle(txtAO.Text) < -10.0 Then
                        sBar.Text = "Output Data out of range"
                    Else
                        pac8024W.VoltageOut(slotIndex, chIndex, Convert.ToSingle(txtAO.Text))
                        sBar.Text = ""
                    End If
                    Exit Select
                Case 1
                    If Convert.ToSingle(txtAO.Text) > 20.0 OrElse Convert.ToSingle(txtAO.Text) < 0.0 Then

                        sBar.Text = "Output Data out of range"
                    Else
                        pac8024W.CurrentOut(slotIndex, chIndex, Convert.ToSingle(txtAO.Text))
                        sBar.Text = ""
                    End If
                    Exit Select
                Case 2
                    If Convert.ToInt16(txtAO.Text) > 32767 OrElse Convert.ToInt16(txtAO.Text) < -32768 Then

                        sBar.Text = "Output Data out of range"
                    Else
                        pac8024W.VoltageOut_Hex(slotIndex, chIndex, Convert.ToInt16(txtAO.Text))
                        sBar.Text = ""
                    End If
                    Exit Select
                Case 3
                    If Convert.ToInt16(txtAO.Text) > 32767 OrElse Convert.ToInt16(txtAO.Text) < 0 Then

                        sBar.Text = "Output Data out of range"
                    Else
                        pac8024W.CurrentOut_Hex(slotIndex, chIndex, Convert.ToInt16(txtAO.Text))
                        sBar.Text = ""
                    End If
                    Exit Select
            End Select
        End If
    End Sub
End Class
