﻿Imports pac8026WNet
Public Class Form1
    Private slotStr As String() = New String(7) {}
    Private slotIndex As Integer

    
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer = 0
        slotStr(0) = "Slot 0"
        slotStr(1) = "Slot 1"
        slotStr(2) = "Slot 2"
        slotStr(3) = "Slot 3"
        slotStr(4) = "Slot 4"
        slotStr(5) = "Slot 5"
        slotStr(6) = "Slot 6"
        slotStr(7) = "Slot 7"

        While i < 8
            cboSlotIndex.Items.Add(slotStr(i))
            System.Math.Max(System.Threading.Interlocked.Increment(i), i - 1)
        End While

       

    End Sub

    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Dim ch As Integer = 0
        Dim diBit As Byte() = New Byte(2) {}
        Dim doBit As Byte() = New Byte(2) {}
        Dim diVal As Int16 = 0, doVal As Int16 = 0
        Dim aiV As Single = 0
        Dim aiData As TextBox() = {txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5}
        Dim gain As Int16 = cboAIGain.SelectedIndex
        If slotIndex <> -1 Then
            ch = 0
            While ch < 6
                Try
                    Console.WriteLine("rai")
                    pac8026W.ReadAI(slotIndex, ch, gain, aiV)

                    aiData(ch).Text = [String].Format("[{0}]", aiV)
                Catch ee As Exception
                    Console.WriteLine(ee.Message)
                    timer1.Enabled = False
                End Try
                System.Math.Max(System.Threading.Interlocked.Increment(ch), ch - 1)
            End While

            pac8026W.ReadDIO(slotIndex, diVal, doVal, diBit, doBit)

            lbDIVal.Text = diVal.ToString()

            lbDOVal.Text = doVal.ToString()
        End If
    End Sub

   

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        timer1.Enabled = True
        timer1.Interval = 1000

    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        timer1.Enabled = False
    End Sub

   

    Private Sub WriteAO(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAO1.Click, btnAO0.Click
        Dim txtAO As TextBox() = New TextBox() {txtAO0, txtAO1}
        Dim gain As Int16 = cboAOGain.SelectedIndex
        Dim index As Int16 = Int16.Parse(DirectCast(sender, TextBox).Tag.ToString())

        pac8026W.WriteAO(slotIndex, index, gain, Convert.ToSingle(txtAO(index)))
    End Sub

    Private Sub btnWriteDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        pac8026W.WriteDO(slotIndex, Convert.ToInt16(txtDOOut.Text))
    End Sub

   

    
   
    
    
   
    
    Private Sub cboSlotIndex_SelectedIndexChanged_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlotIndex.SelectedIndexChanged
        If pac8026W.Init(cboSlotIndex.SelectedIndex) = 0 Then
            slotIndex = cboSlotIndex.SelectedIndex
            txtLibVer.Text = [String].Format("{0:X4}", pac8026W.LibVersion())

            txtLibDate.Text = pac8026W.LibDate()
            txtFirmware.Text = [String].Format("{0:X4}", pac8026W.FirmwareVersion(slotIndex))
        Else
            slotIndex = -1
            txtLibVer.Text = "-1"
            txtLibDate.Text = "none"
            txtFirmware.Text = "-1"
        End If
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click

        pac8026W.WriteAO(slotIndex, 0, cboAOGain.SelectedIndex, Convert.ToSingle(txtAO0.Text))

    End Sub

    Private Sub button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs)

        pac8026W.WriteAO(slotIndex, 1, cboAOGain.SelectedIndex, Convert.ToSingle(txtAO1))
    End Sub

    Private Sub button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs)

    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        pac8026W.WriteAO(slotIndex, 1, cboAOGain.SelectedIndex, Convert.ToSingle(txtAO1.Text))
    End Sub

    Private Sub btnStart_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        timer1.Enabled = True
        timer1.Interval = 1000
    End Sub

    Private Sub btnStop_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        timer1.Enabled = False
    End Sub

    Private Sub btnWriteDO_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteDO.Click
        pac8026W.WriteDO(slotIndex, Convert.ToInt16(txtDOOut.Text))
    End Sub
End Class
