﻿Public Class Form1

    Dim hPort As IntPtr
    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        hPort = PACNET.UART.Open("COM" + cmbPort.Text + "," + txtBuadRate.Text)
        btnOpen.Enabled = False
        btnClose.Enabled = True
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        PACNET.UART.Close(hPort)
        btnOpen.Enabled = True
        btnClose.Enabled = False
    End Sub
    
    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim address As Integer
        Dim IDValue As UInteger = 0
        Dim iRet As Boolean

        'Get slot data
        address = Convert.ToInt16(txtAddress.Text)

        'Read data
        iRet = PACNET.PAC_IO.ReadCNT(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(address), Convert.ToInt16(txtChannel.Text), IDValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        Else
            txtDiValue.Text = Convert.ToString(IDValue)
        End If

    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        Dim address As Integer
        Dim iRet As Boolean

        'Get slot data
        address = Convert.ToInt16(txtAddress.Text)

        'Clear data
        iRet = PACNET.PAC_IO.ClearCNT(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(address), Convert.ToInt16(txtChannel.Text))

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        Else
            MessageBox.Show("Clear Success")
        End If

    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Dim address As Integer
        Dim IDValue As Integer = 0
        Dim iRet As Boolean

        'Get slot data
        address = Convert.ToInt16(txtAddress.Text)

        'Read data
        iRet = PACNET.PAC_IO.ReadCNTOverflow(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(address), Convert.ToInt16(txtChannel.Text), IDValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        Else
            txtDiValue.Text = Convert.ToString(IDValue)
        End If

        PACNET.UART.Close(hPort)
    End Sub
End Class
