'
' Sharememory_UINT32
' Address:
'  0: The average of time span of twice calllback function called by periodically upon expiration of real-time timer1 (unit:milliseconds)
'  1: The minimum of time span of twice calllback function called by periodically upon expiration of real-time timer1 (unit:milliseconds)
'  2: The maximum of time span of twice calllback function called by periodically upon expiration of real-time timer1 (unit:milliseconds)
' 10: Records the starting time difference of 2 program (RTTPrj.exe and RTTimerP.exe)
'

Imports System.Runtime.InteropServices
Imports System.Threading
Imports HANDLE = System.IntPtr
Public Class Form1
    <DllImport("coredll.dll")> _
     Public Shared Function FindWindow(ByVal lpWindowName As String, ByVal lpClassName As String) As IntPtr
    End Function

    <DllImport("coredll", EntryPoint:="SendMessage")> _
    Private Shared Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As Integer, ByVal wParam As IntPtr, ByVal lParam As IntPtr) As Integer
    End Function


    <DllImport("coredll.dll", SetLastError:=True, CallingConvention:=CallingConvention.Winapi, CharSet:=CharSet.Auto)> _
    Public Shared Function CreateEvent(ByVal lpEventAttributes As HANDLE, <[In](), MarshalAs(UnmanagedType.Bool)> ByVal bManualReset As Boolean, <[In](), MarshalAs(UnmanagedType.Bool)> ByVal bIntialState As Boolean, <[In](), MarshalAs(UnmanagedType.BStr)> ByVal lpName As String) As HANDLE
    End Function

    <DllImport("coredll.dll", SetLastError:=True, CallingConvention:=CallingConvention.Winapi, CharSet:=CharSet.Auto)> _
    Public Shared Function CloseHandle(ByVal hObject As HANDLE) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function

    <DllImport("coredll.dll", SetLastError:=True)> _
    Public Shared Function EventModify(ByVal hEvent As HANDLE, <[In](), MarshalAs(UnmanagedType.U4)> ByVal dEvent As Integer) As <MarshalAs(UnmanagedType.Bool)> Boolean
    End Function

    <DllImport("coredll.Dll", EntryPoint:="CreateProcess", SetLastError:=True)> _
    Private Shared Function CreateProcess(ByVal strImageName As String, ByVal strCmdLine As String, ByVal pProcessAttributes As IntPtr, ByVal pThreadAttributes As IntPtr, ByVal bInheritsHandle As Integer, ByVal dwCreationFlags As Integer, _
     ByVal pEnvironment As IntPtr, ByVal pCurrentDir As IntPtr, ByVal bArray As IntPtr, ByVal oProc As ProcessInfo) As Integer
    End Function
    Private Const shareMemorylib As String = "RTTimerDll.dll"

    ' To Read/Write share memory boolean data
    <DllImport(shareMemorylib)> _
    Private Shared Function RTT_ReadBOOL(ByVal memslot As Int32, ByRef rbool32Array As Boolean) As Boolean
    End Function

    <DllImport(shareMemorylib)> _
    Private Shared Function RTT_WriteBOOL(ByVal memslot As Int32, ByVal bool32Array As Boolean) As Boolean
    End Function

    ' To Read/Write share memory float data
    <DllImport(shareMemorylib)> _
    Private Shared Function RTT_ReadFLOAT(ByVal memslot As Int32, ByRef rfloatValue As Single) As Boolean
    End Function

    <DllImport(shareMemorylib)> _
    Private Shared Function RTT_WriteFLOAT(ByVal memslot As Int32, ByVal floatValue As Single) As Boolean
    End Function

    ' To Read/Write share memory Int32 data
    <DllImport(shareMemorylib)> _
    Private Shared Function RTT_ReadDWORD(ByVal memslot As Int32, ByRef ruint32Value As UInt32) As Boolean
    End Function

    <DllImport(shareMemorylib)> _
    Private Shared Function RTT_WriteDWORD(ByVal memslot As Int32, ByVal uint32Value As UInt32) As Boolean
    End Function

    <DllImport("coredll.Dll")> _
    Private Shared Function GetTickCount() As UInteger
    End Function

    Public Class ProcessInfo
        Public hProcess As Int32
        Public hThread As Int32
        Public ProcessID As Int32
        Public ThreadID As Int32
    End Class

    Public Enum EventFlags
        PULSE = 1
        RESET = 2
        [SET] = 3
    End Enum
    Private Shared Function SetEvent(ByVal hEvent As HANDLE) As Boolean
        Return EventModify(hEvent, CInt(EventFlags.[SET]))
    End Function
    Private Shared Function ResetEvent(ByVal hEvent As HANDLE) As Boolean
        Return EventModify(hEvent, CInt(EventFlags.RESET))
    End Function

    Private Delegate Sub ShowOnTextCallback(ByRef rtb As TextBox, ByVal inpstr As String)

    Dim worker As ThreadStart
    Dim t As Thread
    Dim RTTPrjStartTick As UInt32 = 0
    ' IntPtr hPort;
    Dim bRunThread As Boolean = False


    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        worker = New ThreadStart(AddressOf IO_work)
        t = New Thread(worker)
        't.IsBackground = true;            

        Dim pi As New ProcessInfo()
        Dim sparameter As String = textBox1.Text 'Timer interval

        RTTPrjStartTick = GetTickCount()
        CreateProcess("\temp\RTTimerP.exe", sparameter, IntPtr.Zero, IntPtr.Zero, 0, 0, _
         IntPtr.Zero, IntPtr.Zero, IntPtr.Zero, pi)

        Thread.Sleep(5)
        t.Start()
        bRunThread = True
    End Sub
    Private Sub IO_work()
        Dim AIValue As Single = 0
        Dim IDValue As UInteger = 0

        Dim iRet As Boolean

        Dim uiValue As UInt32 = 0
        Dim errMessage As New String(" "c, 128)


        While bRunThread = True
            'try
            '{                    
            RTT_ReadDWORD(10, uiValue)
            If (uiValue > 0) Then
                'Console.WriteLine(Convert.ToString(uiValue) + " " + Convert.ToString(RTTPrjStartTick))
                ShowOnTextBox(Me.textBox6, Convert.ToString(uiValue - RTTPrjStartTick))
            End If


            'Read DWORD share memory
            iRet = RTT_ReadDWORD(0, uiValue)
            If (iRet = True) Then
                ShowOnTextBox(Me.txtAvgValue, Convert.ToString(uiValue))
            End If
            iRet = RTT_ReadDWORD(1, uiValue)
            If (iRet = True) Then
                ShowOnTextBox(Me.txtMinValue, Convert.ToString(uiValue))
            End If

            iRet = RTT_ReadDWORD(2, uiValue)
            If (iRet = True) Then
                ShowOnTextBox(Me.txtMaxValue, Convert.ToString(uiValue))
            End If

            Thread.Sleep(5)
        End While
    End Sub
    Private Sub ShowOnTextBox(ByRef rtb As TextBox, ByVal inpstr As String)
        If rtb.InvokeRequired Then
            Dim d As New ShowOnTextCallback(AddressOf ShowOnTextBox)
            Me.Invoke(d, New Object() {rtb, inpstr})
        Else
            rtb.Text = inpstr
        End If
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        bRunThread = False
        t.Abort()
        t.Join()

        Dim p As IntPtr = CreateEvent(IntPtr.Zero, True, False, "CLOSERTTIMER")
        SetEvent(p)
        ResetEvent(p)
        CloseHandle(p)

        Dim Hwnd As IntPtr = FindWindow(Nothing, "RTTimerP")
        If Hwnd <> IntPtr.Zero Then
            '0x0010 WM_CLOSE
            Console.WriteLine("send WM_close")
            SendMessage(Hwnd, &H10, IntPtr.Zero, IntPtr.Zero)
        End If
    End Sub
End Class
