// 87k_aiDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_ai.h"
#include "87k_aiDlg.h"
#include "PACSDK.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy87k_aiDlg dialog

CMy87k_aiDlg::CMy87k_aiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_aiDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_aiDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy87k_aiDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMy87k_aiDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy87k_aiDlg::OnBnClickedButton2)
END_MESSAGE_MAP()


// CMy87k_aiDlg message handlers

BOOL CMy87k_aiDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//set default value
	SetDlgItemText(IDC_COMBO1,L"1");
	SetDlgItemText(IDC_EDIT1,L"8");
	SetDlgItemText(IDC_EDIT2,L"1");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy87k_aiDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY87K_AI_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY87K_AI_DIALOG));
	}
}
#endif


void CMy87k_aiDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code her
	HANDLE hPort = uart_Open("");
	TCHAR temp[20]={0};
	float fValue=0.0;

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int TotalChannel = _wtoi(temp);

	//get user set read channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	int ReadChannel = _wtoi(temp);

	//use pac_ReadAI functio to read AI data
	BOOL iret = pac_ReadAI(hPort,slot,ReadChannel,TotalChannel,&fValue);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Read AI error",L"87k_ai",MB_OK);
	}else{
		wsprintf(temp,L"%.4f",fValue);
		SetDlgItemText(IDC_EDIT3,temp);
	}



}

void CMy87k_aiDlg::OnBnClickedButton2()
{
	// TODO: b[JiBz`{X
	// TODO: Add your control notification handler code her
	HANDLE hPort = uart_Open("");
	TCHAR temp[20]={0};
	float fValue[32] = {0};

	DWORD len = 0;

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	int slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	int TotalChannel = _wtoi(temp);

	//get user set read channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	int ReadChannel = _wtoi(temp);

	//use pac_ReadAI functio to read AI data
	BOOL iret = pac_ReadAIAllExt(hPort,slot,fValue,32,&len);
	uart_Close(hPort);
	if(!iret)
	{
		::MessageBox(NULL,L"Read AI error",L"87k_ai",MB_OK);
	}
	else
	{
		for(int i = 0; i < 32; i++)
		{
			printf("channel %d, value: %f\n", i, fValue[i]);
		}

		printf("total channel len: %d\n", len);
	}

}
