// 8k_87k_dioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_87k_dio.h"
#include "8k_87k_dioDlg.h"
#include "PACSDK.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy8k_87k_dioDlg dialog

CMy8k_87k_dioDlg::CMy8k_87k_dioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_87k_dioDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_87k_dioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy8k_87k_dioDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CMy8k_87k_dioDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy8k_87k_dioDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMy8k_87k_dioDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMy8k_87k_dioDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CMy8k_87k_dioDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CMy8k_87k_dioDlg::OnBnClickedButton6)
END_MESSAGE_MAP()


// CMy8k_87k_dioDlg message handlers

BOOL CMy8k_87k_dioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_EDIT11, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy8k_87k_dioDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY8K_87K_DIO_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY8K_87K_DIO_DIALOG));
	}
}
#endif



void CMy8k_87k_dioDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	DWORD DOValue=0;
	CString strTemp;
	char ctemp[20]={0};
	int slot,DOChannel;
	BOOL iret;

	//87k module must build com port HANDLE send data
	HANDLE hPort = uart_Open("");

	//get user insert 87k module slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	slot = _wtoi(temp);

	//get user set 87k module DO channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	DOChannel = _wtoi(temp);

	//get user set 87k module DO value and change decade to hexadecimal
	GetDlgItemText(IDC_EDIT3,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}
	sscanf(ctemp,"%lx",&DOValue);

	//use pac_WriteDO functio to write DO data
	iret = pac_WriteDO(hPort,slot,DOChannel,DOValue);
	uart_Close(hPort);


	//get user insert 8k module slot
	GetDlgItemText(IDC_COMBO2,temp,20);
	slot = _wtoi(temp);

	//get user set 8k module DO channel
	GetDlgItemText(IDC_EDIT7,temp,20);
	DOChannel = _wtoi(temp);

	//get user set 8k module DO value and change decade to hexadecimal, 8k module haven't use com port HANDLE send data.
	GetDlgItemText(IDC_EDIT8,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}
	sscanf(ctemp,"%lx",&DOValue);

	//use pac_WriteDO functio to write DO data
	iret = pac_WriteDO(0,slot,DOChannel,DOValue);



	if(!iret){
		::MessageBox(NULL,L"Write DO error",L"87k_8k_dio",MB_OK);
	}
}

void CMy8k_87k_dioDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	int slot,DOChannel;
	BOOL iret;

	//87k module must build com port HANDLE send data
	HANDLE hPort = uart_Open("");

	//get user insert 87k module slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	slot = _wtoi(temp);

	//get user set 87k module DO channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	DOChannel = _wtoi(temp);

	//use pac_WriteDO functio to write DO data
	iret = pac_WriteDO(hPort,slot,DOChannel,0);
	uart_Close(hPort);

	if(!iret){
		::MessageBox(NULL,L"Write 87k module DO error",L"87k_8k_dio",MB_OK);
	}


	//get user insert 8k module slot
	GetDlgItemText(IDC_COMBO2,temp,20);
	slot = _wtoi(temp);

	//get user set 8k module DO channel
	GetDlgItemText(IDC_EDIT7,temp,20);
	DOChannel = _wtoi(temp);

	//use pac_WriteDO functio to write DO data, 8k module haven't use com port HANDLE send data.
	iret = pac_WriteDO(0,slot,DOChannel,0);



	if(!iret){
		::MessageBox(NULL,L"Write 8k module DO error",L"87k_8k_dio",MB_OK);
	}

}

void CMy8k_87k_dioDlg::OnBnClickedButton3()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	DWORD DIValue;
	DWORD DOValue;
	int slot,DIChannel,DOChannel;
	BOOL iret;

	

	//87k module must build com port HANDLE read data
	HANDLE hPort = uart_Open("");

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	DIChannel = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	DOChannel = _wtoi(temp);

	//use pac_ReadDI functio to read DI data
	iret = pac_ReadDIO(hPort,slot,DIChannel,DOChannel,&DIValue,&DOValue);
	uart_Close(hPort);

	if(!iret){
		::MessageBox(NULL,L"Read 87k moudle DI error",L"87k_8k_dio",MB_OK);
	}else{
		wsprintf(temp,L"%d",DIValue);
		SetDlgItemText(IDC_EDIT4,temp);

		wsprintf(temp,L"0x%lx",DIValue);
		SetDlgItemText(IDC_EDIT5,temp);
	}


	//get user set slot
	GetDlgItemText(IDC_COMBO2,temp,20);
	slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT6,temp,20);
	DIChannel = _wtoi(temp);

	GetDlgItemText(IDC_EDIT7,temp,20);
	DOChannel = _wtoi(temp);

	//use pac_ReadDI functio to read DI data,8k module haven't use com port HANDLE read data.
	pac_ReadDIO(NULL,slot,DIChannel,DOChannel,&DIValue,&DOValue);

	wsprintf(temp,L"%d",DIValue);
	SetDlgItemText(IDC_EDIT9,temp);

	wsprintf(temp,L"0x%lx",DIValue);
	SetDlgItemText(IDC_EDIT10,temp);

}

void CMy8k_87k_dioDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	DWORD DOValue=0;
	CString strTemp;
	char ctemp[20]={0};
	int slot,DOChannel;
	BOOL iret;

	//87k module must build com port HANDLE send data
	HANDLE hPort = uart_Open("");

	//get user insert 87k module slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	slot = _wtoi(temp);

	//get user set 87k module DO channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	DOChannel = _wtoi(temp);

	//get user set 87k module DO value and change decade to hexadecimal
	GetDlgItemText(IDC_EDIT3,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}
	sscanf(ctemp,"%lx",&DOValue);

	//use pac_WriteDO functio to write DO data
	iret = pac_WriteDO_MF(hPort,slot,DOChannel,DOValue);
	uart_Close(hPort);


	//get user insert 8k module slot
	GetDlgItemText(IDC_COMBO2,temp,20);
	slot = _wtoi(temp);

	//get user set 8k module DO channel
	GetDlgItemText(IDC_EDIT7,temp,20);
	DOChannel = _wtoi(temp);

	//get user set 8k module DO value and change decade to hexadecimal, 8k module haven't use com port HANDLE send data.
	GetDlgItemText(IDC_EDIT8,strTemp);
	for(int i=0;i<strTemp.GetAllocLength();i++){
		ctemp[i] = strTemp[i];
	}
	sscanf(ctemp,"%lx",&DOValue);

	//use pac_WriteDO functio to write DO data
	iret = pac_WriteDO(0,slot,DOChannel,DOValue);



	if(!iret){
		::MessageBox(NULL,L"Write DO error",L"87k_8k_dio",MB_OK);
	}
}

void CMy8k_87k_dioDlg::OnBnClickedButton5()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	int slot,DOChannel;
	BOOL iret;

	//87k module must build com port HANDLE send data
	HANDLE hPort = uart_Open("");

	//get user insert 87k module slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	slot = _wtoi(temp);

	//get user set 87k module DO channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	DOChannel = _wtoi(temp);

	//use pac_WriteDO functio to write DO data
	iret = pac_WriteDO_MF(hPort,slot,DOChannel,0);
	uart_Close(hPort);

	if(!iret){
		::MessageBox(NULL,L"Write 87k module DO error",L"87k_8k_dio",MB_OK);
	}


	//get user insert 8k module slot
	GetDlgItemText(IDC_COMBO2,temp,20);
	slot = _wtoi(temp);

	//get user set 8k module DO channel
	GetDlgItemText(IDC_EDIT7,temp,20);
	DOChannel = _wtoi(temp);

	//use pac_WriteDO functio to write DO data, 8k module haven't use com port HANDLE send data.
	iret = pac_WriteDO(0,slot,DOChannel,0);



	if(!iret){
		::MessageBox(NULL,L"Write 8k module DO error",L"87k_8k_dio",MB_OK);
	}
}

void CMy8k_87k_dioDlg::OnBnClickedButton6()
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
	DWORD DIValue;
	DWORD DOValue;
	int slot,DIChannel,DOChannel;
	BOOL iret;

	

	//87k module must build com port HANDLE read data
	HANDLE hPort = uart_Open("");

	//get user set slot
	GetDlgItemText(IDC_COMBO1,temp,20);
	slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT1,temp,20);
	DIChannel = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT2,temp,20);
	DOChannel = _wtoi(temp);

	//use pac_ReadDI functio to read DI data
	iret = pac_ReadDIO_MF(hPort,slot,DIChannel,DOChannel,&DIValue,&DOValue);
	uart_Close(hPort);

	if(!iret){
		::MessageBox(NULL,L"Read 87k moudle DI error",L"87k_8k_dio",MB_OK);
	}else{
		wsprintf(temp,L"%d",DIValue);
		SetDlgItemText(IDC_EDIT4,temp);

		wsprintf(temp,L"0x%lx",DIValue);
		SetDlgItemText(IDC_EDIT5,temp);
	}


	//get user set slot
	GetDlgItemText(IDC_COMBO2,temp,20);
	slot = _wtoi(temp);

	//get user set total channel
	GetDlgItemText(IDC_EDIT6,temp,20);
	DIChannel = _wtoi(temp);

	GetDlgItemText(IDC_EDIT7,temp,20);
	DOChannel = _wtoi(temp);

	//use pac_ReadDI functio to read DI data,8k module haven't use com port HANDLE read data.
	pac_ReadDIO(NULL,slot,DIChannel,DOChannel,&DIValue,&DOValue);

	wsprintf(temp,L"%d",DIValue);
	SetDlgItemText(IDC_EDIT9,temp);

	wsprintf(temp,L"0x%lx",DIValue);
	SetDlgItemText(IDC_EDIT10,temp);
}
