// 7k_do_poweron_safeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_do_poweron_safe.h"
#include "7k_do_poweron_safeDlg.h"
#include "PACSDK.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy7k_do_poweron_safeDlg dialog

CMy7k_do_poweron_safeDlg::CMy7k_do_poweron_safeDlg(CWnd* pParent /*=NULL*/)
: CDialog(CMy7k_do_poweron_safeDlg::IDD, pParent)
{
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_do_poweron_safeDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy7k_do_poweron_safeDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
    ON_WM_SIZE()
#endif
    //}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_BUTTON1, &CMy7k_do_poweron_safeDlg::OnBnClickedButton1)
    ON_BN_CLICKED(IDC_BUTTON2, &CMy7k_do_poweron_safeDlg::OnBnClickedButton2)
    //    ON_BN_CLICKED(IDC_BUTTON3, &CMy7k_do_poweron_safeDlg::OnBnClickedButton3)
    ON_BN_CLICKED(IDC_BUTTON4, &CMy7k_do_poweron_safeDlg::OnBnClickedButton4)
    ON_BN_CLICKED(IDC_BUTTON5, &CMy7k_do_poweron_safeDlg::OnBnClickedButton5)
    ON_BN_CLICKED(IDC_BUTTON6, &CMy7k_do_poweron_safeDlg::OnBnClickedButton6)
    ON_BN_CLICKED(IDC_BUTTON8, &CMy7k_do_poweron_safeDlg::OnBnClickedButton8)
    ON_BN_CLICKED(IDC_BUTTON9, &CMy7k_do_poweron_safeDlg::OnBnClickedButton9)
    ON_BN_CLICKED(IDC_BUTTON10, &CMy7k_do_poweron_safeDlg::OnBnClickedButton10)
    ON_BN_CLICKED(IDC_BUTTON11, &CMy7k_do_poweron_safeDlg::OnBnClickedButton11)
    ON_BN_CLICKED(IDC_BUTTON12, &CMy7k_do_poweron_safeDlg::OnBnClickedButton12)
    ON_BN_CLICKED(IDC_BUTTON13, &CMy7k_do_poweron_safeDlg::OnBnClickedButton13)
    ON_BN_CLICKED(IDC_BUTTON14, &CMy7k_do_poweron_safeDlg::OnBnClickedButton14)
    ON_BN_CLICKED(IDC_BUTTON15, &CMy7k_do_poweron_safeDlg::OnBnClickedButton15)
	ON_BN_CLICKED(IDC_BUTTON7, &CMy7k_do_poweron_safeDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON16, &CMy7k_do_poweron_safeDlg::OnBnClickedButton16)
	ON_BN_CLICKED(IDC_BUTTON17, &CMy7k_do_poweron_safeDlg::OnBnClickedButton17)
	ON_BN_CLICKED(IDC_BUTTON18, &CMy7k_do_poweron_safeDlg::OnBnClickedButton18)
	ON_BN_CLICKED(IDC_BUTTON19, &CMy7k_do_poweron_safeDlg::OnBnClickedButton19)
	ON_BN_CLICKED(IDC_BUTTON20, &CMy7k_do_poweron_safeDlg::OnBnClickedButton20)
	ON_BN_CLICKED(IDC_BUTTON21, &CMy7k_do_poweron_safeDlg::OnBnClickedButton21)
END_MESSAGE_MAP()


// CMy7k_do_poweron_safeDlg message handlers

BOOL CMy7k_do_poweron_safeDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon

    // TODO: Add extra initialization here

    //set default value
    SetDlgItemText(IDC_COMBO1, L"COM3:");
    SetDlgItemText(IDC_EDIT1, L"01");
    SetDlgItemText(IDC_EDIT2, L"9600");
    SetDlgItemText(IDC_EDIT3, L"16");
    SetDlgItemText(IDC_EDIT4, L"10");
	SetDlgItemText(IDC_EDIT7, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

    return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy7k_do_poweron_safeDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    if(AfxIsDRAEnabled())
    {
        DRA::RelayoutDialog(
            AfxGetResourceHandle(),
            this->m_hWnd,
            DRA::GetDisplayMode() != DRA::Portrait ?
            MAKEINTRESOURCE(IDD_MY7k_do_poweron_safe_DIALOG_WIDE) :
        MAKEINTRESOURCE(IDD_MY7k_do_poweron_safe_DIALOG));
    }
}
#endif

HANDLE hPort;
void CMy7k_do_poweron_safeDlg::OnBnClickedButton1()
{
    // TODO: Add your control notification handler code here
    TCHAR OpenPort[10];
    TCHAR temp[20];
    char port[20];

    //get user set com port and buad rate
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    GetDlgItemText(IDC_EDIT2, temp, 20);
    int BuadRate = _wtoi(temp);

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    //if hPort value is INVALID_HANDLE_VALUE , that is error
    if(hPort == INVALID_HANDLE_VALUE)
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_di", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton2()
{
    // TODO: Add your control notification handler code here

    //close com port
    if(!uart_Close(hPort))
    {
        ::MessageBox(NULL, L"Close Port Error", L"7k_di", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton4()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT4, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteDO(hPort, PAC_REMOTE_IO(address), channel, DOValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write DO error", L"7k_di", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton5()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_ReadDO(hPort, PAC_REMOTE_IO(address), channel, &DOValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"READ DO error", L"7k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read DO: %d", DOValue);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton6()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteDO(hPort, PAC_REMOTE_IO(address), channel, 0);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write DO error", L"7k_di", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton8()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set WTD Timeout
    GetDlgItemText(IDC_EDIT6, temp, 20);
    int WTDTimeout = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_SetModuleWDTConfig(hPort, PAC_REMOTE_IO(address), 1, WTDTimeout, 0);

    if(!iret)
    {
        ::MessageBox(NULL, L"Config WDT  error", L"7k_do_poweron_safe", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton9()
{
    // TODO: b[JiBz`{X

    TCHAR temp[20];

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int TotalChannel = _wtoi(temp);

    short ebStatus;
    ulong WTDTimeout;
    int WTDOverwrite;
    //use pac_GetModuleWDTConfig function
    BOOL iret = pac_GetModuleWDTConfig(hPort, PAC_REMOTE_IO(address), &ebStatus, &WTDTimeout, &WTDOverwrite);

    if(!iret)
    {
        ::MessageBox(NULL, L"Get Module WDT Config error", L"7k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%u", WTDTimeout);
        SetDlgItemText(IDC_EDIT6, temp);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton10()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_ResetModuleWDT(hPort, PAC_REMOTE_IO(address));

    if(!iret)
    {
        ::MessageBox(NULL, L"Reset Module WDT error", L"7k_do_poweron_safe", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton11()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_RefreshModuleWDT(hPort, PAC_REMOTE_IO(address));

    if(!iret)
    {
        ::MessageBox(NULL, L"Refresh Module WDT error", L"7k_do_poweron_safe", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton12()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;
    DWORD fValue = 0;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int TotalChannel = _wtoi(temp);

    //use pac_ReaddO function
    BOOL iret = pac_ReadModulePowerOnValueDO(hPort, PAC_REMOTE_IO(address), TotalChannel, &fValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read PowerOn ValueDO error", L"7k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read PowerOn ValueDO: %d", fValue);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton13()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 10);
    int address = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT4, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteModulePowerOnValueDO(hPort, PAC_REMOTE_IO(address), channel, DOValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write PowerOn ValueDO error", L"7k_do_poweron_safe", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton14()
{
    // TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;
    DWORD fValue = 0;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int TotalChannel = _wtoi(temp);

    //use pac_ReaddO function
    BOOL iret = pac_ReadModuleSafeValueDO(hPort, PAC_REMOTE_IO(address), TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read Safe ValuedO error", L"7k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read Safe ValuedO: %d", fValue);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton15()
{
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 10);
    int address = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT4, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteModuleSafeValueDO(hPort, PAC_REMOTE_IO(address), channel, DOValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write Safe ValueDO error", L"7k_do_poweron_safe", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton7()
{
	// TODO: b[JiBz`{X
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT4, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteDO_MF(hPort, PAC_REMOTE_IO(address), channel, DOValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write DO error", L"7k_di", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton16()
{
	// TODO: b[JiBz`{X
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_ReadDO_MF(hPort, PAC_REMOTE_IO(address), channel, &DOValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"READ DO error", L"7k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read DO: %d", DOValue);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton17()
{
	// TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteDO_MF(hPort, PAC_REMOTE_IO(address), channel, 0);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write DO error", L"7k_di", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton18()
{
	// TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;
    DWORD fValue = 0;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int TotalChannel = _wtoi(temp);

    //use pac_ReaddO function
    BOOL iret = pac_ReadModulePowerOnValueDO_MF(hPort, PAC_REMOTE_IO(address), TotalChannel, &fValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read PowerOn ValueDO error", L"7k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read PowerOn ValueDO: %d", fValue);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton19()
{
	// TODO: b[JiBz`{X
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 10);
    int address = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT4, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteModulePowerOnValueDO_MF(hPort, PAC_REMOTE_IO(address), channel, DOValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write PowerOn ValueDO error", L"7k_do_poweron_safe", MB_OK);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton20()
{
	// TODO: b[JiBz`{X
    TCHAR temp[20];
    CString strTemp;
    DWORD fValue = 0;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int TotalChannel = _wtoi(temp);

    //use pac_ReaddO function
    BOOL iret = pac_ReadModuleSafeValueDO_MF(hPort, PAC_REMOTE_IO(address), TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read Safe ValuedO error", L"7k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read Safe ValuedO: %d", fValue);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy7k_do_poweron_safeDlg::OnBnClickedButton21()
{
	TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 10);
    int address = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT4, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteModuleSafeValueDO_MF(hPort, PAC_REMOTE_IO(address), channel, DOValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write Safe ValueDO error", L"7k_do_poweron_safe", MB_OK);
    }
}
