// 7k_dobitDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_dobit.h"
#include "7k_dobitDlg.h"
#include "pacsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMy7k_dobitDlg dialog

CMy7k_dobitDlg::CMy7k_dobitDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k_dobitDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_dobitDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMy7k_dobitDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP	
	ON_BN_CLICKED(IDC_BUTTON1, &CMy7k_dobitDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CMy7k_dobitDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CMy7k_dobitDlg::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CMy7k_dobitDlg::OnBnClickedButton4)
END_MESSAGE_MAP()


// CMy7k_dobitDlg message handlers

BOOL CMy7k_dobitDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CMy7k_dobitDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_MY7K_DOBIT_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_MY7K_DOBIT_DIALOG));
	}
}
#endif

HANDLE hPort;
int byteOnOff = 0;
BOOL iret;
void CMy7k_dobitDlg::OnBnClickedButton1()
{
    // TODO: Add your control notification handler code here
    TCHAR OpenPort[10];
    TCHAR temp[20];
    char port[20];

    //get user set com port and buad rate
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    GetDlgItemText(IDC_EDIT3, temp, 20);
    int BuadRate = _wtoi(temp);								// _wtoi = string to integer

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    //if hPort value is INVALID_HANDLE_VALUE , that is error
    if(hPort == INVALID_HANDLE_VALUE)
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_di", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
		GetDlgItem(IDC_BUTTON4)->EnableWindow(TRUE);
    }
}

void CMy7k_dobitDlg::OnBnClickedButton2()
{
    // TODO: Add your control notification handler code here

    //close com port
    if(!uart_Close(hPort))
    {
        ::MessageBox(NULL, L"Close Port Error", L"7k_di", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
		GetDlgItem(IDC_BUTTON4)->EnableWindow(FALSE);
    }
}


void CMy7k_dobitDlg::FL_CheckMF(byte byteOnOff)
{
    TCHAR temp[20];
    DWORD DOChannel = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set address
	GetDlgItemText(IDC_EDIT2, temp, 20);
    int address = _wtoi(temp);

    //get user set dobit channel
	GetDlgItemText(IDC_EDIT5, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOChannel);

    //get user set total channel
    GetDlgItemText(IDC_EDIT4, temp, 20);
    int Totalchannel = _wtoi(temp);

    //use pac_Writedobit functio to write dobit data
	//if(    )
	iret = pac_WriteDOBit(hPort, PAC_REMOTE_IO(address), Totalchannel, DOChannel, byteOnOff);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write dobit error", L"7k_di", MB_OK);
    }
} 

void CMy7k_dobitDlg::OnBnClickedButton3()
{
    // TODO: Add your control notification handler code here
	byteOnOff = 1;
	//if()										for check checkbox enable
	CMy7k_dobitDlg::FL_CheckMF(byteOnOff);
}

void CMy7k_dobitDlg::OnBnClickedButton4()
{
	// TODO: Add your control notification handler code here
	byteOnOff = 0;
	CMy7k_dobitDlg::FL_CheckMF(byteOnOff);
}
