// 87K_demoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87K_demo.h"
#include "87K_demoDlg.h"

#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy87K_demoDlg dialog

CMy87K_demoDlg::CMy87K_demoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87K_demoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87K_demoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87K_demoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87K_demoDlg)
	DDX_Control(pDX, IDC_COMBO1, m_SelectSlot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87K_demoDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87K_demoDlg)
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_CHANGESLOT, OnChangeslot)
	ON_BN_CLICKED(IDC_SENDCMD, OnSendcmd)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)
	ON_BN_CLICKED(IDC_QUIT, OnQuit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87K_demoDlg message handlers

BOOL CMy87K_demoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_SelectSlot.SetCurSel(0);
	UpdateData(false);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

HANDLE hPort;

void CMy87K_demoDlg::OnOpen() 
{
	// TODO: Add your control notification handler code here
	hPort = uart_Open("");	// The default is COM0:, 115200, N, 8, 1	
}

void CMy87K_demoDlg::OnChangeslot() 
{
	// TODO: Add your control notification handler code here
	int slot;
	slot = m_SelectSlot.GetCurSel();	
	pac_ChangeSlot(slot);
}

void CMy87K_demoDlg::OnSendcmd() 
{
	// TODO: Add your control notification handler code here
	char szResult[32];
	TCHAR str[32];
	uart_SendCmdExt( hPort, "$00M", 4, szResult, sizeof(szResult));	// "$00M" ask the module name
	pac_AnsiToWideString(szResult, str);
	SetDlgItemText(IDC_EDIT, str);
}

void CMy87K_demoDlg::OnClose() 
{
	// TODO: Add your control notification handler code here
	uart_Close(hPort);
}

void CMy87K_demoDlg::OnQuit() 
{
	// TODO: Add your control notification handler code here
	PostMessage(WM_QUIT);
}
