// 87k_basicDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_basic.h"
#include "87k_basicDlg.h"
#include "PACSDK.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
unsigned char cComPort;
int iSlot;
static char SendBuf[20];
static char RecBuf[1024];
/////////////////////////////////////////////////////////////////////////////
// CMy87k_basicDlg dialog

CMy87k_basicDlg::CMy87k_basicDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_basicDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_basicDlg)
	m_Baud = 0;
	m_strCmd = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_basicDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_basicDlg)
	DDX_Control(pDX, IDC_EDITRes, m_editRes);
	DDX_Control(pDX, IDC_COMBOSlot, m_cmbSlot);
	DDX_Control(pDX, IDC_COMBOCom, m_cmbCom);
	DDX_Control(pDX, IDC_BUTTONSendCmd, m_btnSendCmd);
	DDX_Control(pDX, IDC_BUTTONOpenCom, m_btnOpenCom);
	DDX_Control(pDX, IDC_BUTTONCloseCom, m_btnCloseCom);
	DDX_Text(pDX, IDC_EDITBaud, m_Baud);
	DDX_Text(pDX, IDC_EDITCmd, m_strCmd);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_basicDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_basicDlg)
	ON_BN_CLICKED(IDC_BUTTONOpenCom, OnBUTTONOpenCom)
	ON_BN_CLICKED(IDC_BUTTONCloseCom, OnBUTTONCloseCom)
	ON_BN_CLICKED(IDC_BUTTONSendCmd, OnBUTTONSendCmd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_basicDlg message handlers

BOOL CMy87k_basicDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default values
	m_cmbCom.SetCurSel(0);
	m_Baud=115200;
	m_cmbSlot.SetCurSel (0);
	m_strCmd=_T("$00M");
	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

HANDLE hPort;

void CMy87k_basicDlg::OnBUTTONOpenCom() 
{
	// TODO: Add your control notification handler code here
	int j;
	char open[64];
	DWORD ret_err;
	//Open com port
	cComPort=m_cmbCom.GetCurSel();
	UpdateData();

	j  = sprintf( open, "COM%d:", cComPort);
	sprintf( open + j, ",%d", m_Baud);

	hPort = uart_Open(open);
	ret_err = pac_GetLastError();
//	if(!(ret_err == PAC_ERR_SUCCESS)) AfxMessageBox(_T("Open Com Error"));
}

void CMy87k_basicDlg::OnBUTTONCloseCom() 
{
	// TODO: Add your control notification handler code here
	//Close com port
	uart_Close(hPort);
}

void CMy87k_basicDlg::OnBUTTONSendCmd() 
{
	// TODO: Add your control notification handler code here
	WORD wTimeout=100,wChecksum=0;

	if(cComPort==0){
		//Change slot where the 87k module is
		iSlot=m_cmbSlot.GetCurSel();
		pac_ChangeSlot(iSlot);
	}
		//Get command
		memset(SendBuf,'\0',sizeof(SendBuf));
		UpdateData(); //update m_strCmd
		wcstombs(SendBuf,m_strCmd,m_strCmd.GetLength());
		
		//Send command and receive response
		memset(RecBuf,'\0',sizeof(RecBuf));
		uart_SendCmdExt(hPort, SendBuf, sizeof(SendBuf), RecBuf, sizeof(RecBuf));		
		
		
		//Show response
		m_editRes.SetWindowText((CString)RecBuf);
	
}
