// 87k_cntDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_cnt.h"
#include "87k_cntDlg.h"
#include "PACSDK.h"
				
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy87k_cntDlg dialog

CMy87k_cntDlg::CMy87k_cntDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_cntDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_cntDlg)
	m_DIChannels = _T("");
	m_DIValue = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_cntDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_cntDlg)
	DDX_Control(pDX, IDC_COMBODISlot, m_cmbDISlot);
	DDX_Control(pDX, IDC_BUTTONReadDI, m_btnReadDI);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_cntDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_cntDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI, OnBUTTONReadDI)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_cntDlg message handlers

BOOL CMy87k_cntDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbDISlot.SetCurSel(0);
	m_DIChannels=_T("8");
	UpdateData(false);

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy87k_cntDlg::OnBUTTONReadDI() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];

	//get user set slot
	GetDlgItemText(IDC_COMBODISlot,temp,20);
	int slot = _wtoi(temp);
	
	//get user set total channel
	GetDlgItemText(IDC_EDIT4,temp,20);
	int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5,temp,20);
	int DICNTchannel = _wtoi(temp);
	int DIValue;

	//use pac_ReadAI functio to read DI data
	BOOL iret = pac_ReadCNTOverflow(hPort,slot,DICNTchannel,&DIValue);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Read data error",L"87k_cnt",MB_OK);
	}else{
		wsprintf(temp,L"%d",DIValue);
		SetDlgItemText(IDC_EDIT4,temp);
	}
}

void CMy87k_cntDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];

	//get user set slot
	GetDlgItemText(IDC_COMBODISlot,temp,20);
	int slot = _wtoi(temp);
	
	//get user set total channel
	GetDlgItemText(IDC_EDIT4,temp,20);
	int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5,temp,20);
	int DICNTchannel = _wtoi(temp);
	DWORD DIValue;

	//use pac_ReadAI functio to read DI data
	BOOL iret = pac_ReadCNT(hPort,slot,DICNTchannel,&DIValue);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Read data error",L"87k_cnt",MB_OK);
	}else{
		wsprintf(temp,L"%d",DIValue);
		SetDlgItemText(IDC_EDIT4,temp);
	}
}

void CMy87k_cntDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
	//COM0 port connect to backplane
	HANDLE hPort = uart_Open("");
	TCHAR temp[20];

	//get user set slot
	GetDlgItemText(IDC_COMBODISlot,temp,20);
	int slot = _wtoi(temp);
	
	//get user set total channel
	GetDlgItemText(IDC_EDIT4,temp,20);
	int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5,temp,20);
	int DICNTchannel = _wtoi(temp);
	DWORD DIValue=0;

	//use pac_ReadAI functio to read DI data
	BOOL iret = pac_ClearCNT(hPort,slot,DICNTchannel);
	uart_Close(hPort);
	if(!iret){
		::MessageBox(NULL,L"Read data error",L"87k_cnt",MB_OK);
	}else{
		wsprintf(temp,L"%d",DIValue);
		SetDlgItemText(IDC_EDIT4,temp);
	}
}
