// 87k_doDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_do.h"
#include "87k_doDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//base variables
short iSlot;
short iDO_TotalCh;
/////////////////////////////////////////////////////////////////////////////
// CMy87k_doDlg dialog

CMy87k_doDlg::CMy87k_doDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_doDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_doDlg)
	m_DOValue = _T("");
	m_DOTotalCh = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_doDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_doDlg)
	DDX_Control(pDX, IDC_COMBODOSlot, m_cmbDOSlot);
	DDX_Control(pDX, IDC_BUTTONWriteDO, m_btnWriteDO);
	DDX_Control(pDX, IDC_BUTTONClearDO, m_btnClearDO);
	DDX_Text(pDX, IDC_EDITDOValue, m_DOValue);
	DDX_Text(pDX, IDC_EDITTotalCh, m_DOTotalCh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_doDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_doDlg)
	ON_BN_CLICKED(IDC_BUTTONWriteDO, OnBUTTONWriteDO)
	ON_BN_CLICKED(IDC_BUTTONClearDO, OnBUTTONClearDO)
	ON_BN_CLICKED(IDC_BUTTONWriteDO2, OnBUTTONWriteDO2)
	ON_BN_CLICKED(IDC_BUTTONClearDO2, OnBUTTONClearDO2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_doDlg message handlers

BOOL CMy87k_doDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbDOSlot.SetCurSel(0);
	m_DOTotalCh=_T("8");
	m_DOValue=_T("01");
	UpdateData(false);
	SetDlgItemText(IDC_EDIT3, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy87k_doDlg::OnBUTTONWriteDO() 
{
	// TODO: Add your control notification handler code here
	bool bRet;
	char cTmp[10];
	unsigned long lDO_Value;
	HANDLE hPort;

	//First open com port	
	hPort = uart_Open("");

	//Get the slot where the 87K DO module is
	iSlot=m_cmbDOSlot.GetCurSel ();
	
	//Get DO Channels value
	UpdateData(true);
	wcstombs(cTmp,m_DOTotalCh,10);
	iDO_TotalCh=atoi(cTmp);

	//Get DO value
	UpdateData(true);
	wcstombs(cTmp,m_DOValue,10);
	sscanf(cTmp,"%lx",&lDO_Value);
	
	//Write DO
	bRet = pac_WriteDO( hPort, iSlot,iDO_TotalCh,lDO_Value);
	
	if(bRet==false) AfxMessageBox(_T("No module or module is wrong or something wrong"));
	//Close com port

	uart_Close(hPort);
}

void CMy87k_doDlg::OnBUTTONClearDO() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort;

	hPort = uart_Open("");
	//Clear DO
	pac_WriteDO( hPort, iSlot,iDO_TotalCh,0);	
	m_DOValue=_T("00");
	UpdateData(false);
	
	uart_Close(hPort);
}

void CMy87k_doDlg::OnBUTTONWriteDO2() 
{
// TODO: Add your control notification handler code here
	bool bRet;
	char cTmp[10];
	unsigned long lDO_Value;
	HANDLE hPort;

	//First open com port	
	hPort = uart_Open("");

	//Get the slot where the 87K DO module is
	iSlot=m_cmbDOSlot.GetCurSel ();
	
	//Get DO Channels value
	UpdateData(true);
	wcstombs(cTmp,m_DOTotalCh,10);
	iDO_TotalCh=atoi(cTmp);

	//Get DO value
	UpdateData(true);
	wcstombs(cTmp,m_DOValue,10);
	sscanf(cTmp,"%lx",&lDO_Value);
	
	//Write DO
	bRet = pac_WriteDO_MF( hPort, iSlot,iDO_TotalCh,lDO_Value);
	
	if(bRet==false) AfxMessageBox(_T("No module or module is wrong or something wrong"));
	//Close com port

	uart_Close(hPort);	
}

void CMy87k_doDlg::OnBUTTONClearDO2() 
{
// TODO: Add your control notification handler code here
	HANDLE hPort;

	hPort = uart_Open("");
	//Clear DO
	pac_WriteDO_MF( hPort, iSlot,iDO_TotalCh,0);	
	m_DOValue=_T("00");
	UpdateData(false);
	
	uart_Close(hPort);	
}
