// 87k_do_poweron_safeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_do_poweron_safe.h"
#include "87k_do_poweron_safeDlg.h"

#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy87k_do_poweron_safeDlg dialog

CMy87k_do_poweron_safeDlg::CMy87k_do_poweron_safeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_do_poweron_safeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_do_poweron_safeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_do_poweron_safeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_do_poweron_safeDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_do_poweron_safeDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_do_poweron_safeDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	ON_BN_CLICKED(IDC_BUTTON13, OnButton13)
	ON_BN_CLICKED(IDC_BUTTON12, OnButton12)
	ON_BN_CLICKED(IDC_BUTTON14, OnButton14)
	ON_BN_CLICKED(IDC_BUTTON15, OnButton15)
	ON_BN_CLICKED(IDC_BUTTON16, OnButton16)
	ON_BN_CLICKED(IDC_BUTTON17, OnButton17)
	ON_BN_CLICKED(IDC_BUTTON18, OnButton18)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_do_poweron_safeDlg message handlers

BOOL CMy87k_do_poweron_safeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_EDIT3, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy87k_do_poweron_safeDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT2, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteDO(hPort, slot, channel, DOValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write DO error", L"87k_do_poweron_safe", MB_OK);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    DWORD DOValue = 0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_ReadDO(hPort, slot, channel, &DOValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"READ DO error", L"87k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read DO: %d", DOValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio and set DO value be 0 to clear
    BOOL iret = pac_WriteDO(hPort, slot, channel, 0);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Clear DO error", L"87k_do_poweron_safe", MB_OK);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set WTD Timeout
    GetDlgItemText(IDC_EDIT5, temp, 20);
    int WTDTimeout = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_SetModuleWDTConfig(hPort, slot, 1, WTDTimeout, 0);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Config WDT  error", L"87k_do_poweron_safe", MB_OK);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    short ebStatus;
    ulong WTDTimeout;
    int WTDOverwrite;
    //use pac_GetModuleWDTConfig function
    BOOL iret = pac_GetModuleWDTConfig(hPort, slot, &ebStatus, &WTDTimeout, &WTDOverwrite);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Get Module WDT Config error", L"87k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%u", WTDTimeout);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_ResetModuleWDT(hPort, slot);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Reset Module WDT error", L"87k_do_poweron_safe", MB_OK);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_RefreshModuleWDT(hPort, slot);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Refresh Module WDT error", L"87k_do_poweron_safe", MB_OK);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    DWORD fValue = 0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //use pac_ReadDO function
    BOOL iret = pac_ReadModulePowerOnValueDO(hPort, slot, TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read PowerOn ValuedO error", L"87k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read PowerOn ValuedO: %d", fValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT2, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteModulePowerOnValueDO(hPort, slot, channel, DOValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write PowerOn ValueDO error", L"87k_do_poweron_safe", MB_OK);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton10() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    DWORD fValue = 0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //use pac_ReadDO function
    BOOL iret = pac_ReadModuleSafeValueDO(hPort, slot, TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read Safe ValuedO error", L"87k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read Safe ValuedO: %d", fValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton11() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT2, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteModuleSafeValueDO(hPort, slot, channel, DOValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write Safe ValueDO error", L"87k_do_poweron_safe", MB_OK);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton13() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    DWORD DOValue = 0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_ReadDO_MF(hPort, slot, channel, &DOValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"READ DO error", L"87k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read DO: %d", DOValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton12() 
{
// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT2, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteDO_MF(hPort, slot, channel, DOValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write DO error", L"87k_do_poweron_safe", MB_OK);
    }	
}

void CMy87k_do_poweron_safeDlg::OnButton14() 
{
// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //use pac_WriteDO functio and set DO value be 0 to clear
    BOOL iret = pac_WriteDO_MF(hPort, slot, channel, 0);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Clear DO error", L"87k_do_poweron_safe", MB_OK);
    }	
}

void CMy87k_do_poweron_safeDlg::OnButton15() 
{
// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    DWORD fValue = 0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //use pac_ReadDO function
    BOOL iret = pac_ReadModulePowerOnValueDO_MF(hPort, slot, TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read PowerOn ValuedO error", L"87k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read PowerOn ValuedO: %d", fValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }	
}

void CMy87k_do_poweron_safeDlg::OnButton16() 
{
// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT2, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteModulePowerOnValueDO_MF(hPort, slot, channel, DOValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write PowerOn ValueDO error", L"87k_do_poweron_safe", MB_OK);
    }	
}

void CMy87k_do_poweron_safeDlg::OnButton17() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    DWORD fValue = 0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //use pac_ReadDO function
    BOOL iret = pac_ReadModuleSafeValueDO_MF(hPort, slot, TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read Safe ValuedO error", L"87k_do_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read Safe ValuedO: %d", fValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy87k_do_poweron_safeDlg::OnButton18() 
{
// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    DWORD DOValue = 0;
    CString strTemp;
    char ctemp[20] = {0};

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 10);
    int slot = _wtoi(temp);

    //get user set DO channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    //get user set DO value
    GetDlgItemText(IDC_EDIT2, strTemp);

    for(int i = 0; i < strTemp.GetAllocLength(); i++)
    {
        ctemp[i] = strTemp[i];
    }

    sscanf(ctemp, "%lx", &DOValue);

    //use pac_WriteDO functio to write DO data
    BOOL iret = pac_WriteModuleSafeValueDO_MF(hPort, slot, channel, DOValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write Safe ValueDO error", L"87k_do_poweron_safe", MB_OK);
    }	
}
