// 8k_87k_doDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_87k_do.h"
#include "8k_87k_doDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int iDO_Slot,iDOTotalCh=0;
CString csTmp;
char cTmp[10];
short iSlot;
short iDO_TotalCh;

/////////////////////////////////////////////////////////////////////////////
// CMy8k_87k_doDlg dialog

CMy8k_87k_doDlg::CMy8k_87k_doDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_87k_doDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy8k_87k_doDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_87k_doDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy8k_87k_doDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_EDITDOValue8k, m_editDOValue);
	DDX_Control(pDX, IDC_EDITDOChannels8k, m_editDOChannels);
	DDX_Control(pDX, IDC_COMBODOSlot8k, m_cmbDOSlot);

	DDX_Control(pDX, IDC_COMBODOSlot87k, m_cmbDOSlot2);
	DDX_Text(pDX, IDC_EDITDOValue87k, m_DOValue);
	DDX_Text(pDX, IDC_EDITDOChannels87k, m_DOTotalCh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy8k_87k_doDlg, CDialog)
	//{{AFX_MSG_MAP(CMy8k_87k_doDlg)
	ON_BN_CLICKED(IDC_BUTTONWriteDO8k87k, OnBUTTONWriteDO8k87k)
	ON_BN_CLICKED(IDC_BUTTONDOClear8k87k, OnBUTTONDOClear8k87k)
	ON_BN_CLICKED(IDC_BUTTONWriteDO8k87k2, OnBUTTONWriteDO8k87k2)
	ON_BN_CLICKED(IDC_BUTTONDOClear8k87k2, OnBUTTONDOClear8k87k2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy8k_87k_doDlg message handlers

BOOL CMy8k_87k_doDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbDOSlot.SetCurSel(0);
	m_editDOChannels.SetWindowText (_T("8"));
	m_editDOValue.SetWindowText (_T("FF"));

	m_cmbDOSlot2.SetCurSel(0);
	m_DOTotalCh=_T("8");
	m_DOValue=_T("FF");
	UpdateData(false);

	SetDlgItemText(IDC_EDIT1, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CMy8k_87k_doDlg::OnBUTTONWriteDO8k87k() 
{
	// TODO: Add your control notification handler code here
	DWORD dwDOData;
	bool bRet;
	char cTmp[10];
	unsigned long lDO_Value;
	HANDLE hPort;
	int Type;

	//First open com port	
	hPort = uart_Open("");
	
	//Get slot where the 8k module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();

	Type=pac_GetModuleType(iDO_Slot);
	if(Type==0xe2 || Type==0xc2)
	{
			//The module is DIO module
	} 
	else 
	{
		AfxMessageBox(_T("No 8k module or 8k Module is wrong")); 
		return;
	}

	//Get the slot where the 87K DO module is
	iSlot=m_cmbDOSlot2.GetCurSel ();

	//Get total channels of 8k DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);

	//Get 87k DO Channels value
	UpdateData(true);
	wcstombs(cTmp,m_DOTotalCh,10);
	iDO_TotalCh=atoi(cTmp);

	//Set 8k DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);

	//Get 87k DO value
	UpdateData(true);
	wcstombs(cTmp,m_DOValue,10);
	sscanf(cTmp,"%lx",&lDO_Value);

	//Write 8k DO 
	pac_WriteDO(0, iDO_Slot,iDOTotalCh,dwDOData);

	//Write 87k DO
	bRet = pac_WriteDO( hPort, iSlot,iDO_TotalCh,lDO_Value);
	
	if(bRet==false) AfxMessageBox(_T("No 87k module or 87k module is wrong or something wrong"));
	//Close com port

	uart_Close(hPort);	
}


void CMy8k_87k_doDlg::OnBUTTONDOClear8k87k() 
{
	// TODO: Add your control notification handler code here

	HANDLE hPort;
	hPort = uart_Open("");

	//Clear 8k DO
	pac_WriteDO( 0, iDO_Slot, iDOTotalCh,0);

	//Clear 87k DO
	pac_WriteDO( hPort, iSlot,iDO_TotalCh,0);
	
	uart_Close(hPort);	
}

void CMy8k_87k_doDlg::OnBUTTONWriteDO8k87k2() 
{
	// TODO: Add your control notification handler code here
	DWORD dwDOData;
	bool bRet;
	char cTmp[10];
	unsigned long lDO_Value;
	HANDLE hPort;
	int Type;

	//First open com port	
	hPort = uart_Open("");
	
	//Get slot where the 8k module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();

	Type=pac_GetModuleType(iDO_Slot);
	if(Type==0xe2 || Type==0xc2)
	{
			//The module is DIO module
	} 
	else 
	{
		AfxMessageBox(_T("No 8k module or 8k Module is wrong")); 
		return;
	}

	//Get the slot where the 87K DO module is
	iSlot=m_cmbDOSlot2.GetCurSel ();

	//Get total channels of 8k DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);

	//Get 87k DO Channels value
	UpdateData(true);
	wcstombs(cTmp,m_DOTotalCh,10);
	iDO_TotalCh=atoi(cTmp);

	//Set 8k DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);

	//Get 87k DO value
	UpdateData(true);
	wcstombs(cTmp,m_DOValue,10);
	sscanf(cTmp,"%lx",&lDO_Value);

	//Write 8k DO 
	pac_WriteDO(0, iDO_Slot,iDOTotalCh,dwDOData);

	//Write 87k DO
	bRet = pac_WriteDO_MF( hPort, iSlot,iDO_TotalCh,lDO_Value);
	
	if(bRet==false) AfxMessageBox(_T("No 87k module or 87k module is wrong or something wrong"));
	//Close com port

	uart_Close(hPort);		
}

void CMy8k_87k_doDlg::OnBUTTONDOClear8k87k2() 
{
// TODO: Add your control notification handler code here

	HANDLE hPort;
	hPort = uart_Open("");

	//Clear 8k DO
	pac_WriteDO( 0, iDO_Slot, iDOTotalCh,0);

	//Clear 87k DO
	pac_WriteDO_MF( hPort, iSlot,iDO_TotalCh,0);
	
	uart_Close(hPort);		
}
