// 8k_diDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_di.h"
#include "8k_diDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
int iDI_Slot,iTotalCh;
CString csTmp;
char cTmp[10];
DWORD dwDIValue;
/////////////////////////////////////////////////////////////////////////////
// CMy8k_diDlg dialog

CMy8k_diDlg::CMy8k_diDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_diDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy8k_diDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_diDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy8k_diDlg)
	DDX_Control(pDX, IDC_EDITDIValue, m_editDIValue);
	DDX_Control(pDX, IDC_EDITDIChannels, m_editDIChannels);
	DDX_Control(pDX, IDC_COMBODISlot, m_cmbDISlot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy8k_diDlg, CDialog)
	//{{AFX_MSG_MAP(CMy8k_diDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI, OnBUTTONReadDI)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy8k_diDlg message handlers

BOOL CMy8k_diDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbDISlot.SetCurSel(0);
	m_editDIChannels.SetWindowText (_T("4"));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy8k_diDlg::OnBUTTONReadDI() 
{
	// TODO: Add your control notification handler code here
	int Type;

	//Get slot where the module is
	iDI_Slot=m_cmbDISlot.GetCurSel();
	Type=pac_GetModuleType(iDI_Slot);
	
	if(Type==0xe3 || Type==0xc3){
			//The module is DI module
	} 
	else {
		AfxMessageBox(_T("No module or Module is wrong")); 
		return;
	}
	
	//Get DI value
	m_editDIChannels.GetWindowText (csTmp); 
	wcstombs(cTmp,csTmp,10); 
	iTotalCh=atoi(cTmp);

	pac_ReadDI(0, iDI_Slot,iTotalCh, &dwDIValue);
	
    
	//Show DI value
	sprintf(cTmp,"%lx",dwDIValue);
	csTmp=cTmp;
	m_editDIValue.SetWindowText (csTmp);
}
