// 8k_dioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_dio.h"
#include "8k_dioDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables

int iDIO_Slot,iDITotalCh=0,iDOTotalCh=0;
CString csTmp;
char cTmp[10];
DWORD dwDIValue;


/////////////////////////////////////////////////////////////////////////////
// CMy8k_dioDlg dialog

CMy8k_dioDlg::CMy8k_dioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_dioDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy8k_dioDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_dioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy8k_dioDlg)
	DDX_Control(pDX, IDC_EDITDOValue, m_editDOValue);
	DDX_Control(pDX, IDC_COMBODIOSlot, m_cmbDIOSlot);
	DDX_Control(pDX, IDC_BUTTONClearDO, m_btnClearDO);
	DDX_Control(pDX, IDC_EDITDOChannels, m_editDOChs);
	DDX_Control(pDX, IDC_EDITDIValue, m_editDIValue);
	DDX_Control(pDX, IDC_EDITDIChannels, m_editDIChs);
	DDX_Control(pDX, IDC_BUTTONWriteDO, m_btnWriteDO);
	DDX_Control(pDX, IDC_BUTTONReadDI, m_btnReadDI);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy8k_dioDlg, CDialog)
	//{{AFX_MSG_MAP(CMy8k_dioDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI, OnBUTTONReadDI)
	ON_BN_CLICKED(IDC_BUTTONWriteDO, OnBUTTONWriteDO)
	ON_BN_CLICKED(IDC_BUTTONClearDO, OnBUTTONClearDO)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy8k_dioDlg message handlers

BOOL CMy8k_dioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbDIOSlot.SetCurSel(0);
	m_editDIChs.SetWindowText (_T("4"));
	m_editDOChs.SetWindowText (_T("4"));
	m_editDOValue.SetWindowText (_T("01"));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy8k_dioDlg::OnBUTTONReadDI() 
{
	// TODO: Add your control notification handler code here
	int Type;

	//Get slot where the module is
	iDIO_Slot=m_cmbDIOSlot.GetCurSel();
	
	Type=pac_GetModuleType(iDIO_Slot);
	if(Type==0xe2 || Type==0xc2){
			//The module is DIO module
	} 
	else {
		AfxMessageBox(_T("No module or Module is wrong")); 
		return;
	}

	//Get DI value
	m_editDIChs.GetWindowText (csTmp); 
	wcstombs(cTmp,csTmp,10); 
	iDITotalCh=atoi(cTmp);

	pac_ReadDI(0, iDIO_Slot, iDITotalCh, &dwDIValue);
    
	//Show DI value
	sprintf(cTmp,"%lx",dwDIValue);
	csTmp=cTmp;
	m_editDIValue.SetWindowText (csTmp);

  }


void CMy8k_dioDlg::OnBUTTONWriteDO() 
{
	// TODO: Add your control notification handler code here
	DWORD dwDOData;
	int Type;
	
	//Get slot where the module is
	iDIO_Slot=m_cmbDIOSlot.GetCurSel();
	
	Type=pac_GetModuleType(iDIO_Slot);
	if(Type==0xe2 || Type==0xc2){
			//The module is DIO module
	} 
	else {
		AfxMessageBox(_T("No module or Module is wrong")); 
		return;
	}

	//Get total channels of DO
	m_editDOChs.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);

	//Set DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);

	pac_WriteDO(0, iDIO_Slot,iDOTotalCh,dwDOData);
}

void CMy8k_dioDlg::OnBUTTONClearDO() 
{
	// TODO: Add your control notification handler code here
	//Clear DO value
	
	pac_WriteDO( 0, iDIO_Slot, iDOTotalCh, 0);

	m_editDOValue.SetWindowText (_T("00"));
}
