// pac8017HDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "pac8017HDemo.h"
#include "pac8017HDemoDlg.h"


	#include "wincon.h"
	#include <math.h>
	#include "pac_i8017HW.h"



/*
#ifdef _WINCON_
include "wincon.h"
	#include <math.h>
	#include "pac_i8017HW.h"
	#define pac_GetModuleName GetNameOfModule
#endif
*/

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static int slotIndex; //=0

static int typeCode;

static int gainMode;

static int exitFlag=0;

static long loopCnt=0;

float AIVal[8][16];
float PreAI[16];

int AIHex[8][16];
int PreHex[16];
short jumper=0;
short firm=0;

/////////////////////////////////////////////////////////////////////////////
// CPac8017HDemoDlg dialog

CPac8017HDemoDlg::CPac8017HDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPac8017HDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPac8017HDemoDlg)
	m_dly = 0;
	m_loop = 1;
	m_check = FALSE;
	m_hex = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPac8017HDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPac8017HDemoDlg)
	DDX_Control(pDX, IDC_CH9, m_ch9);
	DDX_Control(pDX, IDC_CH8, m_ch8);
	DDX_Control(pDX, IDC_CH7, m_ch7);
	DDX_Control(pDX, IDC_CH6, m_ch6);
	DDX_Control(pDX, IDC_CH5, m_ch5);
	DDX_Control(pDX, IDC_CH4, m_ch4);
	DDX_Control(pDX, IDC_CH3, m_ch3);
	DDX_Control(pDX, IDC_CH2, m_ch2);
	DDX_Control(pDX, IDC_CH15, m_ch15);
	DDX_Control(pDX, IDC_CH14, m_ch14);
	DDX_Control(pDX, IDC_CH13, m_ch13);
	DDX_Control(pDX, IDC_CH12, m_ch12);
	DDX_Control(pDX, IDC_CH11, m_ch11);
	DDX_Control(pDX, IDC_CH10, m_ch10);
	DDX_Control(pDX, IDC_CH1, m_ch1);
	DDX_Control(pDX, IDC_CH0, m_ch0);
	DDX_Control(pDX, IDC_TYPE, m_type);
	DDX_Control(pDX, IDC_SLOT, m_slot);
	DDX_Text(pDX, IDC_DELAY, m_dly);
	DDX_Text(pDX, IDC_LOOP, m_loop);
	DDX_Check(pDX, IDC_CHECK, m_check);
	DDX_Check(pDX, IDC_Hex, m_hex);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPac8017HDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CPac8017HDemoDlg)
	ON_CBN_SELCHANGE(IDC_SLOT, OnSelchangeSlot)
	ON_BN_CLICKED(IDC_Exit, OnExit)
	ON_BN_CLICKED(IDC_AI, OnAi)
	ON_CBN_SELCHANGE(IDC_TYPE, OnSelchangeType)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SELECTALL, OnSelectall)
	ON_BN_CLICKED(IDC_CLEARALL, OnClearall)
//	ON_BN_CLICKED(IDC_CALI, OnCali)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPac8017HDemoDlg message handlers

BOOL CPac8017HDemoDlg::OnInitDialog()
{
	int i;
	CString str,typeStr[6];
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
 /*   
    iChannel: 0~7
    iGain:  0 ==>   +/- 10.0  V
            1 ==>   +/-  5.0  V
            2 ==>   +/-  2.5  V
            3 ==>   +/-  1.25 V
            4 ==>   +/- 20.0  mA
*/
	typeStr[0]="Voltage +/- 10.0 V ";
	typeStr[1]="Voltage +/-  5.0 V ";
	typeStr[2]="Voltage +/-  2.5 V ";
	typeStr[3]="Voltage +/-  1.25 V ";
	typeStr[4]="Voltage +/- 20.0 mA ";

	for (i=0 ;i <8 ; i++)
	{
		str.Format(_T("Slot %d"),i);
		m_slot.AddString(str);
	}
	m_slot.SetCurSel(0);



	for(i=0;i<5;i++)
	{
		m_type.AddString (typeStr[i]);
	}
	// TODO: Add extra initialization here


	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CPac8017HDemoDlg::OnSelchangeSlot() 
{
	// TODO: Add your control notification handler code here
	char libDate[32];
	CString SingleEndedStr[2],str;
	CString LibDate;
	
	SingleEndedStr[0]="Differential";
	SingleEndedStr[1]="Single Ended";
	UpdateData(false);
	slotIndex=m_slot.GetCurSel();
	m_slot.SetCurSel(slotIndex);
	pac_i8017HW_Init(slotIndex);	
	pac_i8017HW_GetSingleEndJumper(slotIndex, &jumper);

//	printf("Jumper + %d\n",	pac_i8017HW_Get_SingleEndJumper(slotIndex));
	SetDlgItemText(IDC_JUMPER,SingleEndedStr[jumper]);


//	pac_i8017HW
		  //pac_i8017HW_Set_MUXReadyTime
	//m_dly=pac_i8017HW_Get_MUXReadyTime();
//	printf("Delay time %d \n",m_dly);
	//str.Format(_T("%d"),m_dly);
//	SetDlgItemText(IDC_DELAY,str);
	

	// TODO: Add your control notification handler code here

	str.Format(_T("%04X"),pac_i8017HW_GetLibVersion());
	SetDlgItemText(IDC_LIBVER,str);

	pac_i8017HW_GetLibDate(libDate);
	str=libDate;
	//str.Format(_T("%s"),LibDate);
	SetDlgItemText(IDC_LIBDATE,str);

	pac_i8017HW_GetFirmwareVersion(slotIndex,&firm);
	str.Format(_T("%04X"),firm);
	SetDlgItemText(IDC_FIRMWARE,str);

}

void CPac8017HDemoDlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	exit(0);
}
int check=0;
	short iVal,imax[16],imin[16];
	float fVal,max[16],min[16];

void CPac8017HDemoDlg::OnAi() 
{
	
	// TODO: Add your control notification handler code here
	int ch;
	short ret;
	int ifReadFloat=1;
	CString str;
    long ST;

    int enCheck[16];
	UpdateData(true);
	int totalCh=8;
	exitFlag=0;
	loopCnt=0;
	ST=GetTickCount();
	//pac_i8017HW_Set_MUXReadyTime(m_dly);
	//pac_i8017HW_Set_MUXReadyTime


    enCheck[0]=m_ch0.GetCheck();
	enCheck[1]=m_ch1.GetCheck();
	enCheck[2]=m_ch2.GetCheck();
	enCheck[3]=m_ch3.GetCheck();
	enCheck[4]=m_ch4.GetCheck();
	enCheck[5]=m_ch5.GetCheck();
	enCheck[6]=m_ch6.GetCheck();
	enCheck[7]=m_ch7.GetCheck();
	enCheck[8]=m_ch8.GetCheck();
	enCheck[9]=m_ch9.GetCheck();
	enCheck[10]=m_ch10.GetCheck();
	enCheck[11]=m_ch11.GetCheck();
	enCheck[12]=m_ch12.GetCheck();
	enCheck[13]=m_ch13.GetCheck();
	enCheck[14]=m_ch14.GetCheck();
	enCheck[15]=m_ch15.GetCheck();

	str.Format(_T("LoopCnt = %lu  Ticks = 0 ms"),loopCnt );
	SetWindowText(str);

	if(jumper==1) //Single Ended Mode
	{
		
		totalCh=16;
	}
	else
	{
		totalCh=8;
	}


	while(!exitFlag)
	{
		for(ch=0;ch<totalCh;ch++)
		{
			if(enCheck[ch])
			{
			
				//	Sleep(1);
				if(m_hex)
				{
					ret=pac_i8017HW_ReadAIHex(slotIndex,ch,gainMode,&iVal);
					if(ret==0)
					{
						
					//	printf("[%d][%d]=%04X\n",slotIndex,ch,iVal);
						AIHex[slotIndex][ch]=iVal;
						//SetDlgItemText(IDC_VAL0+ch,str);
					}
					else
					{
						printf("ReadAIHex Error Code = %d\n",ret);
					}
				}
				else
				{
					ret=pac_i8017HW_ReadAI(slotIndex,ch,gainMode,&fVal);
					if(ret==0)
					{
					//	printf("[%d][%d]=%.3f\n",slotIndex,ch,fVal);
						AIVal[slotIndex][ch]=fVal;
					}
					else
					{
						printf("ReadAI Error Code = %d\n",ret);
					}
					
				}
		//	}
				
				if(check==0)
				{
					if(m_hex)
					{
						imin[ch]=iVal;
						imax[ch]=iVal;
					}
					else
					{
						min[ch]=fVal;
						max[ch]=fVal;
					}
					
				}

				if(m_check)
				{
					if(m_hex)
					{
						if(iVal > imax[ch])
							imax[ch]=iVal;
						if(iVal < imin[ch])
							imin[ch]=iVal;
						str.Format(_T("%04X[%04X][%04X][%04X]"),iVal,imax[ch],imin[ch],imax[ch]-imin[ch]);
					}
					else
					{

						if(fVal > max[ch])
							max[ch]=fVal;
						if(fVal < min[ch])
							min[ch]=fVal;
						str.Format(_T("%.3f[%.3f][%.3f][%.3f]"),fVal,max[ch],min[ch],max[ch]-min[ch]);
					}
					SetDlgItemText(IDC_VAL0+ch,str);
				}
			}
		//	Sleep(100);
		}
		check=1;

		loopCnt++;
		if(m_check)
		{
			str.Format(_T("LoopCnt = %lu  Ticks = %lu ms"),loopCnt,GetTickCount()-ST );
			SetWindowText(str);
		}
		if(m_loop!=0)
		{
			if(loopCnt >= m_loop)
			{
				str.Format(_T("LoopCnt = %lu  Ticks = %lu ms"),loopCnt,GetTickCount()-ST );
				SetWindowText(str);

				exitFlag=1;
			}
		}
	
	}
		
			
	
	
	
}

void CPac8017HDemoDlg::OnSelchangeType() 
{
	unsigned short gainValue=0;
	short offsetValue=0;

	CString str;
//	str.Format(_T("%s"),pac_i8017HW_GetLibDate());
//	SetDlgItemText(IDC_LIBDATE,str);
	
	UpdateData(true);
	gainMode=m_type.GetCurSel();

	pac_i8017HW_ReadGainOffset_Info(slotIndex,gainMode,&gainValue,&offsetValue);
	str.Format(_T("%u"),gainValue);
	SetDlgItemText(IDC_GAIN,str);
	str.Format(_T("%d"),offsetValue);
	SetDlgItemText(IDC_OFFSET,str);
	
	//printf("gainMode = %d \n",gainMode);
}

void CPac8017HDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default


	
	CDialog::OnTimer(nIDEvent);
}

void CPac8017HDemoDlg::OnSelectall() 
{
	// TODO: Add your control notification handler code here
    m_ch0.SetCheck(1);
	m_ch1.SetCheck(1);
	m_ch2.SetCheck(1);
	m_ch3.SetCheck(1);
	m_ch4.SetCheck(1);
	m_ch5.SetCheck(1);
	m_ch6.SetCheck(1);
	m_ch7.SetCheck(1);
	m_ch8.SetCheck(1);
	m_ch9.SetCheck(1);
	m_ch10.SetCheck(1);
	m_ch11.SetCheck(1);
	m_ch12.SetCheck(1);
	m_ch13.SetCheck(1);
	m_ch14.SetCheck(1);
	m_ch15.SetCheck(1);
	
}

void CPac8017HDemoDlg::OnClearall() 
{
    m_ch0.SetCheck(0);
	m_ch1.SetCheck(0);
	m_ch2.SetCheck(0);
	m_ch3.SetCheck(0);
	m_ch4.SetCheck(0);
	m_ch5.SetCheck(0);
	m_ch6.SetCheck(0);
	m_ch7.SetCheck(0);
	m_ch8.SetCheck(0);
	m_ch9.SetCheck(0);
	m_ch10.SetCheck(0);
	m_ch11.SetCheck(0);
	m_ch12.SetCheck(0);
	m_ch13.SetCheck(0);
	m_ch14.SetCheck(0);
	m_ch15.SetCheck(0);	
}


