// pac_i8172WDIODlg.cpp : implementation file
//
#pragma comment(lib,"pac_i8172W.lib")
#include "stdafx.h"
#include "pac_i8172WDIO.h"
#include "pac_i8172WDIODlg.h"
#include "pac_i8172W.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPac_i8172WDIODlg dialog
int slotIndex=-1,portIndex=-1,di_groupIndex=-1,do_groupIndex=-1,dio_groupIndex=-1;

CPac_i8172WDIODlg::CPac_i8172WDIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPac_i8172WDIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPac_i8172WDIODlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPac_i8172WDIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPac_i8172WDIODlg)
	DDX_Control(pDX, IDC_DIO_DO7, m_dio_do7);
	DDX_Control(pDX, IDC_DIO_DO6, m_dio_do6);
	DDX_Control(pDX, IDC_DIO_DO5, m_dio_do5);
	DDX_Control(pDX, IDC_DIO_DO4, m_dio_do4);
	DDX_Control(pDX, IDC_DIO_DO3, m_dio_do3);
	DDX_Control(pDX, IDC_DIO_DO2, m_dio_do2);
	DDX_Control(pDX, IDC_DIO_DO1, m_dio_do1);
	DDX_Control(pDX, IDC_DIO_DO0, m_dio_do0);
	DDX_Control(pDX, IDC_DO_9, m_do09);
	DDX_Control(pDX, IDC_DO_8, m_do08);
	DDX_Control(pDX, IDC_DO_7, m_do07);
	DDX_Control(pDX, IDC_DO_6, m_do06);
	DDX_Control(pDX, IDC_DO_5, m_do05);
	DDX_Control(pDX, IDC_DO_4, m_do04);
	DDX_Control(pDX, IDC_DO_3, m_do03);
	DDX_Control(pDX, IDC_DO_2, m_do02);
	DDX_Control(pDX, IDC_DO_15, m_do15);
	DDX_Control(pDX, IDC_DO_14, m_do14);
	DDX_Control(pDX, IDC_DO_13, m_do13);
	DDX_Control(pDX, IDC_DO_12, m_do12);
	DDX_Control(pDX, IDC_DO_11, m_do11);
	DDX_Control(pDX, IDC_DO_10, m_do10);
	DDX_Control(pDX, IDC_DO_1, m_do01);
	DDX_Control(pDX, IDC_DO_0, m_do00);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPac_i8172WDIODlg, CDialog)
	//{{AFX_MSG_MAP(CPac_i8172WDIODlg)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_CBN_SELCHANGE(IDC_SLOT, OnSelchangeSlot)
	ON_CBN_SELCHANGE(IDC_GROUPDO, OnSelchangeGroupdo)
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_CBN_SELCHANGE(IDC_GROUPDI, OnSelchangeGroupdi)
	ON_CBN_SELCHANGE(IDC_GROUPDIO, OnSelchangeGroupdio)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_DO_0, OnDo0)
	ON_BN_CLICKED(IDC_DO_1, OnDo1)
	ON_BN_CLICKED(IDC_DO_2, OnDo2)
	ON_BN_CLICKED(IDC_DO_3, OnDo3)
	ON_BN_CLICKED(IDC_DO_4, OnDo4)
	ON_BN_CLICKED(IDC_DO_5, OnDo5)
	ON_BN_CLICKED(IDC_DO_6, OnDo6)
	ON_BN_CLICKED(IDC_DO_7, OnDo7)
	ON_BN_CLICKED(IDC_DO_8, OnDo8)
	ON_BN_CLICKED(IDC_DO_9, OnDo9)
	ON_BN_CLICKED(IDC_DO_10, OnDo10)
	ON_BN_CLICKED(IDC_DO_11, OnDo11)
	ON_BN_CLICKED(IDC_DO_12, OnDo12)
	ON_BN_CLICKED(IDC_DO_13, OnDo13)
	ON_BN_CLICKED(IDC_DO_14, OnDo14)
	ON_BN_CLICKED(IDC_DO_15, OnDo15)
	ON_BN_CLICKED(IDC_DIO_DO0, OnDioDo0)
	ON_BN_CLICKED(IDC_DIO_DO1, OnDioDo1)
	ON_BN_CLICKED(IDC_DIO_DO2, OnDioDo2)
	ON_BN_CLICKED(IDC_DIO_DO3, OnDioDo3)
	ON_BN_CLICKED(IDC_DIO_DO4, OnDioDo4)
	ON_BN_CLICKED(IDC_DIO_DO5, OnDioDo5)
	ON_BN_CLICKED(IDC_DIO_DO6, OnDioDo6)
	ON_BN_CLICKED(IDC_DIO_DO7, OnDioDo7)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPac_i8172WDIODlg message handlers

BOOL CPac_i8172WDIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CPac_i8172WDIODlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	KillTimer(10);
	exit(0);
}

void CPac_i8172WDIODlg::OnSelchangeSlot() 
{
	// TODO: Add your control notification handler code here
	int ret = -1;
	CString str,dateStr;
	char libDate[32];
	int ch;
	int res=-1;
	int findio=0;
	CComboBox *cbo;
	

	cbo  = (CComboBox*) GetDlgItem(IDC_SLOT);

	ret=pac_i8172W_Init(cbo->GetCurSel());
	if(ret==0)
	{
		slotIndex=cbo->GetCurSel();	
		pac_i8172W_GetLibDate(libDate);
		dateStr=libDate;
		str.Format(_T("8172W Lib Built:%s Ver:%04X"),dateStr,pac_i8172W_GetLibVersion());
		SetWindowText(str);	
		findio=1;
	}

	if(findio==0)
	{
	
		str.Format(_T("Not found 8172W at slot"));
		MessageBox( str, TEXT("Error"),MB_OK);
	}
}

void CPac_i8172WDIODlg::OnSelchangeGroupdo() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_GROUPDO);
	do_groupIndex=cbo->GetCurSel();	
}

void CPac_i8172WDIODlg::OnSelchangePort() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_PORT);
	portIndex=cbo->GetCurSel();	
}

void CPac_i8172WDIODlg::OnSelchangeGroupdi() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_GROUPDI);
	di_groupIndex=cbo->GetCurSel();	
	
}

void CPac_i8172WDIODlg::OnSelchangeGroupdio() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_GROUPDIO);
	dio_groupIndex=cbo->GetCurSel();	
	
}

void CPac_i8172WDIODlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	int GroupStatus,DIOGroupStatus;
	unsigned int  diBit;
	int i;
	CString str;
	unsigned short  EnBitArr[16] ={0x0001,0x0002,0x0004,0x0008,0x0010,0x0020,0x0040,0x0080,
							0x0100,0x0200,0x0400,0x0800,0x1000,0x2000,0x4000,0x8000};
	if(di_groupIndex>=0)
	{
		for(i=0;i<16;i++)
		{
			diBit = pac_i8172W_ReadDIBit(slotIndex,portIndex,di_groupIndex +8,i);
			if(diBit==1)
			{
				SetDlgItemText(IDC_DI_0+i, _T("1"));
			}
			else
			{
				SetDlgItemText(IDC_DI_0+i, _T("0"));
			}
			
		}
		GroupStatus=pac_i8172W_ReadInputGroupStatus(slotIndex,portIndex,di_groupIndex +8);
		if(GroupStatus)
		{
			SetDlgItemText(IDC_GROUPSTATUS, _T("ON_LINE"));
		}
		else
		{
			SetDlgItemText(IDC_GROUPSTATUS, _T("OFF_LINE"));
		}
	}

	if(dio_groupIndex >=0)
	{
		DIOGroupStatus=pac_i8172W_ReadInputGroupStatus(slotIndex,portIndex,dio_groupIndex +8);
		if(GroupStatus)
		{
			SetDlgItemText(IDC_DIOGROUPSTATUS, _T("ON_LINE"));
		}
		else
		{
			SetDlgItemText(IDC_DIOGROUPSTATUS, _T("OFF_LINE"));
		}
		for(i=0;i<8;i++)
		{
			diBit=pac_i8172W_DIO_ReadDIBit(slotIndex,portIndex,dio_groupIndex +8,i);

			if(diBit==1)
			{
				SetDlgItemText(IDC_DIO_DI0+i, _T("1"));
			}
			else
			{
				SetDlgItemText(IDC_DIO_DI0+i, _T("0"));
			}
		}		
	}	
	CDialog::OnTimer(nIDEvent);
}

void CPac_i8172WDIODlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	SetTimer(10, 100, NULL);
}

void CPac_i8172WDIODlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	KillTimer(10);
}

void CPac_i8172WDIODlg::OnDo0() 
{
	// TODO: Add your control notification handler code here
	int ch=0;
	if(m_do00.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);	
}

void CPac_i8172WDIODlg::OnDo1() 
{
	// TODO: Add your control notification handler code here
	int ch=1;
	if(m_do01.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);		
}

void CPac_i8172WDIODlg::OnDo2() 
{
	// TODO: Add your control notification handler code here
	int ch=2;
	if(m_do02.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo3() 
{
	// TODO: Add your control notification handler code here
	int ch=3;
	if(m_do03.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo4() 
{
	// TODO: Add your control notification handler code here
	int ch=4;
	if(m_do04.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo5() 
{
	// TODO: Add your control notification handler code here
	int ch=5;
	if(m_do05.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo6() 
{
	// TODO: Add your control notification handler code here
	int ch=6;
	if(m_do06.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo7() 
{
	// TODO: Add your control notification handler code here
	int ch=7;
	if(m_do07.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo8() 
{
	// TODO: Add your control notification handler code here
	int ch=8;
	if(m_do08.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo9() 
{
	// TODO: Add your control notification handler code here
	int ch=9;
	if(m_do09.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo10() 
{
	// TODO: Add your control notification handler code here
	int ch=10;
	if(m_do10.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo11() 
{
	// TODO: Add your control notification handler code here
	int ch=11;
	if(m_do11.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo12() 
{
	// TODO: Add your control notification handler code here
	int ch=12;
	if(m_do12.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo13() 
{
	// TODO: Add your control notification handler code here
	int ch=13;
	if(m_do13.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo14() 
{
	// TODO: Add your control notification handler code here
	int ch=14;
	if(m_do14.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDo15() 
{
	// TODO: Add your control notification handler code here
	int ch=15;
	if(m_do15.GetCheck()==1)
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,1);
	else
		pac_i8172W_WriteDOBit(slotIndex,portIndex,do_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDioDo0() 
{
	// TODO: Add your control notification handler code here
	int ch=0;
	if(m_dio_do0.GetCheck()==1)
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,1);
	else
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,0);				
}

void CPac_i8172WDIODlg::OnDioDo1() 
{
	// TODO: Add your control notification handler code here
	int ch=1;
	if(m_dio_do1.GetCheck()==1)
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,1);
	else
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDioDo2() 
{
	// TODO: Add your control notification handler code here
	int ch=2;
	if(m_dio_do2.GetCheck()==1)
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,1);
	else
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDioDo3() 
{
	// TODO: Add your control notification handler code here
	int ch=3;
	if(m_dio_do3.GetCheck()==1)
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,1);
	else
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDioDo4() 
{
	// TODO: Add your control notification handler code here
	int ch=4;
	if(m_dio_do4.GetCheck()==1)
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,1);
	else
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDioDo5() 
{
	// TODO: Add your control notification handler code here
	int ch=5;
	if(m_dio_do5.GetCheck()==1)
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,1);
	else
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDioDo6() 
{
	// TODO: Add your control notification handler code here
	int ch=6;
	if(m_dio_do6.GetCheck()==1)
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,1);
	else
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,0);			
}

void CPac_i8172WDIODlg::OnDioDo7() 
{
	// TODO: Add your control notification handler code here
	int ch=7;
	if(m_dio_do7.GetCheck()==1)
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,1);
	else
		pac_i8172W_DIO_WriteDOBit(slotIndex,portIndex,dio_groupIndex,ch,0);			
}
