// pac_8172WriteAODlg.cpp : implementation file
//

#include "stdafx.h"
#include "pac_8172WriteAO.h"
#include "pac_8172WriteAODlg.h"
#include "pac_i8172W.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPac_8172WriteAODlg dialog
short slotIndex,port,group,jumper,bitMode;

CPac_8172WriteAODlg::CPac_8172WriteAODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPac_8172WriteAODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPac_8172WriteAODlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPac_8172WriteAODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPac_8172WriteAODlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPac_8172WriteAODlg, CDialog)
	//{{AFX_MSG_MAP(CPac_8172WriteAODlg)
	ON_BN_CLICKED(IDC_EXIT, OnExit)
	ON_CBN_SELCHANGE(IDC_SLOT, OnSelchangeSlot)
	ON_CBN_SELCHANGE(IDC_PORT, OnSelchangePort)
	ON_CBN_SELCHANGE(IDC_GROUP, OnSelchangeGroup)
	ON_BN_CLICKED(IDC_WAO_0, OnWao0)
	ON_BN_CLICKED(IDC_WAO_1, OnWao1)
	ON_BN_CLICKED(IDC_WAO_2, OnWao2)
	ON_BN_CLICKED(IDC_WAO_3, OnWao3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPac_8172WriteAODlg message handlers

BOOL CPac_8172WriteAODlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	CComboBox *cbo;
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	int i;
	for(i=0;i<4;i++)
	{
		cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_0 + i);
		cbo->SetCurSel(3); // type code = 0x33 +-10 V
	}

	bitMode = 12 ; //default
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CPac_8172WriteAODlg::OnExit() 
{
	// TODO: Add your control notification handler code here
	exit(0);
}

void CPac_8172WriteAODlg::OnSelchangeSlot() 
{
	// TODO: Add your control notification handler code here
	int ret = -1;
	CComboBox *cbo;
	CString str;

	cbo  = (CComboBox*) GetDlgItem(IDC_SLOT);

	ret=pac_i8172W_Init(cbo->GetCurSel());
	if(ret==0)
	{
		slotIndex=cbo->GetCurSel();	
	}
	else
	{
		str.Format(_T("Does not find I-8172W at slot %d"),cbo->GetCurSel());
		MessageBox( str, TEXT("Error"),MB_OK);
	}	
}

void CPac_8172WriteAODlg::OnSelchangePort() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_PORT);
	port=cbo->GetCurSel() ;	
}

void CPac_8172WriteAODlg::OnSelchangeGroup() 
{
	// TODO: Add your control notification handler code here
	CComboBox *cbo;
	cbo  = (CComboBox*) GetDlgItem(IDC_GROUP);
	group=cbo->GetCurSel() ;	
}

void CPac_8172WriteAODlg::OnWao0() 
{
	// TODO: Add your control notification handler code here
	double aoFloat;
	CComboBox *cbo;
	CEdit *edit;
	CString str;
	short ifDelay =0;
	short typeCode;
	cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_0);
	typeCode = cbo->GetCurSel()+0x30;
	edit = (CEdit*) GetDlgItem(IDC_AO_0);  
	edit->GetWindowText(str);

	TCHAR sz[1024],*tmp;
	lstrcpy(sz,str);
	aoFloat = _tcstod(sz,&tmp);
	
	pac_i8172W_WriteAOFloat(slotIndex,port,group,bitMode, 0,  typeCode, aoFloat, ifDelay);
}

void CPac_8172WriteAODlg::OnWao1() 
{
	// TODO: Add your control notification handler code here
	double aoFloat;
	CComboBox *cbo;
	CEdit *edit;
	CString str;
	short ifDelay =0;
	short typeCode;
	cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_1);
	typeCode = cbo->GetCurSel() +0x30;
	edit = (CEdit*) GetDlgItem(IDC_AO_1);  
	edit->GetWindowText(str);

	TCHAR sz[1024],*tmp;
	lstrcpy(sz,str);
	aoFloat = _tcstod(sz,&tmp);
	
	pac_i8172W_WriteAOFloat(slotIndex,port,group,bitMode, 1,  typeCode, aoFloat, ifDelay);	
}

void CPac_8172WriteAODlg::OnWao2() 
{
	// TODO: Add your control notification handler code here
	double aoFloat;
	CComboBox *cbo;
	CEdit *edit;
	CString str;
	short ifDelay =0;
	short typeCode;
	cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_2);
	typeCode = cbo->GetCurSel()+0x30;
	edit = (CEdit*) GetDlgItem(IDC_AO_2);  
	edit->GetWindowText(str);

	TCHAR sz[1024],*tmp;
	lstrcpy(sz,str);
	aoFloat = _tcstod(sz,&tmp);
	
	pac_i8172W_WriteAOFloat(slotIndex,port,group,bitMode, 2,  typeCode, aoFloat, ifDelay);	
}

void CPac_8172WriteAODlg::OnWao3() 
{
	// TODO: Add your control notification handler code here
	double aoFloat;
	CComboBox *cbo;
	CEdit *edit;
	CString str;
	short ifDelay =0;
	short typeCode;
	cbo  = (CComboBox*) GetDlgItem(IDC_TYPE_3);
	typeCode = cbo->GetCurSel()+0x30;
	edit = (CEdit*) GetDlgItem(IDC_AO_3);  
	edit->GetWindowText(str);

	TCHAR sz[1024],*tmp;
	lstrcpy(sz,str);
	aoFloat = _tcstod(sz,&tmp);
	
	pac_i8172W_WriteAOFloat(slotIndex,port,group,bitMode, 3,  typeCode, aoFloat, ifDelay);	
}
