// 7k87k_BasicDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k87k_Basic.h"
#include "7k87k_BasicDlg.h"

#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
unsigned char cCom;
static char SendBuf[20];
static char RecBuf[1024];
/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_BasicDlg dialog

CMy7k87k_BasicDlg::CMy7k87k_BasicDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k87k_BasicDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7k87k_BasicDlg)
	m_strCmd = _T("");
	m_strRes = _T("");
	m_lBaud = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k87k_BasicDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7k87k_BasicDlg)
	DDX_Control(pDX, IDC_COMBOCom, m_cmbCom);
	DDX_Text(pDX, IDC_EDITSend, m_strCmd);
	DDX_Text(pDX, IDC_EDITResponse, m_strRes);
	DDX_Text(pDX, IDC_EDITBaud, m_lBaud);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7k87k_BasicDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7k87k_BasicDlg)
	ON_BN_CLICKED(IDC_BUTTONOpenCom, OnBUTTONOpenCom)
	ON_BN_CLICKED(IDC_BUTTONCloseCom, OnBUTTONCloseCom)
	ON_BN_CLICKED(IDC_BUTTONSend, OnBUTTONSend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_BasicDlg message handlers

BOOL CMy7k87k_BasicDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbCom.SetCurSel(2);
	m_lBaud=115200;
	m_strCmd=_T("$01M");
	UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

HANDLE hPort;

void CMy7k87k_BasicDlg::OnBUTTONOpenCom() 
{
	// TODO: Add your control notification handler code here	
	DWORD ret_error;
	//Open com port
	
	UpdateData(true);
	cCom=m_cmbCom.GetCurSel();
	char buffer[64];
	int j;

	j = sprintf(buffer, "COM%d:", cCom);
	sprintf(buffer+j , ",%d", m_lBaud);
	hPort = uart_Open(buffer);

	ret_error = pac_GetLastError();

	if(!(ret_error == (DWORD) INVALID_HANDLE_VALUE )) AfxMessageBox(_T("Open Com Error"));
}

void CMy7k87k_BasicDlg::OnBUTTONCloseCom() 
{
	// TODO: Add your control notification handler code here
	uart_Close(hPort);
}

void CMy7k87k_BasicDlg::OnBUTTONSend() 
{
	// TODO: Add your control notification handler code here
	WORD wTimeout=100,wChecksum=0;

	memset(SendBuf,'\0',sizeof(SendBuf));
	UpdateData(true); //update m_strCmd
	wcstombs(SendBuf,m_strCmd,20);
	uart_SendCmdExt( hPort, SendBuf, sizeof(SendBuf), RecBuf, sizeof(RecBuf));	
	m_strRes=RecBuf;
	UpdateData(false);
}

