// 7k87k_aoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k87k_ao.h"
#include "7k87k_aoDlg.h"
#include "PACSDK.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
unsigned char cPort;

/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_aoDlg dialog

CMy7k87k_aoDlg::CMy7k87k_aoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k87k_aoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7k87k_aoDlg)
	m_strAddr = _T("");
	m_iAOChs = 0;
	m_fAOValue = 0.0f;
	m_dwBaud = 0;
	m_iWWhichCh = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k87k_aoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7k87k_aoDlg)
	DDX_Control(pDX, IDC_COMBOCom, m_cmbCom);
	DDX_Text(pDX, IDC_EDITAddr, m_strAddr);
	DDX_Text(pDX, IDC_EDITAOChs, m_iAOChs);
	DDX_Text(pDX, IDC_EDITAOValue, m_fAOValue);
	DDX_Text(pDX, IDC_EDITBaud, m_dwBaud);
	DDX_Text(pDX, IDC_EDITRWhichCh, m_iWWhichCh);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7k87k_aoDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7k87k_aoDlg)
	ON_BN_CLICKED(IDC_BUTTONWriteAO, OnBUTTONWriteAO)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_aoDlg message handlers

BOOL CMy7k87k_aoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbCom.SetCurSel(2);
	m_strAddr=_T("03");
	m_dwBaud=115200;
	m_iAOChs=4;
	m_iWWhichCh=3;
	UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy7k87k_aoDlg::OnBUTTONWriteAO() 
{
	// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[10];	
	char ConnectionString[32];
	
	UpdateData(true);
	int cPort=m_cmbCom.GetCurSel();  //com 0, 1, 2, 3, 4
	
	//Get module address
	wcstombs(cTmp, m_strAddr, 10);
	sscanf(cTmp,"%x",&iAddr);

	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);
	
	HANDLE hPort = uart_Open(ConnectionString);
	if(! hPort) AfxMessageBox(_T("Open Com Error"));

	//Write AO value to remote module
	pac_WriteAO( hPort, PAC_REMOTE_IO(iAddr), m_iWWhichCh, m_iAOChs, m_fAOValue);	
	uart_Close(hPort);
}
