// 7k_cntDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_cnt.h"
#include "7k_cntDlg.h"

#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy7k_cntDlg dialog

CMy7k_cntDlg::CMy7k_cntDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k_cntDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7k_cntDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_cntDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7k_cntDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7k_cntDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7k_cntDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7k_cntDlg message handlers

BOOL CMy7k_cntDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

HANDLE hPort;

void CMy7k_cntDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	TCHAR OpenPort[10];
    TCHAR temp[20];
    char port[20];

    //get user set com port and buad rate
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    GetDlgItemText(IDC_EDIT2, temp, 20);
    int BuadRate = _wtoi(temp);

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    //if hPort value is INVALID_HANDLE_VALUE , that is error
    if(hPort == INVALID_HANDLE_VALUE)
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_di", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
    }
}

void CMy7k_cntDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	if(!uart_Close(hPort))
    {
        ::MessageBox(NULL, L"Close Port Error", L"7k_di", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
    }
}

void CMy7k_cntDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);
    DWORD DIValue;

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ReadCNT(hPort, slot, DICNTchannel, &DIValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_cnt", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%d", DIValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy7k_cntDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);
    DWORD DIValue;

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ClearCNT(hPort, slot, DICNTchannel);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_cnt", MB_OK);
    }
}

void CMy7k_cntDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);
    int DIValue;

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ReadCNTOverflow(hPort, slot, DICNTchannel, &DIValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_cnt", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%d", DIValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}
