// InterruptDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Interrupt.h"
#include "InterruptDlg.h"

#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInterruptDlg dialog

CInterruptDlg::CInterruptDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInterruptDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInterruptDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CInterruptDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInterruptDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CInterruptDlg, CDialog)
	//{{AFX_MSG_MAP(CInterruptDlg)
	ON_BN_CLICKED(IDC_ENABLE, OnEnable)
	ON_BN_CLICKED(IDC_DISABLE, OnDisable)
	ON_BN_CLICKED(IDC_REGINTR, OnRegintr)
	ON_BN_CLICKED(IDC_UNREGINTR, OnUnregintr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInterruptDlg message handlers

BOOL CInterruptDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


int CALLBACK demo_callback_proc7()
{
	static int c = 0;
	PAC_OUTP(0x1000*(1+7)+0xAAA, c++%0x7F);
	PAC_OUTP(0X1000*(1+7)+0x4, c++%0x7F);
	return 0;
}

void CInterruptDlg::OnEnable() 
{
	// TODO: Add your control notification handler code here
   pac_EnableSlotInterrupt(7, true);
   PAC_OUTP(0x1000*(1+7)+0x4, 6);

}

void CInterruptDlg::OnDisable() 
{
	// TODO: Add your control notification handler code here
	pac_EnableSlotInterrupt(7, false);
}

void CInterruptDlg::OnRegintr() 
{
	// TODO: Add your control notification handler code here
	pac_RegisterSlotInterrupt(7, demo_callback_proc7);	
}

void CInterruptDlg::OnUnregintr() 
{
	// TODO: Add your control notification handler code here
   pac_UnregisterSlotInterrupt(7);	
}
