// MemoryDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Memory.h"
#include "MemoryDlg.h"

#include "WinPacSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMemoryDlg dialog

CMemoryDlg::CMemoryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMemoryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMemoryDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMemoryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMemoryDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMemoryDlg, CDialog)
	//{{AFX_MSG_MAP(CMemoryDlg)
	//ON_BN_CLICKED(IDC_SizeEEP, OnSizeEEP)
	//ON_BN_CLICKED(IDC_SizeSram, OnSizeSram)
	ON_BN_CLICKED(IDC_TestEEP, OnTestEEP)
	ON_BN_CLICKED(IDC_TestSram, OnTestSram)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMemoryDlg message handlers

BOOL CMemoryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CMemoryDlg::OnTestEEP() 
{
	// TODO: Add your control notification handler code here
	BYTE buf_W[] = {'H','e','l','l','o'};
	BYTE buf_R[5];
	const int START_BYTE = 0; //the first byte to write/read
	unsigned short sram_text[5];
	unsigned short * p = sram_text;
    
	pac_EnableEEPROM(true); 
	
	pac_WriteMemory(START_BYTE, buf_W, sizeof(buf_W), WINPAC_MEM_EEPROM);
	pac_ReadMemory(START_BYTE, buf_R, sizeof(buf_R), WINPAC_MEM_EEPROM);
	wsprintf(p, _T("%c%c%c%c%c"), buf_R[0],buf_R[1],buf_R[2],buf_R[3],buf_R[4]);

	GetDlgItem(IDC_EEP)->SetWindowText(p);
	
    pac_EnableEEPROM(false); 		
}

void CMemoryDlg::OnTestSram() 
{
	// TODO: Add your control notification handler code here
	BYTE buf_W[] = {'H','e','l','l','o'};
	BYTE buf_R[5];
	const int START_BYTE = 0; //the first byte to write/read
	unsigned short sram_text[5];
	unsigned short * p = sram_text;
	
	pac_WriteMemory(START_BYTE, buf_W, sizeof(buf_W), WINPAC_MEM_SRAM);
	pac_ReadMemory(START_BYTE, buf_R, sizeof(buf_R), WINPAC_MEM_SRAM);
	wsprintf(p, _T("%c%c%c%c%c"), buf_R[0],buf_R[1],buf_R[2],buf_R[3],buf_R[4]);

	GetDlgItem(IDC_SRAM)->SetWindowText(p);
}
