// SystemInfoDlg.h : header file
//

#if !defined(AFX_SYSTEMINFODLG_H__D3B5EA4C_5892_40F2_88EB_63F03DFFF5EB__INCLUDED_)
#define AFX_SYSTEMINFODLG_H__D3B5EA4C_5892_40F2_88EB_63F03DFFF5EB__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CSystemInfoDlg dialog

class CSystemInfoDlg : public CDialog
{
// Construction
public:
	CSystemInfoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSystemInfoDlg)
	enum { IDD = IDD_SYSTEMINFO_DIALOG };
	int		m_rotaryID;
	CString	m_serialNumber;
	CString	m_osVersion;
	CString	m_ebootVersion;
	CString	m_sdkVersion;
	CString	m_lan1mac;
	CString	m_lan2mac;
	BYTE	m_CPUVersion;
	int		m_RotaryID;
	CString	m_CPU;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSystemInfoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSystemInfoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnGetRotaryID();
	afx_msg void OnGetNetID();
	afx_msg void OnGetSerialNumber();
	afx_msg void OnGetOSVersion();
	afx_msg void OnGetFirmwareVersion();
	afx_msg void OnGetEbootVersion();
	afx_msg void OnSDKVersion();
	afx_msg void OnGetLan1MacAddress();
	afx_msg void OnGetLan2MacAddress();
	afx_msg void OnLedon();
	afx_msg void OnLedoff();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SYSTEMINFODLG_H__D3B5EA4C_5892_40F2_88EB_63F03DFFF5EB__INCLUDED_)
