// DiagnosticDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Diagnostic.h"
#include "DiagnosticDlg.h"


#include "WinPacSDK.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDiagnosticDlg dialog

CDiagnosticDlg::CDiagnosticDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiagnosticDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDiagnosticDlg)
	m_SLOT0 = _T("");
	m_SLOT3 = _T("");
	m_SLOT1 = _T("");
	m_SLOT2 = _T("");
	m_SLOT4 = _T("");
	m_SLOT5 = _T("");
	m_SLOT6 = _T("");
	m_SLOT7 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDiagnosticDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDiagnosticDlg)
	DDX_Text(pDX, IDC_EDIT0, m_SLOT0);
	DDX_Text(pDX, IDC_EDIT3, m_SLOT3);
	DDX_Text(pDX, IDC_EDIT1, m_SLOT1);
	DDX_Text(pDX, IDC_EDIT2, m_SLOT2);
	DDX_Text(pDX, IDC_EDIT4, m_SLOT4);
	DDX_Text(pDX, IDC_EDIT5, m_SLOT5);
	DDX_Text(pDX, IDC_EDIT6, m_SLOT6);
	DDX_Text(pDX, IDC_EDIT7, m_SLOT7);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDiagnosticDlg, CDialog)
	//{{AFX_MSG_MAP(CDiagnosticDlg)
	ON_BN_CLICKED(IDC_SCAN, OnScan)
	ON_BN_CLICKED(IDC_CLOSE, OnClose)	
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiagnosticDlg message handlers

BOOL CDiagnosticDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CDiagnosticDlg::OnScan() 
{
	// TODO: Add your control notification handler code here
	HANDLE hUart;
	char temp[32];
	
	hUart = uart_Open("");
	
	for ( int i =0; i<8 ; i++)
	{
		int mt = pac_GetModuleName((byte)i, temp);
		if( mt == 255)
		{
			char result[32];
			TCHAR buf1[32];
			pac_ChangeSlot((BYTE)i);
			uart_SendCmd(hUart, "$00M", result);
			pac_AnsiToWideString( result, buf1);
			SetDlgItemText(IDC_EDIT0+i, &buf1[3]);
		}
		else if( mt>0)
		{
			TCHAR buf2[32];
			pac_AnsiToWideString(temp, buf2);
			SetDlgItemText(IDC_EDIT0+i, buf2);
		}	
	}

	uart_Close(hUart);
}

void CDiagnosticDlg::OnClose() 
{
	// TODO: Add your control notification handler code here
	PostMessage(WM_QUIT);
}
