// WatchdogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Watchdog.h"
#include "WatchdogDlg.h"

#include "WinPacSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWatchdogDlg dialog

CWatchdogDlg::CWatchdogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWatchdogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWatchdogDlg)
	m_MODE = 0;
	m_TIME = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWatchdogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWatchdogDlg)
	DDX_Text(pDX, IDC_MODE, m_MODE);
	DDX_Text(pDX, IDC_TIME, m_TIME);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWatchdogDlg, CDialog)
	//{{AFX_MSG_MAP(CWatchdogDlg)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_DISABLE, OnDisable)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWatchdogDlg message handlers

BOOL CWatchdogDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

bool bFlag;
int mode;
DWORD time;

DWORD WINAPI Thread(PVOID pArg)
{		
	while(bFlag)
	{		
		pac_RefreshWatchDog(mode);	
		Sleep(time);
	}	
	return 0;
}


void CWatchdogDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	UpdateData(true);
	
	HANDLE hThread;
	DWORD dwThreadID = 0;

	time = m_TIME >> 2;
	mode = m_MODE;

	int nParameter = 5;	
	bFlag = true;

	if(!pac_EnableWatchDog(mode, m_TIME))
		MessageBox(_T("Enable WTD fail."), _T("Error"), MB_OK|MB_ICONERROR); 

	hThread = CreateThread(NULL, 0, Thread, &nParameter, 0, &dwThreadID);	
}

void CWatchdogDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	bFlag = false;
}

void CWatchdogDlg::OnDisable() 
{
	// TODO: Add your control notification handler code here
	pac_DisableWatchDog(mode);
}
