// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"
#include "InputDig.h"
#include "WinconSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int timerOn=0;
int slot24,find24;
int slot17,find17;
int mode=0;
float ch0=0.0f,ch1=0.0f,ch2=0.0f,ch3=0.0f;
/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	DDX_Control(pDX, IDC_RADIO5, m_Mode4);
	DDX_Control(pDX, IDC_RADIO4, m_Mode3);
	DDX_Control(pDX, IDC_RADIO3, m_Mode2);
	DDX_Control(pDX, IDC_RADIO2, m_Mode1);
	DDX_Control(pDX, IDC_RADIO1, m_Mode0);
	DDX_Control(pDX, IDC_AISLOT, m_AISlot);
	DDX_Control(pDX, IDC_AOSLOT, m_AOSlot);
	DDX_Control(pDX, IDC_BtnOutputV, m_BtnAO);
	DDX_Control(pDX, IDC_BUTTON5, m_BtnAIInit);
	DDX_Control(pDX, IDC_BUTTON4, m_BtnAOInit);
	DDX_Control(pDX, IDC_BUTTON3, m_Btn3);
	DDX_Control(pDX, IDC_COMBO2, m_ComboSlot17);
	DDX_Control(pDX, IDC_COMBO1, m_ComboSlot24);
	DDX_Control(pDX, IDC_BUTTON1, m_Btn1);
	DDX_Control(pDX, IDC_AOCH2, m_AO2);
	DDX_Control(pDX, IDC_AOCH3, m_AO3);
	DDX_Control(pDX, IDC_AOCH1, m_AO1);
	DDX_Control(pDX, IDC_AOCH0, m_AO0);
	DDX_Control(pDX, IDC_EDIT8, m_AI7);
	DDX_Control(pDX, IDC_EDIT7, m_AI6);
	DDX_Control(pDX, IDC_EDIT6, m_AI5);
	DDX_Control(pDX, IDC_EDIT5, m_AI4);
	DDX_Control(pDX, IDC_EDIT4, m_AI3);
	DDX_Control(pDX, IDC_EDIT2, m_AI1);
	DDX_Control(pDX, IDC_EDIT3, m_AI2);
	DDX_Control(pDX, IDC_EDIT1, m_AI0);
	DDX_Control(pDX, IDC_EditMsg2, m_Msg2);
	DDX_Control(pDX, IDC_EditMsg, m_Msg);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_BN_CLICKED(IDC_BtnOutputV, OnBtnOutputV)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeComboSlot24)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeComboSlot17)
	ON_BN_CLICKED(IDC_BUTTON3, OnManualScan)
	ON_BN_CLICKED(IDC_BUTTON4, On8024Initial)
	ON_BN_CLICKED(IDC_BUTTON5, On8017Initial)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	TCHAR MsgText[40];
	if (find24==1)
	{
		swprintf(MsgText,_T("I-8024 Card in %d Slot"),slot24);
		m_Msg.SetWindowText(MsgText);
		m_BtnAOInit.EnableWindow(true);
		m_BtnAO.EnableWindow(true);
	}
	else
	{
		swprintf(MsgText,_T("I-8024 Card all slot not found"));
		m_Msg.SetWindowText(MsgText);
		m_BtnAOInit.EnableWindow(false);
		m_BtnAO.EnableWindow(false);
	}

	if (find17==1)
	{
		swprintf(MsgText,_T("I-8017H Card in %d Slot"),slot17);
		m_Msg2.SetWindowText(MsgText);
		m_BtnAIInit.EnableWindow(true);
		m_Btn1.EnableWindow(true);
		m_Btn3.EnableWindow(true);
	}
	else
	{
		swprintf(MsgText,_T("I-8017H Card all slot not found"));
		m_Msg2.SetWindowText(MsgText);
		m_BtnAIInit.EnableWindow(true);
		m_Btn1.EnableWindow(true);
		m_Btn3.EnableWindow(true);
	}
	m_ComboSlot24.SetCurSel(slot24-1);
	m_ComboSlot17.SetCurSel(slot17-1);
	m_Mode0.SetCheck(1);
	swprintf(MsgText,_T("%d"),slot24);
	m_AOSlot.SetWindowText(MsgText);
	swprintf(MsgText,_T("%d"),slot17);
	m_AISlot.SetWindowText(MsgText);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnBtnOutputV() 
{
	// TODO: Add your control notification handler code here
	TCHAR tt[40];
	if (find24==1)
	{
		InputDig FormInputDig=new InputDig();
		FormInputDig.m_Ch0=ch0;
		FormInputDig.m_Ch1=ch1;
		FormInputDig.m_Ch2=ch2;
		FormInputDig.m_Ch3=ch3;
		FormInputDig.DoModal();
		ch0=FormInputDig.m_Ch0;
		ch1=FormInputDig.m_Ch1;
		ch2=FormInputDig.m_Ch2;
		ch3=FormInputDig.m_Ch3;
		I8024_VoltageOut(slot24, 0, ch0);  //Output value to channel0 of I-8024 modeule
		I8024_VoltageOut(slot24, 1, ch1);  //Output value to channel1 of I-8024 modeule
		I8024_VoltageOut(slot24, 2, ch2);  //Output value to channel2 of I-8024 modeule
		I8024_VoltageOut(slot24, 3, ch3);  //Output value to channel3 of I-8024 modeule
		swprintf(tt,_T("%2.3f"),ch0);
		m_AO0.SetWindowText(tt);
		swprintf(tt,_T("%2.3f"),ch1);
		m_AO1.SetWindowText(tt);
		swprintf(tt,_T("%2.3f"),ch2);
		m_AO2.SetWindowText(tt);
		swprintf(tt,_T("%2.3f"),ch3);
		m_AO3.SetWindowText(tt);
	}
	else
		AfxMessageBox(_T("Insert i-8024 Card"));
}

void CDemoDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	if (timerOn==0)
	{
		SetTimer(100,100,NULL);	
		m_Btn1.SetWindowText(_T("Auto Scan Disable"));
		timerOn=1;
		m_Btn3.EnableWindow(false);
	}
	else
	{
		KillTimer(100);
		m_Btn1.SetWindowText(_T("Auto Scan Enable"));
		timerOn=0;
		m_Btn3.EnableWindow(true);
	}
}



void CDemoDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	TCHAR tt[40];
	float temp;
	if (find17==1)
	{
		Set_8017H_Channel_Gain_Mode(slot17,0,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI0.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,1,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI1.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,2,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI2.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,3,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI3.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,4,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI4.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,5,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI5.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,6,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI6.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,7,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI7.SetWindowText(tt);
	}
	CDialog::OnTimer(nIDEvent);
}

void CDemoDlg::OnSelchangeComboSlot24() 
{
	// TODO: Add your control notification handler code here
	CString m_SelSlot;
	int temp;
	TCHAR MsgText[40];
	char strTemp[20];

	m_ComboSlot24.GetLBText(m_ComboSlot24.GetCurSel(), m_SelSlot);
	temp=_ttoi(m_SelSlot);
	if (GetNameOfModule(temp, strTemp)==24)
	{
		slot24=temp;
		swprintf(MsgText,_T("I-8024 Card in %d Slot"),slot24);
		m_Msg.SetWindowText(MsgText);
		swprintf(MsgText,_T("%d"),slot24);
		m_AOSlot.SetWindowText(MsgText);
		m_BtnAOInit.EnableWindow(true);
	}
	else
	{
		swprintf(MsgText,_T("I-8024 Card %d Slot not found"),temp);
		m_Msg.SetWindowText(MsgText);
		m_BtnAOInit.EnableWindow(false);
	}
}

void CDemoDlg::OnSelchangeComboSlot17() 
{
	// TODO: Add your control notification handler code here
	CString m_SelSlot;
	int temp;
	TCHAR MsgText[40];
	char strTemp[20];

	m_ComboSlot17.GetLBText(m_ComboSlot17.GetCurSel(), m_SelSlot);
	temp=_ttoi(m_SelSlot);
	if (GetNameOfModule(temp, strTemp)==17)
	{
		slot17=temp;
		swprintf(MsgText,_T("I-8017H Card in %d Slot"),slot17);
		m_Msg2.SetWindowText(MsgText);
		swprintf(MsgText,_T("%d"),slot17);
		m_AISlot.SetWindowText(MsgText);
		m_BtnAIInit.EnableWindow(true);
	}
	else
	{
		swprintf(MsgText,_T("I-8017H Card %d Slot not found"),temp);
		m_Msg2.SetWindowText(MsgText);
		m_BtnAIInit.EnableWindow(false);
	}	
}

void CDemoDlg::OnManualScan() 
{
	// TODO: Add your control notification handler code here
	TCHAR tt[40];
	float temp;
	if (find17==1)
	{
		Set_8017H_Channel_Gain_Mode(slot17,0,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI0.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,1,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI1.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,2,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI2.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,3,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI3.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,4,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI4.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,5,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI5.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,6,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI6.SetWindowText(tt);
		Set_8017H_Channel_Gain_Mode(slot17,7,mode,0);
		temp=Get_AD_FValue(mode);
		swprintf(tt,_T("%2.3f"),temp);
		m_AI7.SetWindowText(tt);
	}	
}

void CDemoDlg::On8024Initial() 
{
	// TODO: Add your control notification handler code here
	I8024_Initial(slot24);	
}

void CDemoDlg::On8017Initial() 
{
	// TODO: Add your control notification handler code here
	Init_8017H(slot17);	
}

void CDemoDlg::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	mode=0;
	m_Mode1.SetCheck(0);
	m_Mode2.SetCheck(0);
	m_Mode3.SetCheck(0);
	m_Mode4.SetCheck(0);
}

void CDemoDlg::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	mode=1;
	m_Mode0.SetCheck(0);
	m_Mode2.SetCheck(0);
	m_Mode3.SetCheck(0);
	m_Mode4.SetCheck(0);	
}

void CDemoDlg::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	mode=2;
	m_Mode0.SetCheck(0);
	m_Mode1.SetCheck(0);
	m_Mode3.SetCheck(0);
	m_Mode4.SetCheck(0);	
}

void CDemoDlg::OnRadio4() 
{
	// TODO: Add your control notification handler code here
	mode=3;
	m_Mode0.SetCheck(0);
	m_Mode1.SetCheck(0);
	m_Mode2.SetCheck(0);
	m_Mode4.SetCheck(0);	
}

void CDemoDlg::OnRadio5() 
{
	// TODO: Add your control notification handler code here
	mode=4;
	m_Mode0.SetCheck(0);
	m_Mode1.SetCheck(0);
	m_Mode2.SetCheck(0);
	m_Mode3.SetCheck(0);	
}



BOOL CDemoDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
if (pMsg->message == WM_KEYDOWN)
	{
		pMsg->message = WM_HOTKEY;
	}	
	return CDialog::PreTranslateMessage(pMsg);
}
