// Dlg2.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "Dlg2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int CmdNo;
/////////////////////////////////////////////////////////////////////////////
// Dlg2 dialog


Dlg2::Dlg2(CWnd* pParent /*=NULL*/)
	: CDialog(Dlg2::IDD, pParent)
{
	//{{AFX_DATA_INIT(Dlg2)
	m_CHK1 = -1;
	m_CHK2 = -1;
	m_CHK3 = -1;
	m_CHK4 = -1;
	m_Edit1 = 0;
	//}}AFX_DATA_INIT
}


void Dlg2::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Dlg2)
	DDX_Control(pDX, IDC_EDIT1, m_CEdit1);
	DDX_Control(pDX, IDC_STATIC3, m_Group3);
	DDX_Control(pDX, IDC_STATIC1, m_Group1);
	DDX_Control(pDX, IDC_STATIC2, m_Group2);
	DDX_Control(pDX, IDC_RADIO4, m_Radio4);
	DDX_Control(pDX, IDC_RADIO3, m_Radio3);
	DDX_Control(pDX, IDC_RADIO2, m_Radio2);
	DDX_Control(pDX, IDC_RADIO1, m_Radio1);
	DDX_Radio(pDX, IDC_RADIO1, m_CHK1);
	DDX_Radio(pDX, IDC_RADIO2, m_CHK2);
	DDX_Radio(pDX, IDC_RADIO3, m_CHK3);
	DDX_Radio(pDX, IDC_RADIO4, m_CHK4);
	DDX_Text(pDX, IDC_EDIT1, m_Edit1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Dlg2, CDialog)
	//{{AFX_MSG_MAP(Dlg2)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Dlg2 message handlers

BOOL Dlg2::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	switch (CmdNo)
	{
		case i8091_Set_Mode:
			SetWindowText(_T("i8091_Set_Mode"));
			m_Radio1.SetWindowText(_T("CW_CCW"));	
			m_Radio2.SetWindowText(_T("PULSE_DIR"));	
			m_Radio3.SetWindowText(_T("CW_CCW"));	
			m_Radio4.SetWindowText(_T("PULSE_DIR"));
			break;
		case i8091_Set_Servo_On:
			SetWindowText(_T("i8091_Set_Servo_On"));
			m_Radio1.SetWindowText(_T("OFF"));	
			m_Radio2.SetWindowText(_T("ON"));	
			m_Radio3.SetWindowText(_T("OFF"));	
			m_Radio4.SetWindowText(_T("ON"));
			break;
		case i8091_Set_Nc:
			SetWindowText(_T("i8091_Set_Nc"));
			m_Radio1.SetWindowText(_T("OFF"));	
			m_Radio2.SetWindowText(_T("ON"));
			m_Radio3.ShowWindow(0);
			m_Radio4.ShowWindow(0);
			m_Group2.ShowWindow(0);
			break;
		case i8091_Lsp_Org:
			SetWindowText(_T("i8091_Lsp_Org"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Radio3.ShowWindow(0);
			m_Radio4.ShowWindow(0);
			m_Group2.ShowWindow(0);
			break;
		case i8091_Hsp_Org:
			SetWindowText(_T("i8091_Hsp_Org"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Radio3.ShowWindow(0);
			m_Radio4.ShowWindow(0);
			m_Group2.ShowWindow(0);
			break;
		case i8091_Lsp_Pulse_Move:
			SetWindowText(_T("i8091_Lsp_Pulse_Move"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Radio3.ShowWindow(0);
			m_Radio4.ShowWindow(0);
			m_Group2.ShowWindow(0);
			m_Group3.ShowWindow(1);
			m_CEdit1.ShowWindow(1);
			break;
		case i8091_Hsp_Pulse_Move:
			SetWindowText(_T("i8091_Hsp_Pulse_Move"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Radio3.ShowWindow(0);
			m_Radio4.ShowWindow(0);
			m_Group2.ShowWindow(0);
			m_Group3.ShowWindow(1);
			m_CEdit1.ShowWindow(1);
			break;
		case i8091_Lsp_Move:
			SetWindowText(_T("i8091_Lsp_Move"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Group2.SetWindowText(_T("Which direction"));
			m_Radio3.SetWindowText(_T("CW"));	
			m_Radio4.SetWindowText(_T("CCW"));
			break;
		case i8091_Hsp_Move:
			SetWindowText(_T("i8091_Hsp_Move"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Group2.SetWindowText(_T("Which direction"));
			m_Radio3.SetWindowText(_T("CW"));	
			m_Radio4.SetWindowText(_T("CCW"));
			break;
		case i8091_Csp_Move:
			SetWindowText(_T("i8091_Csp_Move"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Group2.SetWindowText(_T("Which direction"));
			m_Radio3.SetWindowText(_T("CW"));	
			m_Radio4.SetWindowText(_T("CCW"));
			m_Group3.ShowWindow(1);
			m_CEdit1.ShowWindow(1);
			m_Group3.SetWindowText(_T("speed (1~2040)"));
			break;
		case i8091_Slow_Stop:
			SetWindowText(_T("i8091_Slow_Stop"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Radio3.ShowWindow(0);
			m_Radio4.ShowWindow(0);
			m_Group2.ShowWindow(0);
			break;
		case i8091_Slow_Down:
			SetWindowText(_T("i8091_Slow_Down"));
			m_Group1.SetWindowText(_T("Which axis"));
			m_Radio1.SetWindowText(_T("X-axis"));	
			m_Radio2.SetWindowText(_T("Y-axis"));
			m_Radio3.ShowWindow(0);
			m_Radio4.ShowWindow(0);
			m_Group2.ShowWindow(0);
			break;
	}
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void Dlg2::OnRadio1() 
{
	// TODO: Add your control notification handler code here
	m_Radio2.SetCheck(0);	
}

void Dlg2::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	m_Radio1.SetCheck(0);	
}

void Dlg2::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	m_Radio4.SetCheck(0);	
}

void Dlg2::OnRadio4() 
{
	// TODO: Add your control notification handler code here
	m_Radio3.SetCheck(0);	
}
