using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using DCONCE;




namespace Demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox comboBoxComPort;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.ComboBox comboBoxBaudRate;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ComboBox comboBoxData;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.ComboBox comboBoxParity;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;

		public byte port=2;
		public uint baudrate=9600;
		public byte databit=8;
		public byte parity=0;
		public byte stop=0;
		public ushort timeout=100;
		public byte checksum=0;
		public byte address_7060;
		public byte address_7021;
		public byte address_7012;

		private System.Windows.Forms.ComboBox comboBoxStop;
		private System.Windows.Forms.TextBox textBoxTimeOut;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.CheckBox checkBoxDO0;
		private System.Windows.Forms.CheckBox checkBoxDO1;
		private System.Windows.Forms.CheckBox checkBoxDO2;
		private System.Windows.Forms.CheckBox checkBoxDO3;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.Panel panelDI0;
		private System.Windows.Forms.Panel panelDI1;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Panel panelDI2;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Panel panelDI3;
		private System.Windows.Forms.TextBox textBox7060;
		private System.Windows.Forms.TextBox textBox7021;
		private System.Windows.Forms.TextBox textBox7012;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Button buttonAO;
		private System.Windows.Forms.TextBox textBoxAO;
		private System.Windows.Forms.Button buttonAI;
		private System.Windows.Forms.Button buttonDI;
		private System.Windows.Forms.TextBox textBoxAI;
		private System.Windows.Forms.Timer timer1;
		private System.Windows.Forms.Button buttonAutoScan;
		private System.Windows.Forms.TrackBar trackBar1;
		private System.Windows.Forms.Button buttonExit;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.Button buttonCloseCom;
		private System.Windows.Forms.CheckBox checkBoxCheckSum;
	
	
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.panel1 = new System.Windows.Forms.Panel();
			this.textBoxTimeOut = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.checkBoxCheckSum = new System.Windows.Forms.CheckBox();
			this.comboBoxStop = new System.Windows.Forms.ComboBox();
			this.label6 = new System.Windows.Forms.Label();
			this.comboBoxParity = new System.Windows.Forms.ComboBox();
			this.label5 = new System.Windows.Forms.Label();
			this.comboBoxData = new System.Windows.Forms.ComboBox();
			this.label4 = new System.Windows.Forms.Label();
			this.comboBoxBaudRate = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.comboBoxComPort = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.textBox7060 = new System.Windows.Forms.TextBox();
			this.textBox7021 = new System.Windows.Forms.TextBox();
			this.textBox7012 = new System.Windows.Forms.TextBox();
			this.button1 = new System.Windows.Forms.Button();
			this.panel2 = new System.Windows.Forms.Panel();
			this.buttonDI = new System.Windows.Forms.Button();
			this.panelDI0 = new System.Windows.Forms.Panel();
			this.label13 = new System.Windows.Forms.Label();
			this.checkBoxDO0 = new System.Windows.Forms.CheckBox();
			this.label12 = new System.Windows.Forms.Label();
			this.checkBoxDO1 = new System.Windows.Forms.CheckBox();
			this.checkBoxDO2 = new System.Windows.Forms.CheckBox();
			this.checkBoxDO3 = new System.Windows.Forms.CheckBox();
			this.panelDI1 = new System.Windows.Forms.Panel();
			this.label14 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.panelDI2 = new System.Windows.Forms.Panel();
			this.label16 = new System.Windows.Forms.Label();
			this.panelDI3 = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.label19 = new System.Windows.Forms.Label();
			this.label18 = new System.Windows.Forms.Label();
			this.textBoxAO = new System.Windows.Forms.TextBox();
			this.buttonAO = new System.Windows.Forms.Button();
			this.label17 = new System.Windows.Forms.Label();
			this.textBoxAI = new System.Windows.Forms.TextBox();
			this.buttonAI = new System.Windows.Forms.Button();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.buttonAutoScan = new System.Windows.Forms.Button();
			this.timer1 = new System.Windows.Forms.Timer();
			this.buttonExit = new System.Windows.Forms.Button();
			this.buttonCloseCom = new System.Windows.Forms.Button();
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.Lime;
			this.panel1.Controls.Add(this.textBoxTimeOut);
			this.panel1.Controls.Add(this.label7);
			this.panel1.Controls.Add(this.checkBoxCheckSum);
			this.panel1.Controls.Add(this.comboBoxStop);
			this.panel1.Controls.Add(this.label6);
			this.panel1.Controls.Add(this.comboBoxParity);
			this.panel1.Controls.Add(this.label5);
			this.panel1.Controls.Add(this.comboBoxData);
			this.panel1.Controls.Add(this.label4);
			this.panel1.Controls.Add(this.comboBoxBaudRate);
			this.panel1.Controls.Add(this.label3);
			this.panel1.Controls.Add(this.label2);
			this.panel1.Controls.Add(this.comboBoxComPort);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Location = new System.Drawing.Point(16, 16);
			this.panel1.Size = new System.Drawing.Size(600, 120);
			// 
			// textBoxTimeOut
			// 
			this.textBoxTimeOut.Location = new System.Drawing.Point(392, 80);
			this.textBoxTimeOut.Size = new System.Drawing.Size(64, 22);
			this.textBoxTimeOut.Text = "100";
			this.textBoxTimeOut.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(320, 80);
			this.label7.Size = new System.Drawing.Size(64, 20);
			this.label7.Text = "TimeOut";
			// 
			// checkBoxCheckSum
			// 
			this.checkBoxCheckSum.Location = new System.Drawing.Point(480, 40);
			this.checkBoxCheckSum.Text = "Check Sum";
			this.checkBoxCheckSum.Click += new System.EventHandler(this.checkBoxCheckSum_Click);
			// 
			// comboBoxStop
			// 
			this.comboBoxStop.Items.Add("1");
			this.comboBoxStop.Items.Add("1.5");
			this.comboBoxStop.Items.Add("2");
			this.comboBoxStop.Location = new System.Drawing.Point(392, 40);
			this.comboBoxStop.Size = new System.Drawing.Size(64, 20);
			this.comboBoxStop.SelectedIndexChanged += new System.EventHandler(this.comboBoxStop_SelectedIndexChanged);
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(336, 40);
			this.label6.Size = new System.Drawing.Size(48, 20);
			this.label6.Text = "Stop";
			// 
			// comboBoxParity
			// 
			this.comboBoxParity.Items.Add("None");
			this.comboBoxParity.Items.Add("Odd");
			this.comboBoxParity.Items.Add("Even");
			this.comboBoxParity.Location = new System.Drawing.Point(240, 80);
			this.comboBoxParity.Size = new System.Drawing.Size(72, 20);
			this.comboBoxParity.SelectedIndexChanged += new System.EventHandler(this.comboBoxParity_SelectedIndexChanged);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(192, 80);
			this.label5.Text = "Parity";
			// 
			// comboBoxData
			// 
			this.comboBoxData.Items.Add("5");
			this.comboBoxData.Items.Add("6");
			this.comboBoxData.Items.Add("7");
			this.comboBoxData.Items.Add("8");
			this.comboBoxData.Location = new System.Drawing.Point(240, 40);
			this.comboBoxData.Size = new System.Drawing.Size(72, 20);
			this.comboBoxData.SelectedIndexChanged += new System.EventHandler(this.comboBoxData_SelectedIndexChanged);
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(192, 40);
			this.label4.Size = new System.Drawing.Size(48, 20);
			this.label4.Text = "Data";
			// 
			// comboBoxBaudRate
			// 
			this.comboBoxBaudRate.Items.Add("1200");
			this.comboBoxBaudRate.Items.Add("2400");
			this.comboBoxBaudRate.Items.Add("4800");
			this.comboBoxBaudRate.Items.Add("9600");
			this.comboBoxBaudRate.Items.Add("19200");
			this.comboBoxBaudRate.Items.Add("38400");
			this.comboBoxBaudRate.Items.Add("57600");
			this.comboBoxBaudRate.Items.Add("115200");
			this.comboBoxBaudRate.Location = new System.Drawing.Point(80, 80);
			this.comboBoxBaudRate.Size = new System.Drawing.Size(100, 20);
			this.comboBoxBaudRate.SelectedIndexChanged += new System.EventHandler(this.comboBoxBaudRate_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(16, 80);
			this.label3.Size = new System.Drawing.Size(56, 20);
			this.label3.Text = "Baud Rate";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(16, 40);
			this.label2.Size = new System.Drawing.Size(56, 20);
			this.label2.Text = "COM Port";
			// 
			// comboBoxComPort
			// 
			this.comboBoxComPort.Items.Add("2");
			this.comboBoxComPort.Items.Add("3");
			this.comboBoxComPort.Location = new System.Drawing.Point(80, 40);
			this.comboBoxComPort.Size = new System.Drawing.Size(72, 20);
			this.comboBoxComPort.SelectedIndexChanged += new System.EventHandler(this.comboBoxComPort_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("PMingLiU", 9F, System.Drawing.FontStyle.Bold);
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Size = new System.Drawing.Size(160, 20);
			this.label1.Text = "Com Port Configuration";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(24, 144);
			this.label8.Size = new System.Drawing.Size(336, 20);
			this.label8.Text = "This Demo use the I-7060, I-7021 and I-7012 Modules.";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(24, 224);
			this.label9.Text = "I-7060 Address";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(24, 248);
			this.label10.Text = "I-7021 Address";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(24, 272);
			this.label11.Text = "I-7012 Address";
			// 
			// textBox7060
			// 
			this.textBox7060.Location = new System.Drawing.Point(128, 224);
			this.textBox7060.Size = new System.Drawing.Size(64, 22);
			this.textBox7060.Text = "2";
			this.textBox7060.TextChanged += new System.EventHandler(this.textBox7060_TextChanged);
			// 
			// textBox7021
			// 
			this.textBox7021.Location = new System.Drawing.Point(128, 248);
			this.textBox7021.Size = new System.Drawing.Size(64, 22);
			this.textBox7021.Text = "3";
			this.textBox7021.TextChanged += new System.EventHandler(this.textBox7021_TextChanged);
			// 
			// textBox7012
			// 
			this.textBox7012.Location = new System.Drawing.Point(128, 272);
			this.textBox7012.Size = new System.Drawing.Size(64, 22);
			this.textBox7012.Text = "1";
			this.textBox7012.TextChanged += new System.EventHandler(this.textBox7012_TextChanged);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(24, 168);
			this.button1.Size = new System.Drawing.Size(80, 32);
			this.button1.Text = "Open Com";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.Color.Chartreuse;
			this.panel2.Controls.Add(this.buttonDI);
			this.panel2.Controls.Add(this.panelDI0);
			this.panel2.Controls.Add(this.label13);
			this.panel2.Controls.Add(this.checkBoxDO0);
			this.panel2.Controls.Add(this.label12);
			this.panel2.Controls.Add(this.checkBoxDO1);
			this.panel2.Controls.Add(this.checkBoxDO2);
			this.panel2.Controls.Add(this.checkBoxDO3);
			this.panel2.Controls.Add(this.panelDI1);
			this.panel2.Controls.Add(this.label14);
			this.panel2.Controls.Add(this.label15);
			this.panel2.Controls.Add(this.panelDI2);
			this.panel2.Controls.Add(this.label16);
			this.panel2.Controls.Add(this.panelDI3);
			this.panel2.Location = new System.Drawing.Point(208, 168);
			this.panel2.Size = new System.Drawing.Size(408, 120);
			// 
			// buttonDI
			// 
			this.buttonDI.Location = new System.Drawing.Point(16, 72);
			this.buttonDI.Size = new System.Drawing.Size(80, 24);
			this.buttonDI.Text = "DI";
			this.buttonDI.Click += new System.EventHandler(this.buttonDI_Click);
			// 
			// panelDI0
			// 
			this.panelDI0.BackColor = System.Drawing.Color.Black;
			this.panelDI0.Location = new System.Drawing.Point(112, 72);
			this.panelDI0.Size = new System.Drawing.Size(16, 16);
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(128, 72);
			this.label13.Size = new System.Drawing.Size(32, 20);
			this.label13.Text = "DI0";
			// 
			// checkBoxDO0
			// 
			this.checkBoxDO0.Location = new System.Drawing.Point(112, 40);
			this.checkBoxDO0.Size = new System.Drawing.Size(56, 20);
			this.checkBoxDO0.Text = "DO0";
			this.checkBoxDO0.CheckStateChanged += new System.EventHandler(this.checkBoxDO0_CheckStateChanged);
			// 
			// label12
			// 
			this.label12.Font = new System.Drawing.Font("PMingLiU", 9F, System.Drawing.FontStyle.Bold);
			this.label12.Location = new System.Drawing.Point(8, 8);
			this.label12.Size = new System.Drawing.Size(192, 20);
			this.label12.Text = "I-7060 Digital Input / Output";
			// 
			// checkBoxDO1
			// 
			this.checkBoxDO1.Location = new System.Drawing.Point(184, 40);
			this.checkBoxDO1.Size = new System.Drawing.Size(56, 20);
			this.checkBoxDO1.Text = "DO1";
			this.checkBoxDO1.CheckStateChanged += new System.EventHandler(this.checkBoxDO1_CheckStateChanged);
			// 
			// checkBoxDO2
			// 
			this.checkBoxDO2.Location = new System.Drawing.Point(256, 40);
			this.checkBoxDO2.Size = new System.Drawing.Size(56, 20);
			this.checkBoxDO2.Text = "DO2";
			this.checkBoxDO2.CheckStateChanged += new System.EventHandler(this.checkBoxDO2_CheckStateChanged);
			// 
			// checkBoxDO3
			// 
			this.checkBoxDO3.Location = new System.Drawing.Point(328, 40);
			this.checkBoxDO3.Size = new System.Drawing.Size(56, 20);
			this.checkBoxDO3.Text = "DO3";
			this.checkBoxDO3.CheckStateChanged += new System.EventHandler(this.checkBoxDO3_CheckStateChanged);
			// 
			// panelDI1
			// 
			this.panelDI1.BackColor = System.Drawing.Color.Black;
			this.panelDI1.Location = new System.Drawing.Point(184, 72);
			this.panelDI1.Size = new System.Drawing.Size(16, 16);
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(200, 72);
			this.label14.Size = new System.Drawing.Size(32, 20);
			this.label14.Text = "DI1";
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(272, 72);
			this.label15.Size = new System.Drawing.Size(32, 20);
			this.label15.Text = "DI2";
			// 
			// panelDI2
			// 
			this.panelDI2.BackColor = System.Drawing.Color.Black;
			this.panelDI2.Location = new System.Drawing.Point(256, 72);
			this.panelDI2.Size = new System.Drawing.Size(16, 16);
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(344, 72);
			this.label16.Size = new System.Drawing.Size(32, 20);
			this.label16.Text = "DI3";
			// 
			// panelDI3
			// 
			this.panelDI3.BackColor = System.Drawing.Color.Black;
			this.panelDI3.Location = new System.Drawing.Point(328, 72);
			this.panelDI3.Size = new System.Drawing.Size(16, 16);
			// 
			// panel3
			// 
			this.panel3.BackColor = System.Drawing.Color.Cyan;
			this.panel3.Controls.Add(this.label19);
			this.panel3.Controls.Add(this.label18);
			this.panel3.Controls.Add(this.textBoxAO);
			this.panel3.Controls.Add(this.buttonAO);
			this.panel3.Controls.Add(this.label17);
			this.panel3.Controls.Add(this.textBoxAI);
			this.panel3.Controls.Add(this.buttonAI);
			this.panel3.Controls.Add(this.trackBar1);
			this.panel3.Location = new System.Drawing.Point(208, 288);
			this.panel3.Size = new System.Drawing.Size(408, 128);
			// 
			// label19
			// 
			this.label19.Location = new System.Drawing.Point(344, 32);
			this.label19.Size = new System.Drawing.Size(16, 20);
			this.label19.Text = "10";
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(232, 32);
			this.label18.Size = new System.Drawing.Size(8, 20);
			this.label18.Text = "0";
			// 
			// textBoxAO
			// 
			this.textBoxAO.Location = new System.Drawing.Point(232, 56);
			this.textBoxAO.Text = "0";
			// 
			// buttonAO
			// 
			this.buttonAO.Location = new System.Drawing.Point(24, 56);
			this.buttonAO.Size = new System.Drawing.Size(168, 24);
			this.buttonAO.Text = "Analog Output I-7021";
			this.buttonAO.Click += new System.EventHandler(this.buttonAO_Click);
			// 
			// label17
			// 
			this.label17.Font = new System.Drawing.Font("PMingLiU", 9F, System.Drawing.FontStyle.Bold);
			this.label17.Location = new System.Drawing.Point(8, 8);
			this.label17.Size = new System.Drawing.Size(216, 20);
			this.label17.Text = "I-7021/12 Analog Input / Output";
			// 
			// textBoxAI
			// 
			this.textBoxAI.Location = new System.Drawing.Point(232, 88);
			this.textBoxAI.ReadOnly = true;
			this.textBoxAI.Text = "0";
			// 
			// buttonAI
			// 
			this.buttonAI.Location = new System.Drawing.Point(24, 88);
			this.buttonAI.Size = new System.Drawing.Size(168, 24);
			this.buttonAI.Text = "Analog Input I-7012";
			this.buttonAI.Click += new System.EventHandler(this.buttonAI_Click);
			// 
			// trackBar1
			// 
			this.trackBar1.Location = new System.Drawing.Point(224, 8);
			this.trackBar1.Size = new System.Drawing.Size(136, 42);
			this.trackBar1.ValueChanged += new System.EventHandler(this.trackBar1_ValueChanged);
			// 
			// buttonAutoScan
			// 
			this.buttonAutoScan.Location = new System.Drawing.Point(24, 304);
			this.buttonAutoScan.Size = new System.Drawing.Size(168, 48);
			this.buttonAutoScan.Text = "Auto Scan DI/AI Enable";
			this.buttonAutoScan.Click += new System.EventHandler(this.button2_Click);
			// 
			// timer1
			// 
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// buttonExit
			// 
			this.buttonExit.Location = new System.Drawing.Point(64, 376);
			this.buttonExit.Size = new System.Drawing.Size(80, 24);
			this.buttonExit.Text = "Exit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			// 
			// buttonCloseCom
			// 
			this.buttonCloseCom.Location = new System.Drawing.Point(112, 168);
			this.buttonCloseCom.Size = new System.Drawing.Size(80, 32);
			this.buttonCloseCom.Text = "Close Com";
			this.buttonCloseCom.Click += new System.EventHandler(this.buttonCloseCom_Click);
			// 
			// Form1
			// 
			this.BackColor = System.Drawing.Color.LightSeaGreen;
			this.Controls.Add(this.buttonExit);
			this.Controls.Add(this.buttonAutoScan);
			this.Controls.Add(this.panel3);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.textBox7012);
			this.Controls.Add(this.textBox7021);
			this.Controls.Add(this.textBox7060);
			this.Controls.Add(this.label9);
			this.Controls.Add(this.label8);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.label10);
			this.Controls.Add(this.label11);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.buttonCloseCom);
			this.Text = "Demo I-7000 series modules for Wincon-8000";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.Form1_Closing);
			this.Load += new System.EventHandler(this.Form1_Load);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			comboBoxComPort.Text="2";
			comboBoxBaudRate.Text="9600";
			comboBoxData.Text="8";
			comboBoxParity.Text="None";
			comboBoxStop.Text="1";
			address_7060=Convert.ToByte(textBox7060.Text);
			address_7021=Convert.ToByte(textBox7021.Text);
			address_7012=Convert.ToByte(textBox7012.Text);

		}

		private void comboBoxComPort_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			port=Convert.ToByte(comboBoxComPort.SelectedItem.ToString());
		}

		private void comboBoxBaudRate_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			baudrate=Convert.ToUInt32(comboBoxBaudRate.SelectedItem.ToString());
		}

		private void comboBoxData_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			databit=Convert.ToByte(comboBoxData.SelectedItem.ToString());
		}

		private void comboBoxParity_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			switch (comboBoxParity.SelectedIndex.ToString())
			{
				case "0":
					parity=0;
					break;
				case "1":
					parity=1;
					break;
				case "2":
					parity=2;
					break;
			}
		}


		private void comboBoxStop_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			switch (comboBoxStop.SelectedIndex.ToString())
			{
				case "0":
					stop=0;
					break;
				case "1":
					stop=1;
					break;
				case "2":
					stop=2;
					break;
			}	
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			timeout=Convert.ToUInt16(textBoxTimeOut.Text);
		}

		private void checkBoxCheckSum_Click(object sender, System.EventArgs e)
		{
			if (checkBoxCheckSum.Checked)
				checksum=1;
			else
				checksum=0;

		}

		private void checkBoxDO0_CheckStateChanged(object sender, System.EventArgs e)
		{
			if (checkBoxDO0.Checked)
				Dcon.i7060.DO_Bit(port, address_7060, 0, 1, checksum, timeout);
			else
				Dcon.i7060.DO_Bit(port, address_7060, 0, 0, checksum, timeout);
		}

		private void checkBoxDO1_CheckStateChanged(object sender, System.EventArgs e)
		{
			if (checkBoxDO1.Checked)
				Dcon.i7060.DO_Bit(port, address_7060, 1, 1, checksum, timeout);
			else
				Dcon.i7060.DO_Bit(port, address_7060, 1, 0, checksum, timeout);		
		}

		private void checkBoxDO2_CheckStateChanged(object sender, System.EventArgs e)
		{
			if (checkBoxDO2.Checked)
				Dcon.i7060.DO_Bit(port, address_7060, 2, 1, checksum, timeout);
			else
				Dcon.i7060.DO_Bit(port, address_7060, 2, 0, checksum, timeout);
		}

		private void checkBoxDO3_CheckStateChanged(object sender, System.EventArgs e)
		{
			if (checkBoxDO3.Checked)
				Dcon.i7060.DO_Bit(port, address_7060, 3, 1, checksum, timeout);
			else
				Dcon.i7060.DO_Bit(port, address_7060, 3, 0, checksum, timeout);
		}

		private void buttonAO_Click(object sender, System.EventArgs e)
		{
			float outdata;
			outdata=(float)Convert.ToDouble(textBoxAO.Text);
			Dcon.i7021.AnalogOut(port, address_7021, outdata, checksum, timeout);
		}

		private void buttonDI_Click(object sender, System.EventArgs e)
		{
			byte InTemp;
			Dcon.i7060.DI_4(port, address_7060, checksum, timeout, out InTemp);
			panelDI0.BackColor=((InTemp&0x01)==0)?(System.Drawing.Color.Black):(System.Drawing.Color.Red);
			panelDI1.BackColor=((InTemp&0x02)==0)?(System.Drawing.Color.Black):(System.Drawing.Color.Red);
			panelDI2.BackColor=((InTemp&0x04)==0)?(System.Drawing.Color.Black):(System.Drawing.Color.Red);
			panelDI3.BackColor=((InTemp&0x08)==0)?(System.Drawing.Color.Black):(System.Drawing.Color.Red);
		}

		private void buttonAI_Click(object sender, System.EventArgs e)
		{
			float InAI;
			Dcon.i7012.AnalogIn(port, address_7012, checksum, timeout, out InAI);
			textBoxAI.Text=InAI.ToString("f");
		}

		private void button2_Click(object sender, System.EventArgs e)
		{
			if (timer1.Enabled)
			{
				timer1.Enabled=false;
				buttonAutoScan.Text="Auto Scan DI/AI Enable";
				buttonDI.Enabled=true;
				buttonAI.Enabled=true;
			}
			else
			{
				timer1.Enabled=true;
				buttonAutoScan.Text="Auto Scan DI/AI Disable";
				buttonDI.Enabled=false;
				buttonAI.Enabled=false;
			}
		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			byte InTemp;
			Dcon.i7060.DI_4(port, address_7060, checksum, timeout, out InTemp);
			panelDI0.BackColor=((InTemp&0x01)==0)?(System.Drawing.Color.Black):(System.Drawing.Color.Red);
			panelDI1.BackColor=((InTemp&0x02)==0)?(System.Drawing.Color.Black):(System.Drawing.Color.Red);
			panelDI2.BackColor=((InTemp&0x04)==0)?(System.Drawing.Color.Black):(System.Drawing.Color.Red);
			panelDI3.BackColor=((InTemp&0x08)==0)?(System.Drawing.Color.Black):(System.Drawing.Color.Red);	

			float InAI;
			Dcon.i7012.AnalogIn(port, address_7012, checksum, timeout, out InAI);
			textBoxAI.Text=InAI.ToString("f");
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Dcon.UART.Open_Com(port, baudrate, databit, parity, stop);
		}

		private void Form1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			Dcon.UART.Close_Com(port);

			if ((MessageBox.Show("Do you want to Close the System?","Exit",MessageBoxButtons.YesNo,
				MessageBoxIcon.Question,0))==(DialogResult.No))
				e.Cancel=true;

			Dcon.UART.Open_Com(port, baudrate, databit, parity, stop);
		}

		private void textBox7060_TextChanged(object sender, System.EventArgs e)
		{
			address_7060=Convert.ToByte(textBox7060.Text);
		}

		private void textBox7021_TextChanged(object sender, System.EventArgs e)
		{
			address_7021=Convert.ToByte(textBox7021.Text);
		}

		private void textBox7012_TextChanged(object sender, System.EventArgs e)
		{
			address_7012=Convert.ToByte(textBox7012.Text);
		}

		private void trackBar1_ValueChanged(object sender, System.EventArgs e)
		{
			textBoxAO.Text=trackBar1.Value.ToString();
			Dcon.i7021.AnalogOut(port, address_7021, trackBar1.Value, checksum, timeout);
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void buttonCloseCom_Click(object sender, System.EventArgs e)
		{
			Dcon.UART.Close_Com(port);
		}

	}
}
