// FreqDlg.cpp : implementation file
//

#include "stdafx.h"
#include "I8080.h"
#include "FreqDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern short AutoTT;
extern short AutoVV;
extern short LowTT;
extern short LowVV;
extern short HighTT;
extern short HighVV;
extern bool SetFreq;
/////////////////////////////////////////////////////////////////////////////
// CFreqDlg dialog


CFreqDlg::CFreqDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFreqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFreqDlg)
	m_iAutoTT = 0;
	m_iAutoVV = 0;
	m_iLowTT = 0;
	m_iHighTT = 0;
	m_iLowVV = 0;
	m_iHighVV = 0;
	//}}AFX_DATA_INIT
}


void CFreqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFreqDlg)
	DDX_Control(pDX, IDC_EDIT5, m_HighVV);
	DDX_Control(pDX, IDC_EDIT29, m_HighTT);
	DDX_Control(pDX, IDC_EDIT3, m_LowVV);
	DDX_Control(pDX, IDC_EDIT28, m_LowTT);
	DDX_Control(pDX, IDC_EDIT2, m_AutoVV);
	DDX_Control(pDX, IDC_EDIT1, m_AutoTT);
	DDX_Control(pDX, IDCANCEL, m_Cancel);
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Text(pDX, IDC_EDIT1, m_iAutoTT);
	DDX_Text(pDX, IDC_EDIT2, m_iAutoVV);
	DDX_Text(pDX, IDC_EDIT28, m_iLowTT);
	DDX_Text(pDX, IDC_EDIT29, m_iHighTT);
	DDX_Text(pDX, IDC_EDIT3, m_iLowVV);
	DDX_Text(pDX, IDC_EDIT5, m_iHighVV);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFreqDlg, CDialog)
	//{{AFX_MSG_MAP(CFreqDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFreqDlg message handlers

BOOL CFreqDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	TCHAR temp[20];
	swprintf(temp, _T("%d"), AutoTT);
	m_AutoTT.SetWindowText(temp);
	swprintf(temp, _T("%d"), AutoVV);
	m_AutoVV.SetWindowText(temp);	
	swprintf(temp, _T("%d"), LowTT);
	m_LowTT.SetWindowText(temp);	
	swprintf(temp, _T("%d"), LowVV);
	m_LowVV.SetWindowText(temp);	
	swprintf(temp, _T("%d"), HighTT);
	m_HighTT.SetWindowText(temp);	
	swprintf(temp, _T("%d"), HighVV);
	m_HighVV.SetWindowText(temp);	
	if (!SetFreq)
	{
		m_AutoTT.SetReadOnly(TRUE);
		m_AutoVV.SetReadOnly(TRUE);
		m_LowTT.SetReadOnly(TRUE);
		m_LowVV.SetReadOnly(TRUE);
		m_HighTT.SetReadOnly(TRUE);
		m_HighVV.SetReadOnly(TRUE);
		m_Cancel.ShowWindow(0);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
