// I8080Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "I8080.h"
#include "I8080Dlg.h"
#include "lSetDlg.h"
#include "FreqDlg.h"
#include "WinconSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define CHA0	0
#define CHB0	1
#define CHA1	2
#define CHB1	3
#define CHA2	4
#define CHB2	5
#define CHA3	6
#define CHB3	7

int slot=1;
int channel=0;
short mode[8];
short tempmode=0;
short tempFreq=3;
short AutoTT;
short AutoVV;
short LowTT;
short LowVV;
short HighTT;
short HighVV;

bool tempSelect=false;
bool tempLowAlarm=false;
bool tempHighAlarm=false;
bool tempXor=false;
bool AutoRead=false;
bool SetFreq=false;
	TCHAR temp1[8][40];
	TCHAR temp2[8][20];


void ScanAllChannel();
/////////////////////////////////////////////////////////////////////////////
// CI8080Dlg dialog

CI8080Dlg::CI8080Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CI8080Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CI8080Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CI8080Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CI8080Dlg)
	DDX_Control(pDX, IDC_BUTTON13, m_DiXorBtn);
	DDX_Control(pDX, IDC_BUTTON3, m_RegisterBtn);
	DDX_Control(pDX, IDC_BUTTON15, m_ReadFreqConfigBtn);
	DDX_Control(pDX, IDC_BUTTON14, m_SetFreqConfigBtn);
	DDX_Control(pDX, IDC_BUTTON4, m_SetChannelModeBtn);
	DDX_Control(pDX, IDC_EDIT27, m_DiXor);
	DDX_Control(pDX, IDC_EDIT18, m_Register);
	DDX_Control(pDX, IDC_BUTTON11, m_ClearB3Btn);
	DDX_Control(pDX, IDC_BUTTON9, m_ClearA3Btn);
	DDX_Control(pDX, IDC_BUTTON12, m_ClearB2Btn);
	DDX_Control(pDX, IDC_BUTTON7, m_ClearA2Btn);
	DDX_Control(pDX, IDC_BUTTON10, m_ClearB1Btn);
	DDX_Control(pDX, IDC_BUTTON6, m_ClearA1Btn);
	DDX_Control(pDX, IDC_BUTTON8, m_ClearB0Btn);
	DDX_Control(pDX, IDC_BUTTON5, m_ClearA0Btn);
	DDX_Control(pDX, IDC_EDIT17, m_MB3);
	DDX_Control(pDX, IDC_EDIT16, m_MA3);
	DDX_Control(pDX, IDC_EDIT15, m_MB2);
	DDX_Control(pDX, IDC_EDIT14, m_MA2);
	DDX_Control(pDX, IDC_EDIT13, m_MB1);
	DDX_Control(pDX, IDC_EDIT12, m_MA1);
	DDX_Control(pDX, IDC_EDIT11, m_MB0);
	DDX_Control(pDX, IDC_EDIT10, m_MA0);
	DDX_Control(pDX, IDC_COMBO1, m_ComboChannel);
	DDX_Control(pDX, IDC_BUTTON1, m_AutoScanBtn);
	DDX_Control(pDX, IDC_BUTTON2, m_ReadBtn);
	DDX_Control(pDX, IDC_EDIT1, m_VA0);
	DDX_Control(pDX, IDC_EDIT26, m_OB2);
	DDX_Control(pDX, IDC_EDIT25, m_OA2);
	DDX_Control(pDX, IDC_EDIT24, m_OB3);
	DDX_Control(pDX, IDC_EDIT23, m_OB1);
	DDX_Control(pDX, IDC_EDIT22, m_OA1);
	DDX_Control(pDX, IDC_EDIT21, m_OA3);
	DDX_Control(pDX, IDC_EDIT20, m_OB0);
	DDX_Control(pDX, IDC_EDIT19, m_OA0);
	DDX_Control(pDX, IDC_EDIT6, m_VB2);
	DDX_Control(pDX, IDC_EDIT3, m_VA2);
	DDX_Control(pDX, IDC_EDIT8, m_VB3);
	DDX_Control(pDX, IDC_EDIT5, m_VB1);
	DDX_Control(pDX, IDC_EDIT2, m_VA1);
	DDX_Control(pDX, IDC_EDIT7, m_VA3);
	DDX_Control(pDX, IDC_EDIT4, m_VB0);
	DDX_Control(pDX, IDC_EDIT9, m_Slot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CI8080Dlg, CDialog)
	//{{AFX_MSG_MAP(CI8080Dlg)
	ON_BN_CLICKED(IDC_BUTTON4, OnSetModeBtn)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON5, OnClearA0)
	ON_BN_CLICKED(IDC_BUTTON8, OnClearB0)
	ON_BN_CLICKED(IDC_BUTTON6, OnClearA1)
	ON_BN_CLICKED(IDC_BUTTON10, OnClearB1)
	ON_BN_CLICKED(IDC_BUTTON7, OnClearA2)
	ON_BN_CLICKED(IDC_BUTTON12, OnClearB2)
	ON_BN_CLICKED(IDC_BUTTON9, OnClearA3)
	ON_BN_CLICKED(IDC_BUTTON11, OnClearB3)
	ON_BN_CLICKED(IDC_BUTTON2, OnReadBtn)
	ON_BN_CLICKED(IDC_BUTTON1, OnAutoScanBtn)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeComboChannel)
	ON_BN_CLICKED(IDC_BUTTON3, OnReadRegisterBtn)
	ON_BN_CLICKED(IDC_BUTTON13, OnReadDiXorBtn)
	ON_BN_CLICKED(IDC_BUTTON15, OnReadFreqConfigBtn)
	ON_BN_CLICKED(IDC_BUTTON14, OnSetFreqConfigBtn)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CI8080Dlg message handlers

BOOL CI8080Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	int i;
	short readmode;
	TCHAR temp[20];

	m_ComboChannel.SetCurSel(channel);

	for(slot=1; slot<8; slot++)
	{
		i=i8080_InitDriver(slot);
		if (!i)
		{
			swprintf(temp, _T("%d"), slot);
			m_Slot.SetWindowText(temp);

			SetTimer(100, 3, NULL);   // scan every 3 ms

			i8080_ReadChannelMode( slot, 0, &readmode);  //Read i-8080 Channel mode
			swprintf(temp, _T("%02X"), readmode);
			m_MA0.SetWindowText(temp);

			i8080_ReadChannelMode( slot, 1, &readmode);  //Read i-8080 Channel mode
			swprintf(temp, _T("%02X"), readmode);
			m_MB0.SetWindowText(temp);

			i8080_ReadChannelMode( slot, 2, &readmode);  //Read i-8080 Channel mode
			swprintf(temp, _T("%02X"), readmode);
			m_MA1.SetWindowText(temp);

			i8080_ReadChannelMode( slot, 3, &readmode);  //Read i-8080 Channel mode
			swprintf(temp, _T("%02X"), readmode);
			m_MB1.SetWindowText(temp);

			i8080_ReadChannelMode( slot, 4, &readmode);  //Read i-8080 Channel mode
			swprintf(temp, _T("%02X"), readmode);
			m_MA2.SetWindowText(temp);

			i8080_ReadChannelMode( slot, 5, &readmode);  //Read i-8080 Channel mode
			swprintf(temp, _T("%02X"), readmode);
			m_MB2.SetWindowText(temp);

			i8080_ReadChannelMode( slot, 6, &readmode);  //Read i-8080 Channel mode
			swprintf(temp, _T("%02X"), readmode);
			m_MA3.SetWindowText(temp);

			i8080_ReadChannelMode( slot, 7, &readmode);  //Read i-8080 Channel mode
			swprintf(temp, _T("%02X"), readmode);
			m_MB3.SetWindowText(temp);
			break;
		}
	}
	
	if (slot>7)
	{
		m_SetChannelModeBtn.EnableWindow(FALSE);
		m_ClearA0Btn.EnableWindow(FALSE);
		m_ClearA1Btn.EnableWindow(FALSE);
		m_ClearA2Btn.EnableWindow(FALSE);
		m_ClearA3Btn.EnableWindow(FALSE);
		m_ClearB0Btn.EnableWindow(FALSE);
		m_ClearB1Btn.EnableWindow(FALSE);
		m_ClearB2Btn.EnableWindow(FALSE);
		m_ClearB3Btn.EnableWindow(FALSE);
		m_SetFreqConfigBtn.EnableWindow(FALSE);
		m_ReadFreqConfigBtn.EnableWindow(FALSE);
		m_RegisterBtn.EnableWindow(FALSE);
		m_DiXorBtn.EnableWindow(FALSE);
		m_AutoScanBtn.EnableWindow(FALSE);
		m_ReadBtn.EnableWindow(FALSE);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CI8080Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	switch (nIDEvent)
	{
		case 100:
			i8080_AutoScan();
			break;
		case 101:
			ScanAllChannel();

			m_VA0.SetWindowText(temp1[0]);
			m_OA0.SetWindowText(temp2[0]);
			if ((mode[1]&0x3)>1)
			{
				m_VB0.SetWindowText(temp1[1]);
				m_OB0.SetWindowText(temp2[1]);
			}
			if ((mode[2]&0x3)>1)
			{
				m_VA1.SetWindowText(temp1[2]);
				m_OA1.SetWindowText(temp2[2]);
			}
			else
			{
				m_VA1.SetWindowText(temp1[1]);
				m_OA1.SetWindowText(temp2[1]);
			}
			if ((mode[3]&0x3)>1)
			{
				m_VB1.SetWindowText(temp1[3]);
				m_OB1.SetWindowText(temp2[3]);
			}

			if ((mode[4]&0x3)>1)
			{
				m_VA2.SetWindowText(temp1[4]);
				m_OA2.SetWindowText(temp2[4]);
			}
			else
			{
				m_VA2.SetWindowText(temp1[2]);
				m_OA2.SetWindowText(temp2[2]);
			}
			if ((mode[5]&0x3)>1)
			{
				m_VB2.SetWindowText(temp1[5]);
				m_OB2.SetWindowText(temp2[5]);
			}

			if ((mode[6]&0x3)>1)
			{
				m_VA3.SetWindowText(temp1[6]);
				m_OA3.SetWindowText(temp2[6]);
			}
			else
			{
				m_VA3.SetWindowText(temp1[3]);
				m_OA3.SetWindowText(temp2[3]);
			}

			if ((mode[7]&0x3)>1)
			{
				m_VB3.SetWindowText(temp1[7]);
				m_OB3.SetWindowText(temp2[7]);
			}
			break;
	}	
	CDialog::OnTimer(nIDEvent);
}


void CI8080Dlg::OnSetModeBtn() 
{
	// TODO: Add your control notification handler code here
	short readmode;
	TCHAR temp[20];

	bool openDlg=true;

	if (channel==1 || channel==3 || channel==5 || channel==7)
	{
		i8080_ReadChannelMode( slot, (channel-1), &readmode);  //Read i-8080 Channel mode
		if (((readmode&0x03)<0x02) && ((readmode&0x0F)!=0x0C))
			openDlg=false;
	}

	if (openDlg)
	{

		i8080_ReadChannelMode( slot, channel, &readmode);  //Read i-8080 Channel mode
		tempmode=readmode;
		
		ClSetDlg FormSetDig=new ClSetDlg();

		int nResponse=FormSetDig.DoModal();

		if (nResponse == IDOK)
		{
			switch (tempFreq)
			{
				case 0:
					tempmode=tempmode&0x03;
					break;
				case 1:
					tempmode=(tempmode|0x04)&0x07;
					break;
				case 2:
					tempmode=(tempmode|0x08)&0x0B;
					break;
				case 3:
					tempmode=tempmode|0x0C;
					break;
			}

			tempmode=(tempLowAlarm)?(tempmode|0x10):(tempmode&0xEF);
			tempmode=(tempHighAlarm)?(tempmode|0x20):(tempmode&0xDF);
			tempmode=(tempSelect)?(tempmode|0x40):(tempmode&0xBF);
			tempmode=(tempXor)?(tempmode|0x80):(tempmode&0x7F);

			mode[channel]=tempmode;

			i8080_SetChannelMode( slot, channel, mode[channel]);

			swprintf(temp, _T("%02X"), mode[channel]);

			switch (channel)
			{
				case 0:
					if ((mode[channel]&0x03)==0x02)
						m_ClearA0Btn.EnableWindow(FALSE);
					else
						m_ClearA0Btn.EnableWindow(TRUE);
					m_MA0.SetWindowText(temp);

					if ((mode[channel]&0x03)<0x02)
					{
						mode[channel+1]=mode[channel];
						i8080_SetChannelMode( slot, channel+1, mode[channel+1]);
						swprintf(temp, _T("%02X"), mode[channel+1]);
						m_MB0.SetWindowText(temp);
						m_ClearB0Btn.EnableWindow(FALSE);
					}
					break;
				case 1:
					if ((mode[channel]&0x03)<=0x02)
						m_ClearB0Btn.EnableWindow(FALSE);
					else 
						m_ClearB0Btn.EnableWindow(TRUE);
					m_MB0.SetWindowText(temp);
					break;
				case 2:
					if ((mode[channel]&0x03)==0x02)
						m_ClearA1Btn.EnableWindow(FALSE);
					else
						m_ClearA1Btn.EnableWindow(TRUE);
					m_MA1.SetWindowText(temp);

					if ((mode[channel]&0x03)<0x02)
					{
						mode[channel+1]=mode[channel];
						i8080_SetChannelMode( slot, channel+1, mode[channel+1]);
						swprintf(temp, _T("%02X"), mode[channel+1]);
						m_MB1.SetWindowText(temp);
						m_ClearB1Btn.EnableWindow(FALSE);
					}
					break;
				case 3:
					if ((mode[channel]&0x03)<=0x02)
						m_ClearB1Btn.EnableWindow(FALSE);
					else
						m_ClearB1Btn.EnableWindow(TRUE);
					m_MB1.SetWindowText(temp);
					break;
				case 4:
					if ((mode[channel]&0x03)==0x02)
						m_ClearA2Btn.EnableWindow(FALSE);
					else
						m_ClearA2Btn.EnableWindow(TRUE);
					m_MA2.SetWindowText(temp);

					if ((mode[channel]&0x03)<0x02)
					{
						mode[channel+1]=mode[channel];
						i8080_SetChannelMode( slot, channel+1, mode[channel+1]);
						swprintf(temp, _T("%02X"), mode[channel+1]);
						m_MB2.SetWindowText(temp);
						m_ClearB2Btn.EnableWindow(FALSE);
					}
					break;
				case 5:
					if ((mode[channel]&0x03)<=0x02)
						m_ClearB2Btn.EnableWindow(FALSE);
					else
						m_ClearB2Btn.EnableWindow(TRUE);
					m_MB2.SetWindowText(temp);
					break;
				case 6:
					if ((mode[channel]&0x03)==0x02)
						m_ClearA3Btn.EnableWindow(FALSE);
					else
						m_ClearA3Btn.EnableWindow(TRUE);
					m_MA3.SetWindowText(temp);

					if ((mode[channel]&0x03)<0x02)
					{
						mode[channel+1]=mode[channel];
						i8080_SetChannelMode( slot, channel+1, mode[channel+1]);
						swprintf(temp, _T("%02X"), mode[channel+1]);
						m_MB3.SetWindowText(temp);
						m_ClearB3Btn.EnableWindow(FALSE);
					}
					break;
				case 7:
					if ((mode[channel]&0x03)<=0x02)
						m_ClearB3Btn.EnableWindow(FALSE);
					else
						m_ClearB3Btn.EnableWindow(TRUE);
					m_MB3.SetWindowText(temp);
					break;
			}
		}
	}
	else
	{
		if ((mode[channel]&0x03)==0x00)
			swprintf(temp, _T("The A%d chnannel mode is Dir/Pulse Counting,\n\ncannot change B%d channel Mode"),
			mode[channel], (channel+1)/2);
		else
			swprintf(temp, _T("The A%d chnannel mode is Up/Down Counting,\n\ncannot change B%d channel Mode"),
			mode[channel], (channel+1)/2);

		MessageBox(temp, _T("Note"), MB_OK);
	}

}



void CI8080Dlg::OnClearA0() 
{
	// TODO: Add your control notification handler code here
	if ((mode[CHA0]&0x03)<2)
	{
		i8080_ClrCnt( slot, CHA0);	
		i8080_ClrCnt( slot, CHB0);
	}
	else
		i8080_ClrCnt( slot, CHA0);
}

void CI8080Dlg::OnClearB0() 
{
	// TODO: Add your control notification handler code here
	i8080_ClrCnt( slot, CHB0);	
}

void CI8080Dlg::OnClearA1() 
{
	// TODO: Add your control notification handler code here
	if ((mode[CHA1]&0x03)<2)
	{
		i8080_ClrCnt( slot, CHA1);	
		i8080_ClrCnt( slot, CHB1);
	}
	else
		i8080_ClrCnt( slot, CHA1);
}

void CI8080Dlg::OnClearB1() 
{
	// TODO: Add your control notification handler code here
	i8080_ClrCnt( slot, CHB1);	
}

void CI8080Dlg::OnClearA2() 
{
	// TODO: Add your control notification handler code here
	if ((mode[CHA2]&0x03)<2)
	{
		i8080_ClrCnt( slot, CHA2);	
		i8080_ClrCnt( slot, CHB2);
	}
	else
		i8080_ClrCnt( slot, CHA2);	
}

void CI8080Dlg::OnClearB2() 
{
	// TODO: Add your control notification handler code here
	i8080_ClrCnt( slot, CHB2);	
}

void CI8080Dlg::OnClearA3() 
{
	// TODO: Add your control notification handler code here
	if ((mode[CHA3]&0x03)<2)
	{
		i8080_ClrCnt( slot, CHA3);	
		i8080_ClrCnt( slot, CHB3);
	}
	else
		i8080_ClrCnt( slot, CHA3);
}

void CI8080Dlg::OnClearB3() 
{
	// TODO: Add your control notification handler code here
	i8080_ClrCnt( slot, CHB3);	
}

void CI8080Dlg::OnReadBtn() 
{
	// TODO: Add your control notification handler code here

	ScanAllChannel();

	m_VA0.SetWindowText(temp1[0]);
	m_OA0.SetWindowText(temp2[0]);
	if ((mode[1]&0x3)>1)
	{
		m_VB0.SetWindowText(temp1[1]);
		m_OB0.SetWindowText(temp2[1]);
	}
	if ((mode[2]&0x3)>1)
	{
		m_VA1.SetWindowText(temp1[2]);
		m_OA1.SetWindowText(temp2[2]);
	}
	else
	{
		m_VA1.SetWindowText(temp1[1]);
		m_OA1.SetWindowText(temp2[1]);
	}
	if ((mode[3]&0x3)>1)
	{
		m_VB1.SetWindowText(temp1[3]);
		m_OB1.SetWindowText(temp2[3]);
	}

	if ((mode[4]&0x3)>1)
	{
		m_VA2.SetWindowText(temp1[4]);
		m_OA2.SetWindowText(temp2[4]);
	}
	else
	{
		m_VA2.SetWindowText(temp1[2]);
		m_OA2.SetWindowText(temp2[2]);
	}
	if ((mode[5]&0x3)>1)
	{
		m_VB2.SetWindowText(temp1[5]);
		m_OB2.SetWindowText(temp2[5]);
	}

	if ((mode[6]&0x3)>1)
	{
		m_VA3.SetWindowText(temp1[6]);
		m_OA3.SetWindowText(temp2[6]);
	}
	else
	{
		m_VA3.SetWindowText(temp1[3]);
		m_OA3.SetWindowText(temp2[3]);
	}

	if ((mode[7]&0x3)>1)
	{
		m_VB3.SetWindowText(temp1[7]);
		m_OB3.SetWindowText(temp2[7]);
	}
}

void CI8080Dlg::OnAutoScanBtn() 
{
	// TODO: Add your control notification handler code here
	if (!AutoRead)
	{
		SetTimer(101,100,NULL);	
		m_AutoScanBtn.SetWindowText(_T("Disable Auto Scan"));
		AutoRead=true;
		m_ReadBtn.EnableWindow(false);		
	}
	else
	{
		KillTimer(101);
		m_AutoScanBtn.SetWindowText(_T("Enable Auto Scan"));
		AutoRead=false;
		m_ReadBtn.EnableWindow(true);
	}			
}

void ScanAllChannel()
{
	int i;
	unsigned long Cnt32U;
	unsigned short Overflow;
	float f;

	for (i=0; i<8 ; i++)
	{
		switch (mode[i]&0x03)
		{
			case 0x00:
			case 0x01:
				i8080_ReadCntUpDown( slot, i, &Cnt32U, &Overflow);
				swprintf(temp1[i], _T("%X"), Cnt32U);
				swprintf(temp2[i], _T("%u"), Overflow);
				break;
			case 0x02:
				i8080_ReadFreq( slot, i, &f);
				swprintf(temp1[i], _T("%.1f"), f);
				swprintf(temp2[i], _T(" "));
				break;
			case 0x03:
				i8080_ReadCntUp( slot, i, &Cnt32U, &Overflow);
				swprintf(temp1[i], _T("%u"), Cnt32U);
				swprintf(temp2[i], _T("%u"), Overflow);
				break;
		}
	}
}

void CI8080Dlg::OnSelchangeComboChannel() 
{
	// TODO: Add your control notification handler code here
	channel=m_ComboChannel.GetCurSel();	
}

void CI8080Dlg::OnReadRegisterBtn() 
{
	// TODO: Add your control notification handler code here
	short j;
	TCHAR temp[20];
	i8080_ReadXorRegister(slot,&j);     // for human's double check	
	swprintf(temp,_T("%02X"),j);
	m_Register.SetWindowText(temp);
}

void CI8080Dlg::OnReadDiXorBtn() 
{
	// TODO: Add your control notification handler code here
	short j;
	TCHAR temp[20];
	i8080_ReadDiXor(slot,&j);       // read DI state after XorControl
	swprintf(temp,_T("%02X"),j);
	m_DiXor.SetWindowText(temp);	
}

void CI8080Dlg::OnReadFreqConfigBtn() 
{
	// TODO: Add your control notification handler code here
	i8080_ReadFreqConfiguration(slot,&AutoTT,&AutoVV,&LowTT,&LowVV,&HighTT,&HighVV);
	SetFreq=false;
	CFreqDlg FormFreqDlg=new CFreqDlg();
	int nResponse=FormFreqDlg.DoModal();
}

void CI8080Dlg::OnSetFreqConfigBtn() 
{
	// TODO: Add your control notification handler code here
	i8080_ReadFreqConfiguration(slot,&AutoTT,&AutoVV,&LowTT,&LowVV,&HighTT,&HighVV);
	SetFreq=true;
	CFreqDlg FormFreqDlg=new CFreqDlg();
	int nResponse=FormFreqDlg.DoModal();
	if (nResponse == IDOK)
	{
		AutoTT=FormFreqDlg.m_iAutoTT;
		AutoVV=FormFreqDlg.m_iAutoVV;
		LowTT=FormFreqDlg.m_iLowTT;
		LowVV=FormFreqDlg.m_iLowVV;
		HighTT=FormFreqDlg.m_iHighTT;
		HighVV=FormFreqDlg.m_iHighVV;

		i8080_SetFreqConfiguration(slot,AutoTT,AutoVV,LowTT,LowVV,HighTT,HighVV);
	}
}

BOOL CI8080Dlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (pMsg->message == WM_KEYDOWN)
	{
		pMsg->message = WM_HOTKEY;
	}	

	return CDialog::PreTranslateMessage(pMsg);
}
