using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Diagnostics;

namespace SendTCP
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        //================================================
        //            2007.12.20 Mac
        //1.iHǰerҦ
        //2.iHǰebinaryҦ
        //3.iHpolling/Timer覡۰ʶǰe
        //4.iHܶ}lPɶ(for polling/timer)
        //5.iH@ǰePέp
        //6.textbox̭rƤӦhᦳ۰ʲM
        //7.S@log
        //8.ƬOHinvoke覡[J,n令thread覡ӷ|n
        //  ϥthread覡,{̭Ϊ,nѨMoӰD
        //  polling覡Mwg[Japplication.doevent, iO٬O|Qd
        //  n찱polling,~|hnetworkstream
        //================================================
        private static string Version = "V1.0.0  2007/12/20";
        //s
        private TcpClient winconClient;
        private NetworkStream winconNetStream;
        private long lCmdPacketQuantity = 0;
        private long lCmdTotal = 0;
        private long lRevPacketSize = 0;
        private long lRevPacketQuantity = 0;
        private long lRevTotal = 0;
        private string endChr = "";
        private string sCmd="";
        private byte[] bCmd;

        private bool bPolling = false;
        /// <Button>
        /// 
        /// </Button>
        /// 
        private void btTimerStart_Click(object sender, EventArgs e)
        {
            if (rdDataBinary.Checked)
            {
                bCmd = HexStringToByteArray(txtMsg.Text);
                sCmd = ByteArrayToHexString(bCmd);
                txtCmdSize.Text = bCmd.Length.ToString();
            }
            else
            {
                sCmd = txtMsg.Text + endChr;
                txtCmdSize.Text = sCmd.Length.ToString();
            }
            
            btTimerStop.Enabled = true;
            btTimerStart.Enabled = false;
            btPolling.Enabled = false;
            btPollingStop.Enabled = false;
            rdDataBinary.Enabled = false;
            rdDataString.Enabled = false;
            panelEndChar.Enabled = false;
            txtStartTime.Text = System.DateTime.Now.ToString();
            txtStopTime.Text = "Stop Time";
            timerSend.Enabled = true;
        }
        private void btTimerStop_Click(object sender, EventArgs e)
        {
            timerSend.Enabled = false;
            btTimerStart.Enabled = true;
            btTimerStop.Enabled = false;
            btPolling.Enabled = true;
            btPollingStop.Enabled = true;
            rdDataBinary.Enabled = true;
            rdDataString.Enabled = true;
            panelEndChar.Enabled = true;
            txtStopTime.Text = System.DateTime.Now.ToString();
        }
        private void btClearSend_Click(object sender, EventArgs e)
        {
            txtSend.Text = "";
        }
        private void btClear_Click(object sender, EventArgs e)
        {
            txtReceive.Text = "";
            txtSend.Text = "";
        }
        private void btSetTimer_Click(object sender, EventArgs e)
        {
            timerSend.Interval = Int16.Parse(txtTimeInterval.Text);
        }
        private void btPolling_Click(object sender, EventArgs e)
        {
            btPollingStop.Visible = true;
            btPolling.Visible = false;
            bPolling = true;
            if (rdDataBinary.Checked)
            {
                bCmd = HexStringToByteArray(txtMsg.Text);
                sCmd = ByteArrayToHexString(bCmd);
                txtCmdSize.Text = bCmd.Length.ToString();
            }
            else
            {
                sCmd = txtMsg.Text + endChr;
                txtCmdSize.Text = sCmd.Length.ToString();
            }
            btSend.Enabled = false;
            btTimerStart.Enabled = false;
            panelEndChar.Enabled = false;
            txtStartTime.Text = System.DateTime.Now.ToString();
            txtStopTime.Text = "Stop Time";
            
            this.BeginInvoke(new EventHandler(PollingSendData));
        }
        private void PollingSendData(object s, EventArgs e)
        {
            while (bPolling)
            {
                Debug.WriteLine("Polling");
                lCmdPacketQuantity++;
                if (rdDataBinary.Checked)
                {
                    SendByteTCP(bCmd, sCmd);
                }
                else
                {
                    SendStringTCP(sCmd);
                }
                
            }
        }
        private void btClearAnalysis_Click(object sender, EventArgs e)
        {
            //lCmdPacketSize = 0;
            lCmdPacketQuantity = 0;
            lCmdTotal = 0;
            lRevPacketSize = 0;
            lRevPacketQuantity = 0;
            lRevTotal = 0;
            //txtCmdSize.Text = "0";
            txtCmdTotal.Text = "0";
            txtCmdTotalPacket.Text = "0";
            txtRevSize.Text = "0";
            txtRevTotal.Text = "0";
            txtRevTotalPacket.Text = "0";
        }
        private void btOpen_Click(object sender, EventArgs e)
        {
            IPAddress ipAddress = IPAddress.Parse(txtIP.Text);
            try
            {
                winconClient = new TcpClient();
                winconClient.Connect(ipAddress, Int32.Parse(txtPort.Text));
                winconNetStream = winconClient.GetStream();
                btClose.Enabled = true;
                btOpen.Enabled = false;
                btSend.Enabled = true;
            }
            catch (Exception err)
            {
                Console.WriteLine(err.ToString());
                //MessageBox.Show(err.ToString());
            }
            finally
            {
                winconClient.Close();
                Console.WriteLine("Port closed.");
            }
            btTimerStart.Enabled = true;
            btSend.Enabled = true;
            btPolling.Enabled = true;
            btPollingStop.Enabled = true;
            this.BeginInvoke(new EventHandler(AddReceive));
        }

        private void btClose_Click(object sender, EventArgs e)
        {
            winconNetStream.Close();
            winconClient.Client.Close();
            
            timerSend.Enabled = false;
            btOpen.Enabled = true;
            btClose.Enabled = false;
            btSend.Enabled = false;
            btTimerStart.Enabled = false;
            btSend.Enabled = false;
            btPolling.Enabled = false;
            btPollingStop.Enabled = false;
        }
        /// <RadioButton>
        /// 
        /// </RadioButton>
        private void rbLFCR_CheckedChanged(object sender, EventArgs e)
        {
            endChr = "\n\r";
        }
        private void rbCR_CheckedChanged(object sender, EventArgs e)
        {
            endChr = "\r";
        }
        private void rbCRLF_CheckedChanged(object sender, EventArgs e)
        {
            endChr = "\r\n";
        }
        private void rbLF_CheckedChanged(object sender, EventArgs e)
        {
            endChr = "\n";
        }
        private void rbNone_CheckedChanged(object sender, EventArgs e)
        {
            endChr = "";
        }
        private void rdDataString_CheckedChanged(object sender, EventArgs e)
        {
            txtMsg.Text = "string";
            panelEndChar.Enabled = true;
        }
        private void rdDataBinary_CheckedChanged(object sender, EventArgs e)
        {
            txtMsg.Text = "01 02 00 00 00 06 01 04 00 00 00 04";
            panelEndChar.Enabled = false;
        }

        /// <TextBox>
        /// 
        /// </TextBox>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void txtSend_TextChanged(object sender, EventArgs e)
        {
            if (txtSend.Text.Length > 3000)
                txtSend.Text = "";
        }
        private void txtReceive_TextChanged(object sender, EventArgs e)
        {
            if (txtReceive.Text.Length > 3000)
                txtReceive.Text = "";
        }


        /// <Polling>
        /// PollingҦ
        /// </Polling>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btPollingStop_Click(object sender, EventArgs e)
        {
            btPollingStop.Visible = false;
            btPolling.Visible = true;
            bPolling = false;
            btSend.Enabled = true;
            btTimerStart.Enabled = true;
            panelEndChar.Enabled = true;
            txtStopTime.Text = System.DateTime.Now.ToString();
        }
        /// <Timer>
        /// TimerҦ
        /// </Timer>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void timerSend_Tick(object sender, EventArgs e)
        {
            lCmdPacketQuantity++;
            if (rdDataBinary.Checked)
            {
                SendByteTCP(bCmd, sCmd);
            }
            else
            {
                SendStringTCP(sCmd);
            }
        }
        /// <Send>
        /// 
        /// </Send>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btSend_Click(object sender, EventArgs e)
        {
            lCmdPacketQuantity++;
            if (rdDataBinary.Checked)
            {
                bCmd = HexStringToByteArray(txtMsg.Text);
                sCmd = ByteArrayToHexString(bCmd);
                SendByteTCP(bCmd, sCmd);
                txtCmdSize.Text = bCmd.Length.ToString();
            }
            else
            {
                sCmd = txtMsg.Text + endChr;
                SendStringTCP(sCmd);
                txtCmdSize.Text = sCmd.Length.ToString();
            }
        }


        /// <SendString>
        /// ǰeString, tr
        /// </SendString>
        /// <param name="sData"></param>
        private void SendStringTCP(string sData)
        {
            try
            {
                Byte[] sendBytes = Encoding.ASCII.GetBytes(sData);
                winconNetStream.Write(sendBytes, 0, sendBytes.Length);
                txtSend.Text = txtSend.Text + sData;
                txtCmdTotalPacket.Text = lCmdPacketQuantity.ToString();
                lCmdTotal = lCmdTotal + sData.Length;
                txtCmdTotal.Text = lCmdTotal.ToString();
            }
            catch (Exception err)
            {
                Console.WriteLine(err.ToString());
                //MessageBox.Show(err.ToString());
                winconNetStream.Close();
                winconClient.Close();
                timerSend.Enabled = false;
                btOpen.Enabled = true;
                btClose.Enabled = false;
                btSend.Enabled = false;
                btTimerStart.Enabled = false;
                btSend.Enabled = false;
                btPolling.Enabled = false;
                btPollingStop.Enabled = false;
                Console.WriteLine("Port closed.");
            }
        }
        /// <SendByte>
        /// ǰeBinary, ܬO_CRC
        /// Modbus/RTUneCRC,쪺]|
        /// </SendByte>
        /// <param name="bData"></param>
        /// <param name="sData"></param>
        private void SendByteTCP(byte[] bData, string sData)
        {
            try
            {
                winconNetStream.Write(bData, 0, bData.Length);
                txtSend.Text = txtSend.Text + sData;
                txtCmdTotalPacket.Text = lCmdPacketQuantity.ToString();
                lCmdTotal = lCmdTotal + bData.Length;
                txtCmdTotal.Text = lCmdTotal.ToString();
            }
            catch (Exception err)
            {
                Console.WriteLine(err.ToString());
                //MessageBox.Show(err.ToString());
                winconNetStream.Close();
                winconClient.Close();
                timerSend.Enabled = false;
                btOpen.Enabled = true;
                btClose.Enabled = false;
                btSend.Enabled = false;
                btTimerStart.Enabled = false;
                btSend.Enabled = false;
                btPolling.Enabled = false;
                btPollingStop.Enabled = false;
                Console.WriteLine("Port closed.");
            }
        }

        
        /// <TCPReceive>
        /// 
        /// </TCPReceive>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        public void AddReceive(object s, EventArgs e)
        {
            Byte[] bDataTemp = new Byte[256];
            Byte[] bData;
            Int32 bytes;
            string responseData;
            do
            {
                try
                {
                
                    Debug.WriteLine("AddReceive");
                    if (winconNetStream.DataAvailable)
                    {
                        lRevPacketQuantity++;
                        bytes = winconNetStream.Read(bDataTemp, 0, bDataTemp.Length);
                        bData = new Byte[bytes];
                        for (int i = 0; i < bytes; i++)
                            bData[i] = bDataTemp[i];
                        lRevPacketSize = bytes;
                        lRevTotal = lRevTotal + lRevPacketSize;
                        responseData = "";
                        if (rdDataBinary.Checked)
                        {
                            responseData = ByteArrayToHexString(bData);
                        }
                        else
                        {
                            responseData = System.Text.Encoding.ASCII.GetString(bData, 0, bytes);
                        }
                        txtReceive.Text = txtReceive.Text + responseData;
                        txtRevSize.Text = lRevPacketSize.ToString();
                        txtRevTotal.Text = lRevTotal.ToString();
                        txtRevTotalPacket.Text = lRevPacketQuantity.ToString();
                    }
                    else
                    {
                        Console.WriteLine("Sorry.  You cannot read from this NetworkStream.");
                    }

                    Application.DoEvents();
                    
                }
                catch (Exception err)
                {
                    Console.WriteLine(err.ToString());
                    ////MessageBox.Show(err.ToString());
                }
            }
            while (this.Visible);
        }


        /// <SubFunction>
        /// 
        /// </SubFunction>
        /// <param name="bCmd"></param>
        /// <param name="bCRC"></param>
        /// <returns></returns>
        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0').PadRight(3, ' '));
            return sb.ToString().ToUpper();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.Text = "ICPDAS SendTCP " + Version;
        }

    }
}