﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _87k_dobit
{
    public partial class Form1 : Form
    {
        int SlotNumber = 0;
        int intTotalChannel;
        int intChannel;
        byte byteOnOff;

        public Form1()
        {
            InitializeComponent();
            InitData();
        }

        private void InitData()
        {
            cmbSlot.SelectedIndex = 2;
        }


        public void FL_CheckMF(byte byteOnOff)
        {
            IntPtr hPort;
            bool iRet;
            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Get slot data
            SlotNumber = Convert.ToInt16(cmbSlot.Text);

            //Get Channel data
            intTotalChannel = Convert.ToInt16(txtTotalChannel.Text);
            intChannel = Convert.ToInt16(txtWrCH.Text);

            //Write data
            if (!checkBox1.Checked)
            {
                iRet = PACNET.PAC_IO.WriteDOBit(hPort, SlotNumber, intTotalChannel, intChannel, Convert.ToInt32(byteOnOff));
            }
            else
            {
                iRet = true;
                MessageBox.Show("not supprot MF");
            }

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            byteOnOff = 1;
            FL_CheckMF(byteOnOff);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            byteOnOff = 0;
            FL_CheckMF(byteOnOff);
        }

    }
}