﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DeviceInformation
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            tbSerialNum.Text = PACNET.Sys.GetSerialNumber();
            tbCPUVer.Text = PACNET.Sys.GetCPUVersion();
            tbOSVer.Text = PACNET.Sys.GetOSVersion();
            tbSDKVer.Text = PACNET.Sys.GetPacSDKVersion();

            Console.WriteLine(PACNET.Sys.get_CPUtype());
            if (PACNET.Sys.get_CPUtype() == PACNET.Sys.ATOM)
                textBox1.Text = "ATOM";
            else if (PACNET.Sys.get_CPUtype() == PACNET.Sys.LX800)
                textBox1.Text = "LX800";
            else
                textBox1.Text = "Unknow";

            tbLan1MacAddr.Text = PACNET.Sys.GetMacAddress(1);
            tbLan2MacAddr.Text = PACNET.Sys.GetMacAddress(2);

            tbBackplaneID.Text = PACNET.Sys.GetBackplaneID();
            tbBattery1Lev.Text = PACNET.Sys.GetBatteryLevel(1).ToString();
            tbBattery2Lev.Text = PACNET.Sys.GetBatteryLevel(2).ToString();
        }
    }
}