#ifndef __RTTIMERDLLM_H
#define __RTTIMERDLLM_H



#ifdef __cplusplus
extern "C" {
#endif

#ifdef RTTIMERDLL_EXPORTS
#define RTT_DLL_API __declspec(dllexport)
#else
#define RTT_DLL_API __declspec(dllimport)
#endif

RTT_DLL_API	extern HANDLE volatile hUart;

RTT_DLL_API bool RTT_WriteBOOL(int memslot,bool bvalue);

RTT_DLL_API bool RTT_ReadBOOL(int memslot,bool *bvalue);

RTT_DLL_API bool RTT_WriteFLOAT(int memslot,float fvalue);

RTT_DLL_API bool RTT_ReadFLOAT(int memslot,float *fvalue);

RTT_DLL_API bool RTT_WriteDWORD(int memslot,DWORD dwvalue);

RTT_DLL_API bool RTT_ReadDWORD(int memslot,DWORD *dwvalue);


#ifdef __cplusplus
}
#endif


//#pragma comment(lib, "PACSDK.lib")
//#pragma warning(disable:4099)     //disable sprintf to sprintf_s warning


#endif //__RTTIMERDLLM_H    