﻿Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cmbSlot.SelectedIndex = 1
    End Sub

    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim intSlot As Integer
        Dim IDValue As UInteger = 0
        Dim iRet As Boolean
        Dim hPort As IntPtr

        'Open default com port , default com port is com 1
        hPort = PACNET.UART.Open("")

        'Get slot data
        intSlot = Convert.ToInt16(cmbSlot.Text)

        'Read data
        iRet = PACNET.PAC_IO.ReadCNT(hPort, intSlot, Convert.ToInt16(txtChannel.Text), IDValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        Else
            txtDiValue.Text = Convert.ToString(IDValue)
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        Dim intSlot As Integer
        Dim iRet As Boolean
        Dim hPort As IntPtr

        'Open default com port , default com port is com 1
        hPort = PACNET.UART.Open("")

        'Get slot data
        intSlot = Convert.ToInt16(cmbSlot.Text)

        'Clear data
        iRet = PACNET.PAC_IO.ClearCNT(hPort, intSlot, Convert.ToInt16(txtChannel.Text))

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        Else
            MessageBox.Show("Clear Success")
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Dim intSlot As Integer
        Dim IDValue As Integer = 0
        Dim iRet As Boolean
        Dim hPort As IntPtr

        'Open default com port , default com port is com 1
        hPort = PACNET.UART.Open("")

        'Get slot data
        intSlot = Convert.ToInt16(cmbSlot.Text)

        'Read data
        iRet = PACNET.PAC_IO.ReadCNTOverflow(hPort, intSlot, Convert.ToInt16(txtChannel.Text), IDValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        Else
            txtDiValue.Text = Convert.ToString(IDValue)
        End If

        PACNET.UART.Close(hPort)
    End Sub


End Class
