﻿Imports pac8014WNet
Public Class Form1

    Private Shared jumper As Int16 = 0, maxCh As Int16 = 8, gain As Int16 = 0
    Private Shared slotIndex As Int16 = 0

    Private Sub cboSlot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlot.SelectedIndexChanged
        Dim ret As Integer = -1
        Dim firmware As Int16, isofirm As Int16, libVer As Int16
        Dim SingleEndedStr As String() = New String(1) {}

        SingleEndedStr(0) = "Differential"
        SingleEndedStr(1) = "Single Ended"
        ret = pac8014W.Init(cboSlot.SelectedIndex)
        If ret = 0 Then
            slotIndex = cboSlot.SelectedIndex
            libVer = pac8014W.LibVersion()
            lbVer.Text = libVer.ToString("X")


            firmware = pac8014W.FirmwareVer_L1(slotIndex)
            ' pac8014W.FirmwareVer_L1(slotIndex);
            lbFirm1.Text = firmware.ToString()
            isofirm = pac8014W.FirmwareVer_L2(slotIndex)
            lbFirm2.Text = isofirm.ToString()

            jumper = pac8014W.SingleEndJumper(slotIndex)


            lbJumper.Text = SingleEndedStr(jumper)
        Else
            MessageBox.Show("I-8014W is not at slot " + cboSlot.SelectedIndex.ToString())
        End If
    End Sub

    Private Sub cboType0_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboType0.SelectedIndexChanged
        Dim gainValue As UInt16 = 0
        Dim offsetValue As Int16 = 0
        gain = cboType0.SelectedIndex
        pac8014W.ReadGainOffset(slotIndex, gain, gainValue, offsetValue)
        lbGain.Text = gainValue.ToString()
        lbOffset.Text = offsetValue.ToString()
    End Sub

    Private Sub btnAIHex_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAIHex.Click
        Dim txtAI As TextBox() = {txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, txtAI12, txtAI13, txtAI14, txtAI15}
        Dim ch As Int16
        Dim ret As Int16
        Dim fVal As Single = 0

        If jumper = 1 Then
            'Single Ended Mode
            maxCh = 16
        Else
            maxCh = 8
        End If

        For ch = 0 To maxCh - 1


            ret = pac8014W.ReadAI(slotIndex, ch, gain, fVal)
            If ret = 0 Then
                ' txtAI[ch].Text = "Gain[" + gain.ToString() + "] " + String.Format("{0:X4}",fVal);
                txtAI(ch).Text = fVal.ToString("F03")
            Else
                txtAI(ch).Text = "ReadAI Error = " + ret.ToString()
            End If
        Next ch

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()

    End Sub
End Class
