'pac_i8050WDemo folder: demo source code
'
'
'   Demo for I-8050W by C#
'    
'   I-8050W is a 16-channel universal Digital I/O module.
'   It doesn't need to do any setting for DI function.
'   Only DO function has to be set(Use pac_i8050W_UDIO_WriteConfig_16()).
'   
'   Warning:(English)														
'     A channel may be destroyed if it is subjected to an input 			
'	  signal(Vcc) while it is configured to be an output channel.			
'	  Please remove the external signal which connects to DI,				
'	  before changing the channel status from DI mode to DO mode			
'																			
'	Warning:(Traditional-Chinese)                                           
'  ĵi:()                                                                 
'		8050W@ӳqD]wDIBqDTJ(Vcc)ApGɱNqD	
'	    A]wDOAhoӳqDi|la								    
'		qDADIאּDOeAХNDI~Ju					
'
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports pac_i8050WNet
Imports Microsoft.VisualBasic

Public Class Form1
    Dim slot As Byte = 0 'Parameter

    Private Sub btnBasicInfor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBasicInfor.Click 'Get the system information from pac_i8050W



        Dim firmware_ver As UShort = pac8050W.GetFirmwareVersion(slot)
        Dim lib_ver As UShort = pac8050W.GetLibVersion()
        Dim net_ver As String = pac8050W.GetNetVersion()

        lblShowInfor.Text = "Firmware(lattice) version: " & firmware_ver.ToString() & vbLf & "Library version: " & Convert.ToString(lib_ver, 16) & vbLf & "Net version:" & net_ver
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        timerDI.Enabled = True
        cmbSlot.SelectedIndex = 0
    End Sub

    Private Sub cmbSlot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmbSlot.SelectedIndexChanged
        slot = Convert.ToByte(cmbSlot.SelectedItem.ToString())
    End Sub

    Private Sub timerDI_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timerDI.Tick
        If Not chkDO0_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H1) > 0 Then
                ptbDI0.Image = imageList1.Images(1)
            Else
                ptbDI0.Image = imageList1.Images(0)
            End If
        End If

        If Not chkDO1_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H2) > 0 Then
                ptbDI1.Image = imageList1.Images(1)
            Else
                ptbDI1.Image = imageList1.Images(0)
            End If
        End If

        If Not chkDO2_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H4) > 0 Then
                ptbDI2.Image = imageList1.Images(1)
            Else
                ptbDI2.Image = imageList1.Images(0)
            End If
        End If

        If Not chkDO3_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H8) > 0 Then
                ptbDI3.Image = imageList1.Images(1)
            Else
                ptbDI3.Image = imageList1.Images(0)
            End If
        End If

        If Not chkDO4_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H10) > 0 Then
                ptbDI4.Image = imageList1.Images(1)
            Else
                ptbDI4.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO5_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H20) > 0 Then
                ptbDI5.Image = imageList1.Images(1)
            Else
                ptbDI5.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO6_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H40) > 0 Then
                ptbDI6.Image = imageList1.Images(1)
            Else
                ptbDI6.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO7_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H80) > 0 Then
                ptbDI7.Image = imageList1.Images(1)
            Else
                ptbDI7.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO8_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H100) > 0 Then
                ptbDI8.Image = imageList1.Images(1)
            Else
                ptbDI8.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO9_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H200) > 0 Then
                ptbDI9.Image = imageList1.Images(1)
            Else
                ptbDI9.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO10_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H400) > 0 Then
                ptbDI10.Image = imageList1.Images(1)
            Else
                ptbDI10.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO11_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H800) > 0 Then
                ptbDI11.Image = imageList1.Images(1)
            Else
                ptbDI11.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO12_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H1000) > 0 Then
                ptbDI12.Image = imageList1.Images(1)
            Else
                ptbDI12.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO13_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H2000) > 0 Then
                ptbDI13.Image = imageList1.Images(1)
            Else
                ptbDI13.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO14_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H4000) > 0 Then
                ptbDI14.Image = imageList1.Images(1)
            Else
                ptbDI14.Image = imageList1.Images(0)
            End If
        End If
        If Not chkDO15_Config.Checked Then
            If (pac8050W.UDIO_DI16(slot) And &H8000) > 0 Then
                ptbDI15.Image = imageList1.Images(1)
            Else
                ptbDI15.Image = imageList1.Images(0)
            End If
        End If
    End Sub

    Private Sub DO_Config(ByVal slot As Byte, ByVal ch As Integer, ByVal bitvlaue As Integer) 'Set dX is dix or dox if bitvlaue == 1 dx become dox else become become dix
        If ch >= 0 AndAlso ch < 16 Then
            Dim value As Integer
            If bitvlaue = 1 Then
                value = pac8050W.UDIO_ReadConfig_16(slot)
                value = (value Or (1 << ch))
                pac8050W.UDIO_WriteConfig_16(slot, CUShort(value))
            ElseIf bitvlaue = 0 Then
                value = pac8050W.UDIO_ReadConfig_16(slot)
                value = value And Not (1 << ch)
                pac8050W.UDIO_WriteConfig_16(slot, CUShort(value))
            End If
        End If
    End Sub



    Private Sub chkDO0_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO0_Config.CheckStateChanged
        If chkDO0_Config.Checked Then
            DO_Config(slot, 0, 1)
            ptbDI0.Visible = False
            chkDO0.Enabled = True
        Else
            DO_Config(slot, 0, 0)
            ptbDI0.Visible = True
            chkDO0.Enabled = False
        End If
    End Sub

    Private Sub chkDO1_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO1_Config.CheckStateChanged
        If chkDO1_Config.Checked Then
            DO_Config(slot, 1, 1)
            ptbDI1.Visible = False
            chkDO1.Enabled = True
        Else
            DO_Config(slot, 1, 0)
            ptbDI1.Visible = True
            chkDO1.Enabled = False
        End If
    End Sub

    Private Sub chkDO2_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO2_Config.CheckStateChanged
        If chkDO2_Config.Checked Then
            DO_Config(slot, 2, 1)
            ptbDI2.Visible = False
            chkDO2.Enabled = True
        Else
            DO_Config(slot, 2, 0)
            ptbDI2.Visible = True
            chkDO2.Enabled = False
        End If
    End Sub

    Private Sub chkDO3_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO3_Config.CheckStateChanged
        If chkDO3_Config.Checked Then
            DO_Config(slot, 3, 1)
            ptbDI3.Visible = False
            chkDO3.Enabled = True
        Else
            DO_Config(slot, 3, 0)
            ptbDI3.Visible = True
            chkDO3.Enabled = False
        End If
    End Sub

    Private Sub chkDO4_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO4_Config.CheckStateChanged
        If chkDO4_Config.Checked Then
            DO_Config(slot, 4, 1)
            ptbDI4.Visible = False
            chkDO4.Enabled = True
        Else
            DO_Config(slot, 4, 0)
            ptbDI4.Visible = True
            chkDO4.Enabled = False
        End If
    End Sub

    Private Sub chkDO5_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO5_Config.CheckStateChanged
        If chkDO5_Config.Checked Then
            DO_Config(slot, 5, 1)
            ptbDI5.Visible = False
            chkDO5.Enabled = True
        Else
            DO_Config(slot, 5, 0)
            ptbDI5.Visible = True
            chkDO5.Enabled = False
        End If
    End Sub

    Private Sub chkDO6_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO6_Config.CheckStateChanged
        If chkDO6_Config.Checked Then
            DO_Config(slot, 6, 1)
            ptbDI6.Visible = False
            chkDO6.Enabled = True
        Else
            DO_Config(slot, 6, 0)
            ptbDI6.Visible = True
            chkDO6.Enabled = False
        End If
    End Sub

    Private Sub chkDO7_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO7_Config.CheckStateChanged
        If chkDO7_Config.Checked Then
            DO_Config(slot, 7, 1)
            ptbDI7.Visible = False
            chkDO7.Enabled = True
        Else
            DO_Config(slot, 7, 0)
            ptbDI7.Visible = True
            chkDO7.Enabled = False
        End If
    End Sub

    Private Sub chkDO8_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO8_Config.CheckStateChanged
        If chkDO8_Config.Checked Then
            DO_Config(slot, 8, 1)
            ptbDI8.Visible = False
            chkDO8.Enabled = True
        Else
            DO_Config(slot, 8, 0)
            ptbDI8.Visible = True
            chkDO8.Enabled = False
        End If
    End Sub

    Private Sub chkDO9_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO9_Config.CheckStateChanged
        If chkDO9_Config.Checked Then
            DO_Config(slot, 9, 1)
            ptbDI9.Visible = False
            chkDO9.Enabled = True
        Else
            DO_Config(slot, 9, 0)
            ptbDI9.Visible = True
            chkDO9.Enabled = False
        End If
    End Sub

    Private Sub chkDO10_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO10_Config.CheckStateChanged
        If chkDO10_Config.Checked Then
            DO_Config(slot, 10, 1)
            ptbDI10.Visible = False
            chkDO10.Enabled = True
        Else
            DO_Config(slot, 10, 0)
            ptbDI10.Visible = True
            chkDO10.Enabled = False
        End If
    End Sub

    Private Sub chkDO11_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO11_Config.CheckStateChanged
        If chkDO11_Config.Checked Then
            DO_Config(slot, 11, 1)
            ptbDI11.Visible = False
            chkDO11.Enabled = True
        Else
            DO_Config(slot, 11, 0)
            ptbDI11.Visible = True
            chkDO11.Enabled = False
        End If
    End Sub

    Private Sub chkDO12_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO12_Config.CheckStateChanged
        If chkDO12_Config.Checked Then
            DO_Config(slot, 12, 1)
            ptbDI12.Visible = False
            chkDO12.Enabled = True
        Else
            DO_Config(slot, 12, 0)
            ptbDI12.Visible = True
            chkDO12.Enabled = False
        End If
    End Sub

    Private Sub chkDO13_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO13_Config.CheckStateChanged
        If chkDO13_Config.Checked Then
            DO_Config(slot, 13, 1)
            ptbDI13.Visible = False
            chkDO13.Enabled = True
        Else
            DO_Config(slot, 13, 0)
            ptbDI13.Visible = True
            chkDO13.Enabled = False
        End If
    End Sub

    Private Sub chkDO14_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO14_Config.CheckStateChanged
        If chkDO14_Config.Checked Then
            DO_Config(slot, 14, 1)
            ptbDI14.Visible = False
            chkDO14.Enabled = True
        Else
            DO_Config(slot, 14, 0)
            ptbDI14.Visible = True
            chkDO14.Enabled = False
        End If
    End Sub

    Private Sub chkDO15_Config_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO15_Config.CheckStateChanged
        If chkDO15_Config.Checked Then
            DO_Config(slot, 15, 1)
            ptbDI15.Visible = False
            chkDO15.Enabled = True
        Else
            DO_Config(slot, 15, 0)
            ptbDI15.Visible = True
            chkDO15.Enabled = False
        End If
    End Sub

    Private Sub btnSelectAll_DOConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectAll_DOConfig.Click
        chkDO0_Config.Checked = True
        chkDO1_Config.Checked = True
        chkDO2_Config.Checked = True
        chkDO3_Config.Checked = True
        chkDO4_Config.Checked = True
        chkDO5_Config.Checked = True
        chkDO6_Config.Checked = True
        chkDO7_Config.Checked = True
        chkDO8_Config.Checked = True
        chkDO9_Config.Checked = True
        chkDO10_Config.Checked = True
        chkDO11_Config.Checked = True
        chkDO12_Config.Checked = True
        chkDO13_Config.Checked = True
        chkDO14_Config.Checked = True
        chkDO15_Config.Checked = True
    End Sub

    Private Sub btnClearAll_DOConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAll_DOConfig.Click
        chkDO0_Config.Checked = False
        chkDO1_Config.Checked = False
        chkDO2_Config.Checked = False
        chkDO3_Config.Checked = False
        chkDO4_Config.Checked = False
        chkDO5_Config.Checked = False
        chkDO6_Config.Checked = False
        chkDO7_Config.Checked = False
        chkDO8_Config.Checked = False
        chkDO9_Config.Checked = False
        chkDO10_Config.Checked = False
        chkDO11_Config.Checked = False
        chkDO12_Config.Checked = False
        chkDO13_Config.Checked = False
        chkDO14_Config.Checked = False
        chkDO15_Config.Checked = False
    End Sub

    Private Sub pac_i8050W_UDIO_WriteDOBit16(ByVal slot As Byte, ByVal channel As Integer, ByVal bitvalue As Integer) ' Send a signal to dox
        Dim Value As UShort = pac8050W.UDIO_ReadDO16(slot)
        Dim Value1 As Integer

        If channel >= 0 AndAlso channel < 16 Then
            If bitvalue = 1 Then
                Value1 = Value Or (&H1 << channel)
                pac8050W.UDIO_WriteDO16(slot, CUShort(Value1))
            ElseIf bitvalue = 0 Then
                Value1 = Value And (Not (&H1 << channel))
                pac8050W.UDIO_WriteDO16(slot, CUShort(Value1))
            End If
        End If

    End Sub

    Private Sub DO_Bit(ByVal slot As Byte, ByVal ch As Integer, ByVal bitvalue As Integer)
        If ch >= 0 AndAlso ch < 16 Then
            If bitvalue = 1 Then
                pac_i8050W_UDIO_WriteDOBit16(slot, ch, 1)
            ElseIf bitvalue = 0 Then
                pac_i8050W_UDIO_WriteDOBit16(slot, ch, 0)
            End If
        End If
    End Sub

    Private Sub chkDO0_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO0.CheckStateChanged
        If chkDO0.Checked Then
            DO_Bit(slot, 0, 1)
        Else
            DO_Bit(slot, 0, 0)
        End If
    End Sub

    Private Sub chkDO1_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO1.CheckStateChanged
        If chkDO1.Checked Then
            DO_Bit(slot, 1, 1)
        Else
            DO_Bit(slot, 1, 0)
        End If
    End Sub

    Private Sub chkDO2_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO2.CheckStateChanged
        If chkDO2.Checked Then
            DO_Bit(slot, 2, 1)
        Else
            DO_Bit(slot, 2, 0)
        End If
    End Sub

    Private Sub chkDO3_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO3.CheckStateChanged
        If chkDO3.Checked Then
            DO_Bit(slot, 3, 1)
        Else
            DO_Bit(slot, 3, 0)
        End If
    End Sub

    Private Sub chkDO4_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO4.CheckStateChanged
        If chkDO4.Checked Then
            DO_Bit(slot, 4, 1)
        Else
            DO_Bit(slot, 4, 0)
        End If
    End Sub

    Private Sub chkDO5_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO5.CheckStateChanged
        If chkDO5.Checked Then
            DO_Bit(slot, 5, 1)
        Else
            DO_Bit(slot, 5, 0)
        End If
    End Sub

    Private Sub chkDO6_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO6.CheckStateChanged
        If chkDO6.Checked Then
            DO_Bit(slot, 6, 1)
        Else
            DO_Bit(slot, 6, 0)
        End If
    End Sub

    Private Sub chkDO7_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO7.CheckStateChanged
        If chkDO7.Checked Then
            DO_Bit(slot, 7, 1)
        Else
            DO_Bit(slot, 7, 0)
        End If
    End Sub

    Private Sub chkDO8_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO8.CheckStateChanged
        If chkDO8.Checked Then
            DO_Bit(slot, 8, 1)
        Else
            DO_Bit(slot, 8, 0)
        End If
    End Sub

    Private Sub chkDO9_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO9.CheckStateChanged
        If chkDO9.Checked Then
            DO_Bit(slot, 9, 1)
        Else
            DO_Bit(slot, 9, 0)
        End If
    End Sub

    Private Sub chkDO10_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO10.CheckStateChanged
        If chkDO10.Checked Then
            DO_Bit(slot, 10, 1)
        Else
            DO_Bit(slot, 10, 0)
        End If
    End Sub

    Private Sub chkDO11_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO11.CheckStateChanged
        If chkDO11.Checked Then
            DO_Bit(slot, 11, 1)
        Else
            DO_Bit(slot, 11, 0)
        End If
    End Sub

    Private Sub chkDO12_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO12.CheckStateChanged
        If chkDO12.Checked Then
            DO_Bit(slot, 12, 1)
        Else
            DO_Bit(slot, 12, 0)
        End If
    End Sub

    Private Sub chkDO13_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO13.CheckStateChanged
        If chkDO13.Checked Then
            DO_Bit(slot, 13, 1)
        Else
            DO_Bit(slot, 13, 0)
        End If
    End Sub

    Private Sub chkDO14_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO14.CheckStateChanged
        If chkDO14.Checked Then
            DO_Bit(slot, 14, 1)
        Else
            DO_Bit(slot, 14, 0)
        End If
    End Sub

    Private Sub chkDO15_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDO15.CheckStateChanged
        If chkDO15.Checked Then
            DO_Bit(slot, 15, 1)
        Else
            DO_Bit(slot, 15, 0)
        End If
    End Sub

    Private Sub btnSelectAll_DOWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectAll_DOWrite.Click
        chkDO0.Checked = True
        chkDO1.Checked = True
        chkDO2.Checked = True
        chkDO3.Checked = True
        chkDO4.Checked = True
        chkDO5.Checked = True
        chkDO6.Checked = True
        chkDO7.Checked = True
        chkDO8.Checked = True
        chkDO9.Checked = True
        chkDO10.Checked = True
        chkDO11.Checked = True
        chkDO12.Checked = True
        chkDO13.Checked = True
        chkDO14.Checked = True
        chkDO15.Checked = True
    End Sub

    Private Sub btnClearAll_DOWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAll_DOWrite.Click
        chkDO0.Checked = False
        chkDO1.Checked = False
        chkDO2.Checked = False
        chkDO3.Checked = False
        chkDO4.Checked = False
        chkDO5.Checked = False
        chkDO6.Checked = False
        chkDO7.Checked = False
        chkDO8.Checked = False
        chkDO9.Checked = False
        chkDO10.Checked = False
        chkDO11.Checked = False
        chkDO12.Checked = False
        chkDO13.Checked = False
        chkDO14.Checked = False
        chkDO15.Checked = False
    End Sub
End Class
