﻿Imports pac8172WNet

Public Class Form1
    Private slotIndex As Integer = -1

    
   
    Private Sub WriteDOBit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckDO9.CheckStateChanged, ckDO8.CheckStateChanged, ckDO7.CheckStateChanged, ckDO6.CheckStateChanged, ckDO5.CheckStateChanged, ckDO4.CheckStateChanged, ckDO3.CheckStateChanged, ckDO2.CheckStateChanged, ckDO15.CheckStateChanged, ckDO14.CheckStateChanged, ckDO13.CheckStateChanged, ckDO12.CheckStateChanged, ckDO11.CheckStateChanged, ckDO10.CheckStateChanged, ckDO1.CheckStateChanged, ckDO0.CheckStateChanged
        Dim doBitArr As CheckBox() = New CheckBox() {ckDO0, ckDO1, ckDO2, ckDO3, ckDO4, ckDO5, ckDO6, ckDO7, ckDO8, ckDO9, ckDO10, ckDO11, ckDO12, ckDO13, ckDO14, ckDO15}
        Dim index As Int16 = Int16.Parse(DirectCast(sender, CheckBox).Tag.ToString())
        Dim portIndex As Integer = cboSelectPort.SelectedIndex
        Dim groupIndex As Integer = cboGroupDO.SelectedIndex

        If portIndex <> -1 AndAlso groupIndex <> -1 Then
            If doBitArr(index).Checked = True Then
                pac8172W.WriteDOBit(slotIndex, portIndex, groupIndex, index, 1)
            Else
                pac8172W.WriteDOBit(slotIndex, portIndex, groupIndex, index, 0)
            End If
        End If
    End Sub
    Private Sub DIO_WriteDOBit(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ckDIO_DO7.CheckStateChanged, ckDIO_DO6.CheckStateChanged, ckDIO_DO5.CheckStateChanged, ckDIO_DO4.CheckStateChanged, ckDIO_DO3.CheckStateChanged, ckDIO_DO2.CheckStateChanged, ckDIO_DO1.CheckStateChanged, ckDIO_DO0.CheckStateChanged
        Dim doBitArr As CheckBox() = New CheckBox() {ckDIO_DO0, ckDIO_DO1, ckDIO_DO2, ckDIO_DO3, ckDIO_DO4, ckDIO_DO5, ckDIO_DO6, ckDIO_DO7}
        Dim index As Int16 = Int16.Parse(DirectCast(sender, CheckBox).Tag.ToString())
        Dim portIndex As Integer = cboSelectPort.SelectedIndex
        Dim groupIndex As Integer = cboGroupDIO.SelectedIndex
        If portIndex <> -1 AndAlso groupIndex <> -1 Then
            If doBitArr(index).Checked = True Then
                pac8172W.DIO_WriteDOBit(slotIndex, portIndex, groupIndex, index, 1)
            Else
                pac8172W.DIO_WriteDOBit(slotIndex, portIndex, groupIndex, index, 0)
            End If
        End If
    End Sub
    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick
        Dim lineStatus As String() = New String() {"Off Line", "On Line"}
        Dim diBitArr As Label() = New Label() {lbDI0, lbDI1, lbDI2, lbDI3, lbDI4, lbDI5, _
         lbDI6, lbDI7, lbDI8, lbDI9, lbDI10, lbDI11, _
         lbDI12, lbDI13, lbDI14, lbDI15}
        Dim dio_diBitArr As Label() = New Label() {lbDIO_DI0, lbDIO_DI1, lbDIO_DI2, lbDIO_DI3, lbDIO_DI4, lbDIO_DI5, _
         lbDIO_DI6, lbDIO_DI7}
        Dim ch As Integer

        Dim portIndex As Integer = cboSelectPort.SelectedIndex
        Dim groupIndex As Integer = cboGroupDI.SelectedIndex


        ' to read FR-2053 DI bit (16 DI input)
        If portIndex <> -1 AndAlso groupIndex <> -1 Then
            ch = 0
            For ch = 0 To 15
                Dim status As UInt16 = pac8172W.ReadDIBit(slotIndex, portIndex, groupIndex + 8, ch)
                diBitArr(ch).Text = status.ToString()
            Next ch

            ' for FRnet input I/O, we can check the communicaton status
            Dim groupStatus As Integer = pac8172W.ReadInputGroupStatus(slotIndex, portIndex, groupIndex)
            lb53GroupStatus.Text = lineStatus(groupStatus)
        End If

        ' to read FR-2054 DI bit (8 DI input)
        portIndex = cboSelectPort.SelectedIndex
        groupIndex = cboGroupDIO.SelectedIndex
        If portIndex <> -1 AndAlso groupIndex <> -1 Then
            ch = 0
            For ch = 0 To 7
                Dim status As UInt16 = pac8172W.DIO_ReadDIBit(slotIndex, portIndex, groupIndex + 8, ch)
                dio_diBitArr(ch).Text = status.ToString()
                System.Math.Max(System.Threading.Interlocked.Increment(ch), ch - 1)
            Next ch
            ' for FRnet input I/O, we can check the communicaton status
            Dim groupStatus As Integer = pac8172W.ReadInputGroupStatus(slotIndex, portIndex, groupIndex)

            lb54GroupStatus.Text = lineStatus(groupStatus)
        End If
    End Sub
    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        timer1.Enabled = True
    End Sub
    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        timer1.Enabled = False
    End Sub


    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer = 0
        For i = 0 To 1
            cboSelectPort.Items.Add("Port " + i.ToString())
        Next i


        For i = 0 To 7
            cboSlotIndex.Items.Add("Slot " + i.ToString())
            ' for DI , group start from 8
            cboGroupDI.Items.Add((i + 8).ToString())
            ' for DIO, DO group start from 0 and DI group start from 8
            cboGroupDIO.Items.Add(i.ToString())
            ' for DO , group start from 0
            cboGroupDO.Items.Add(i.ToString())
        Next i

        cboGroupDO.SelectedIndex = -1
        cboGroupDIO.SelectedIndex = -1
        cboGroupDI.SelectedIndex = -1
        cboSelectPort.SelectedIndex = -1
    End Sub

   
   
    Private Sub cboSlotIndex_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlotIndex.SelectedIndexChanged
        Dim ret As Integer = pac8172W.Init(cboSlotIndex.SelectedIndex)
        If ret = 0 Then
            slotIndex = cboSlotIndex.SelectedIndex
            lbver.Text = [String].Format("{0:X4}", pac8172W.LibVersion())

            lbdate.Text = pac8172W.LibDate()
        Else
            lbStatus.Text = "Can not find I-8172 at Slot " + cboSlotIndex.SelectedIndex.ToString()
            lbver.Text = "-1"
            lbdate.Text = "none"
        End If
    End Sub

End Class
