﻿Imports System.IO.Ports

Public Class Form1
    Private hPort As IntPtr

    Public Sub New()
        InitializeComponent()
        Dim ports As String() = SerialPort.GetPortNames()
        Array.Sort(ports)

        For Each port As String In ports
            cmbPort.Items.Add(port)
        Next

        cmbPort.SelectedIndex = 0
    End Sub

    Private Sub btnOpenPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpenPort.Click
        'Open com port
        hPort = PACNET.UART.Open(cmbPort.Text + "," + txtBaurdRate.Text)
        btnOpenPort.Enabled = False
        btnClosePort.Enabled = True
    End Sub

    Private Sub btnClosePort_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClosePort.Click
        'Clos com port
        PACNET.UART.Close(hPort)
        btnClosePort.Enabled = False
        btnOpenPort.Enabled = True
    End Sub

    Private Sub btnSend_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSend.Click
        Dim iRet As Boolean
        Dim result As Byte() = New Byte(19) {}

        'Send command
        iRet = PACNET.UART.SendCmdExt(hPort, PACNET.MISC.AnsiString(txtSendValue.Text), txtSendValue.Text.Length, result, result.Length)
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            'Show Response to TextBox
            txtResponseValue.Text = PACNET.MISC.WideString(result)
        End If
    End Sub
End Class
