﻿Public Class Form1
    Dim hPort As IntPtr

    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        hPort = PACNET.UART.Open("COM" + cmbPort.Text + "," + txtBaudRate.Text)
        btnOpen.Enabled = False
        btnClose.Enabled = True
    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        PACNET.UART.Close(hPort)
        btnOpen.Enabled = True
        btnClose.Enabled = False
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Dim DIValue As UInteger = 0
        Dim DOValue As UInteger = 0
        Dim DIChannel As Integer = txtDIChannel.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim address As Integer = txtAddress.Text
        Dim iret As Boolean = PACNET.PAC_IO.ReadDIO(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(address), DIChannel, DOChannel, DIValue, DOValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtDIValue.Text = DIValue.ToString("X")
        End If
    End Sub

    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Dim address As Integer = txtAddress.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim value As UInteger = Convert.ToUInt32(txtDOValue.Text, 16)
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(address), DOChannel, value)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim DIValue As UInteger = 0
        Dim DOValue As UInteger = 0
        Dim DIChannel As Integer = txtDIChannel.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim address As Integer = txtAddress.Text
        Dim iret As Boolean = PACNET.PAC_IO.ReadDIO_MF(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(address), DIChannel, DOChannel, DIValue, DOValue)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        Else
            txtDIValue.Text = DIValue.ToString("X")
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim address As Integer = txtAddress.Text
        Dim DOChannel As Integer = txtDOChannel.Text
        Dim value As UInteger = Convert.ToUInt32(txtDOValue.Text, 16)
        Dim iret As Boolean = PACNET.PAC_IO.WriteDO_MF(hPort, PACNET.PAC_IO.PAC_REMOTE_IO(address), DOChannel, value)
        If Not iret Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() & vbLf & "Error Code: 0x" & ec.ToString("X"))
        End If
    End Sub
End Class
