﻿Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Namespace DIP
    Public Partial Class Form1
        Inherits Form
        Const ORIGIN_X As Integer = 10
        Const ORIGIN_Y As Integer = 10
        Const GAP_SLOT As Integer = 30
        Const UNIT_SLOT As Integer = 30
        Const GAP_LABEL_SLOT As Integer = 5
        
        Private dipValue As Integer
        Private numbers As Label() = New Label(7) {}
        Private [ON] As New Label()
        
        Public Sub New()
            InitializeComponent()
            
            'ON Label:
            [ON].Size = New Size(UNIT_SLOT, UNIT_SLOT / 2)
            [ON].Location = New Point(ORIGIN_X + GAP_SLOT, ORIGIN_Y + GAP_SLOT - GAP_LABEL_SLOT - UNIT_SLOT / 2)
            [ON].Font = New Font(FontFamily.GenericMonospace, 12, FontStyle.Bold)
            [ON].Text = "ON"
            [ON].ForeColor = Color.White
            [ON].BackColor = Color.Red
            Me.panel1.Controls.Add([ON])
            
            'number Labels:
            For i As Integer = 0 To 7
                numbers(i) = New Label()
                numbers(i).Size = New Size(UNIT_SLOT, UNIT_SLOT / 2)
                numbers(i).Location = New Point(ORIGIN_X + GAP_SLOT + (UNIT_SLOT + GAP_SLOT) * i, ORIGIN_Y + GAP_SLOT + UNIT_SLOT * 2 + GAP_LABEL_SLOT)
                numbers(i).Font = New Font(FontFamily.GenericMonospace, 12, FontStyle.Bold)
                numbers(i).Text = (i + 1).ToString()
                numbers(i).ForeColor = Color.White
                numbers(i).BackColor = Color.Red
                Me.panel1.Controls.Add(numbers(i))
            Next
        End Sub
        
        Private Sub panel1_Paint(ByVal sender As Object, ByVal e As PaintEventArgs)
            Dim RED As Brush = New SolidBrush(Color.Red)
            Dim WHITE As Brush = New SolidBrush(Color.White)
            Dim black As New Pen(Color.Black, 5)
            
            'Red base
            e.Graphics.FillRectangle(RED, ORIGIN_X, ORIGIN_Y, 9 * GAP_SLOT + 8 * UNIT_SLOT, 2 * GAP_SLOT + 2 * UNIT_SLOT)
            
            'White slots
            For i As Integer = 0 To 7
                e.Graphics.FillRectangle(WHITE, ORIGIN_X + GAP_SLOT + (UNIT_SLOT + GAP_SLOT) * i, ORIGIN_Y + GAP_SLOT, UNIT_SLOT, UNIT_SLOT * 2)
            Next
            
            'black slide
            For i As Integer = 0 To 7
                If 1 = ((dipValue >> i) And 1) Then
                    'ON
                    e.Graphics.DrawRectangle(black, ORIGIN_X + GAP_SLOT + (UNIT_SLOT + GAP_SLOT) * i, ORIGIN_Y + GAP_SLOT, UNIT_SLOT, UNIT_SLOT)
                Else
                    'OFF
                    e.Graphics.DrawRectangle(black, ORIGIN_X + GAP_SLOT + (UNIT_SLOT + GAP_SLOT) * i, ORIGIN_Y + GAP_SLOT + UNIT_SLOT, UNIT_SLOT, UNIT_SLOT)
                End If
            Next
        End Sub
        
        Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs)
            dipValue = PACNET.Sys.GetDIPSwitch()
            textBox1.Text = dipValue.ToString("X")
            panel1.Refresh()
        End Sub
        
        Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs)
            button1_Click(sender, e)
        End Sub
    End Class
End Namespace


