Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Runtime.InteropServices
Imports System.Text
Imports System.Threading
Imports System.Windows.Forms

Public Class Form1
    <DllImport("PACSDK.dll", EntryPoint:="_pac_get_partition_info")> _
Public Shared Function pac_get_partition_info(ByVal szPartName As String, ByVal szFileSys As String, ByVal szVolName As String) As Boolean
    End Function

    Friend Delegate Sub SetButtonCallback(ByVal flag As Boolean)

    'INSTANT VB WARNING: The following constructor is declared outside of its associated class:
    'ORIGINAL LINE: public Form1()
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs)
        MicroSDInfo()
        Dim worker As New ThreadStart(AddressOf btn_work)
        Dim t As New Thread(worker)
        t.Start()
    End Sub

    Public Sub MicroSDInfo()
        Dim strName As New String(" "c, 256)
        Dim strFileSys As New String(" "c, 256)
        Dim strVolName As New String(" "c, 256)

        pac_get_partition_info(strName, strFileSys, strVolName)

        labelFileSystem.Text = strFileSys
        labelPartitionName.Text = strName
        labelVolumeName.Text = strVolName.Substring(1)
    End Sub
    Private Sub btn_work()
        Do
            Thread.Sleep(1000)
            If PACNET.Memory.SDOnside() Then
                If PACNET.Memory.SDExists() Then
                    SetBtn1(False)
                    SetBtn2(True)
                Else
                    SetBtn1(True)
                    SetBtn2(False)
                End If
            Else
                SetBtn1(False)
                SetBtn2(False)
            End If
        Loop
    End Sub

    Private Sub SetBtn1(ByVal flag As Boolean)
        If Me.buttonMount.InvokeRequired Then
            Dim d As New SetButtonCallback(AddressOf SetBtn1)
            Me.Invoke(d, New Object() {flag})
        Else
            Me.buttonMount.Enabled = flag
        End If
    End Sub

    Private Sub SetBtn2(ByVal flag As Boolean)
        If Me.buttonUnmount.InvokeRequired Then
            Dim d As New SetButtonCallback(AddressOf SetBtn2)
            Me.Invoke(d, New Object() {flag})
        Else
            Me.buttonUnmount.Enabled = flag
        End If
    End Sub

    Private Sub buttonMount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonMount.Click
        PACNET.Memory.SDMount("Part00")
        buttonMount.Enabled = False
        buttonUnmount.Enabled = True
        MicroSDInfo()
    End Sub

    Private Sub buttonUnmount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonUnmount.Click
        PACNET.Memory.SDUnmount()
        buttonMount.Enabled = True
        buttonUnmount.Enabled = False
        MicroSDInfo()
    End Sub
End Class
