// GetRotaryIDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetRotaryID.h"
#include "GetRotaryIDDlg.h"
#include "PACSDK.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CGetRotaryIDDlg dialog

CGetRotaryIDDlg::CGetRotaryIDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetRotaryIDDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetRotaryIDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CGetRotaryIDDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CGetRotaryIDDlg message handlers

BOOL CGetRotaryIDDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//default start timer
	OnStartTimer();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CGetRotaryIDDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_GETROTARYID_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_GETROTARYID_DIALOG));
	}
}
#endif

void CGetRotaryIDDlg::OnStartTimer(){
	//set 1 timer , interval 0.5 second and haven't call back function
	SetTimer(1,500,0);
}

void CGetRotaryIDDlg::OnTimer(UINT nIDEvent){
	TCHAR temp[30];
	if(nIDEvent ==1){
		//get rotary id and set value in TextBox
		int ID = pac_GetRotaryID();
		wsprintf(temp,L"%d",ID);
		SetDlgItemText(IDC_EDIT1,temp);
	}

}

void CGetRotaryIDDlg::StopTimer(){
	KillTimer(1);
}