// UARTDlg.cpp : implementation file
//

#include "stdafx.h"
#include "UART.h"
#include "UARTDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CUARTDlg dialog

CUARTDlg::CUARTDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUARTDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUARTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CUARTDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CUARTDlg::OnBnClickedButton1)
END_MESSAGE_MAP()


// CUARTDlg message handlers

BOOL CUARTDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	//set default value
	SetDlgItemText(IDC_EDIT1,L"COM3,115200,8,N,1");
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CUARTDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_UART_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_UART_DIALOG));
	}
}
#endif


void CUARTDlg::OnBnClickedButton1()
{
	// TODO: Add your control notification handler code here
	char command[30];
	char result[30]={0};
	CString temp;
	TCHAR Lresult[30];
	HANDLE hPort;
	//get user com port setting 
	GetDlgItemText(IDC_EDIT1,temp);
	for(int i=0;i<temp.GetAllocLength();i++){
		command[i] = temp[i];
	}
	hPort = uart_Open(command);

	//get user send command
	ZeroMemory(command,30);
	GetDlgItemText(IDC_EDIT2,temp);
	for(int i=0;i<temp.GetAllocLength();i++){
		command[i] = temp[i];
	}

	uart_SetTimeOut(hPort,1000,CTO_TIMEOUT_ALL);

	//send command and receving result
	uart_SendCmdExt(hPort,command,30,result,30); //uart_SendCmdExt is supported in XPACSDK_CE.dll v2011 or later and PACSDK.dll
	int length = strlen(result);
	ZeroMemory(Lresult,30);
	for(int i=0;i<length;i++){
		Lresult[i] = result[i];
	}
	SetDlgItemText(IDC_EDIT3,Lresult);

	uart_Close(hPort);

}
