// 87k_aoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_ao.h"
#include "87k_aoDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
short iSlot;
short iAOChannels,iChannel_Written;
char cTmp[15];
float fAOValue;

/////////////////////////////////////////////////////////////////////////////
// CMy87k_aoDlg dialog

CMy87k_aoDlg::CMy87k_aoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_aoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_aoDlg)
	m_AOChannels = _T("");
	m_AOValue = _T("");
	m_Channel_Written = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_aoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_aoDlg)
	DDX_Control(pDX, IDC_COMBOAOSlot, m_cmbAOSlot);
	DDX_Text(pDX, IDC_EDITAOChannels, m_AOChannels);
	DDX_Text(pDX, IDC_EDITAOValue, m_AOValue);
	DDX_Text(pDX, IDC_EDITCh_Written, m_Channel_Written);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_aoDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_aoDlg)
	ON_BN_CLICKED(IDC_BUTTONWriteAO, OnBUTTONWriteAO)
	ON_BN_CLICKED(IDC_BUTTONClearAO, OnBUTTONClearAO)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_aoDlg message handlers

BOOL CMy87k_aoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbAOSlot.SetCurSel(0);
	m_AOChannels=_T("8");
	m_Channel_Written=_T("0");
	m_AOValue=_T("0.0");
	UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy87k_aoDlg::OnBUTTONWriteAO() 
{
	// TODO: Add your control notification handler code here
		
	//First open com port
	HANDLE hPort;
	hPort = uart_Open("");


	//Get the slot where the 87K AO module is
	iSlot=m_cmbAOSlot.GetCurSel ();
	
	UpdateData(true);
	//Get AO channels
	wcstombs(cTmp,m_AOChannels,15);
	iAOChannels=atoi(cTmp);
	
	//Get the channel which is written
	wcstombs(cTmp,m_Channel_Written,15);
	iChannel_Written=atoi(cTmp);
	
	//Get AO value to write
	wcstombs(cTmp,m_AOValue,15);
	fAOValue=atof(cTmp);
	
	//Write AO 	  
	bool res=pac_WriteAO(hPort, iSlot, iChannel_Written, iAOChannels, fAOValue);
	if(!res) AfxMessageBox(_T("No module or module is wrong or something wrong"));

	//Close com port
	uart_Close(hPort);
}

void CMy87k_aoDlg::OnBUTTONClearAO() 
{
	// TODO: Add your control notification handler code here
	//Open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K AO module is
	pac_ChangeSlot(iSlot);

	//Clear AO 
	bool res = pac_WriteAO(hPort, iSlot, iChannel_Written, iAOChannels, 0);	
	m_AOValue=_T("0.0");
	UpdateData(false);
	
	//Close com port
	uart_Close(hPort);
}
