// 87k_ao_poweron_safeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_ao_poweron_safe.h"
#include "87k_ao_poweron_safeDlg.h"

#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy87k_ao_poweron_safeDlg dialog

CMy87k_ao_poweron_safeDlg::CMy87k_ao_poweron_safeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_ao_poweron_safeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_ao_poweron_safeDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_ao_poweron_safeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_ao_poweron_safeDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_ao_poweron_safeDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_ao_poweron_safeDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_ao_poweron_safeDlg message handlers

BOOL CMy87k_ao_poweron_safeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy87k_ao_poweron_safeDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    char ctemp[20];
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user set write channel
    GetDlgItemText(IDC_EDIT2, temp, 20);
    int WriteChannel = _wtoi(temp);

    //get user set write data
    GetDlgItemText(IDC_EDIT3, strTemp);

    for(int i = 0; i < sizeof(strTemp); i++)
    {
        ctemp[i] = strTemp[i];
    }

    fValue = (float)atof(ctemp);

    //use pac_WriteAO functio to write AO data
    BOOL iret = pac_WriteAO(hPort, slot, WriteChannel, TotalChannel, fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write AO error", L"87k_ao_poweron_safe", MB_OK);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user set write channel
    GetDlgItemText(IDC_EDIT2, temp, 20);
    int WriteChannel = _wtoi(temp);

    //use pac_ReadAO function
    BOOL iret = pac_ReadAO(hPort, slot, WriteChannel, TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read AO error", L"87k_ao_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read AO: %.4f", fValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	//uart_Open function parameter is "", it's open COM0 port and baud rate set 115200
    //COM0 port connect to backplane
    HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user will write channel
    GetDlgItemText(IDC_EDIT2, temp, 20);
    int WriteChannel = _wtoi(temp);

    //use pac_WriteAO function to write data
    BOOL iret = pac_WriteAO(hPort, slot, WriteChannel, TotalChannel, fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Clear AO error", L"87k_ao_poweron_safe", MB_OK);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set WTD Timeout
    GetDlgItemText(IDC_EDIT5, temp, 20);
    int WTDTimeout = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_SetModuleWDTConfig(hPort, slot, 1, WTDTimeout, 0);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Config WDT error", L"87k_ao_poweron_safe", MB_OK);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    short ebStatus;
    ulong WTDTimeout;
    int WTDOverwrite;
    //use pac_GetModuleWDTConfig function
    BOOL iret = pac_GetModuleWDTConfig(hPort, slot, &ebStatus, &WTDTimeout, &WTDOverwrite);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Get Module WDT Config error", L"87k_ao_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%u", WTDTimeout);
        SetDlgItemText(IDC_EDIT5, temp);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_ResetModuleWDT(hPort, slot);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Reset Module WDT error", L"87k_ao_poweron_safe", MB_OK);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //use pac_SetModuleWDTConfig function
    BOOL iret = pac_RefreshModuleWDT(hPort, slot);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Refresh Module WDT error", L"87k_ao_poweron_safe", MB_OK);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user set write channel
    GetDlgItemText(IDC_EDIT2, temp, 20);
    int Channel = _wtoi(temp);

    //use pac_ReadAO function
    BOOL iret = pac_ReadModulePowerOnValueAO(hPort, slot, Channel, TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read PowerOn ValueAO error", L"87k_ao_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read PowerOn ValueAO: %.4f", fValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    char ctemp[20];
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user set write channel
    GetDlgItemText(IDC_EDIT2, temp, 20);
    int WriteChannel = _wtoi(temp);

    //get user set write data
    GetDlgItemText(IDC_EDIT3, strTemp);

    for(int i = 0; i < sizeof(strTemp); i++)
    {
        ctemp[i] = strTemp[i];
    }

    fValue = (float)atof(ctemp);

    //use pac_WriteAO functio to write AO data
    BOOL iret = pac_WriteModulePowerOnValueAO(hPort, slot, WriteChannel, TotalChannel, fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write PowerOn ValueAO error", L"87k_ao_poweron_safe", MB_OK);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton10() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user set write channel
    GetDlgItemText(IDC_EDIT2, temp, 20);
    int Channel = _wtoi(temp);

    //use pac_ReadAO function
    BOOL iret = pac_ReadModuleSafeValueAO(hPort, slot, Channel, TotalChannel, &fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read Safe ValueAO error", L"87k_ao_poweron_safe", MB_OK);
    }
    else
    {
        wsprintf(temp, L"Read Safe ValueAO: %.4f", fValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy87k_ao_poweron_safeDlg::OnButton11() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort = uart_Open("");
    TCHAR temp[20];
    CString strTemp;
    char ctemp[20];
    float fValue = 0.0;

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int TotalChannel = _wtoi(temp);

    //get user set write channel
    GetDlgItemText(IDC_EDIT2, temp, 20);
    int WriteChannel = _wtoi(temp);

    //get user set write data
    GetDlgItemText(IDC_EDIT3, strTemp);

    for(int i = 0; i < sizeof(strTemp); i++)
    {
        ctemp[i] = strTemp[i];
    }

    fValue = (float)atof(ctemp);

    //use pac_WriteAO functio to write AO data
    BOOL iret = pac_WriteModuleSafeValueAO(hPort, slot, WriteChannel, TotalChannel, fValue);
    uart_Close(hPort);

    if(!iret)
    {
        ::MessageBox(NULL, L"Write Safe ValueAO error", L"87k_ao_poweron_safe", MB_OK);
    }
}
