// 87k_diDlg.cpp : implementation file
//

#include "stdafx.h"
#include "87k_di.h"
#include "87k_diDlg.h"
#include "PACSDK.h"
				
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy87k_diDlg dialog

CMy87k_diDlg::CMy87k_diDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy87k_diDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy87k_diDlg)
	m_DIChannels = _T("");
	m_DIValue = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy87k_diDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy87k_diDlg)
	DDX_Control(pDX, IDC_COMBODISlot, m_cmbDISlot);
	DDX_Control(pDX, IDC_BUTTONReadDI, m_btnReadDI);
	DDX_Text(pDX, IDC_EDITDIChannels, m_DIChannels);
	DDX_Text(pDX, IDC_EDITDIValue, m_DIValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy87k_diDlg, CDialog)
	//{{AFX_MSG_MAP(CMy87k_diDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI, OnBUTTONReadDI)
	ON_BN_CLICKED(IDC_BUTTONReadDI2, OnBUTTONReadDI2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy87k_diDlg message handlers

BOOL CMy87k_diDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbDISlot.SetCurSel(0);
	m_DIChannels=_T("8");
	UpdateData(false);
	SetDlgItemText(IDC_EDIT1, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");


	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy87k_diDlg::OnBUTTONReadDI() 
{
	// TODO: Add your control notification handler code here
	short iSlot=0,iDITotalCh;
	unsigned long lDIValue;
	char cTmp[10];

	//First open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K DI module is
	iSlot=m_cmbDISlot.GetCurSel ();

	//Get DI Channel value
	UpdateData(true);
	wcstombs(cTmp,m_DIChannels,10);
	iDITotalCh=atoi(cTmp);
	
	//Read DI
	
	bool res = pac_ReadDI( hPort, iSlot,iDITotalCh,&lDIValue);
    if(!res) {
		//Close com port
    	uart_Close(hPort);
		AfxMessageBox(_T("No module or module is wrong or something wrong"));
		return;
	}

	//Show DI value
	sprintf(cTmp,"%lx",lDIValue);
	m_DIValue=cTmp;
	UpdateData(false);

	//Close com port
	uart_Close(hPort);
}

void CMy87k_diDlg::OnBUTTONReadDI2() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	short iSlot=0,iDITotalCh;
	unsigned long lDIValue;
	char cTmp[10];

	//First open com port
	HANDLE hPort;
	hPort = uart_Open("");

	//Get the slot where the 87K DI module is
	iSlot=m_cmbDISlot.GetCurSel ();

	//Get DI Channel value
	UpdateData(true);
	wcstombs(cTmp,m_DIChannels,10);
	iDITotalCh=atoi(cTmp);
	
	//Read DI
	
	bool res = pac_ReadDI_MF( hPort, iSlot,iDITotalCh,&lDIValue);
    if(!res) {
		//Close com port
    	uart_Close(hPort);
		AfxMessageBox(_T("No module or module is wrong or something wrong"));
		return;
	}

	//Show DI value
	sprintf(cTmp,"%lx",lDIValue);
	m_DIValue=cTmp;
	UpdateData(false);

	//Close com port
	uart_Close(hPort);
}
