// 8k_87k_diDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_87k_di.h"
#include "8k_87k_diDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//Base variables
int iDI_Slot,iTotalCh;
CString csTmp;
char cTmp[10];
DWORD dwDIValue;


/////////////////////////////////////////////////////////////////////////////
// CMy8k_87k_diDlg dialog

CMy8k_87k_diDlg::CMy8k_87k_diDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_87k_diDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy8k_87k_diDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_87k_diDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy8k_87k_diDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_EDITDIValue8k, m_editDIValue);
	DDX_Control(pDX, IDC_EDITDIChannels8k, m_editDIChannels);
	DDX_Control(pDX, IDC_COMBODISlot8k, m_cmbDISlot);

	DDX_Control(pDX, IDC_EDITDIValue87k, m_DIValue2);
	DDX_Control(pDX, IDC_EDITDIChannels87k, m_DIChannels2);
	DDX_Control(pDX, IDC_COMBODISlot87k, m_cmbDISlot2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy8k_87k_diDlg, CDialog)
	//{{AFX_MSG_MAP(CMy8k_87k_diDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI8k87k, OnBUTTONReadDI8k87k)
	ON_BN_CLICKED(IDC_BUTTONReadDI8k87k2, OnBUTTONReadDI8k87k2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy8k_87k_diDlg message handlers

BOOL CMy8k_87k_diDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbDISlot.SetCurSel(0);
	m_editDIChannels.SetWindowText (_T("4"));

	m_cmbDISlot2.SetCurSel(0);
	m_DIChannels2.SetWindowText (_T("4"));

	SetDlgItemText(IDC_EDIT1, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

		
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy8k_87k_diDlg::OnBUTTONReadDI8k87k() 
{
	// TODO: Add your control notification handler code here
	int Type;
	short iSlot=0,iDITotalCh;
	unsigned long lDIValue;
	char cTmp[10];

	//First open com port 87k
	HANDLE hPort;
	hPort = uart_Open("");

	//Get slot where the module is
	iDI_Slot=m_cmbDISlot.GetCurSel();

	//Get the slot where the 87K DI module is
	iSlot=m_cmbDISlot2.GetCurSel ();

	
	Type=pac_GetModuleType(iDI_Slot);
	
	if(Type==0xe3 || Type==0xc3)
	{
		//The module is DI module
	} 
	else 
	{
		AfxMessageBox(_T("No 8k module or 8k Module is wrong")); 
		return;
	}
	
	//Get 8k DI Channel value
	m_editDIChannels.GetWindowText (csTmp); 
	wcstombs(cTmp,csTmp,10); 
	iTotalCh=atoi(cTmp);

	//Get 87k DI Channel value
	UpdateData(true);
	wcstombs(cTmp,csTmp,10);
	iDITotalCh=atoi(cTmp);

	pac_ReadDI(0, iDI_Slot, iTotalCh, &dwDIValue); //8k

	bool res = pac_ReadDI(hPort, iSlot, iDITotalCh, &lDIValue); //87k
    if(!res) {
		//Close com port
    	uart_Close(hPort);
		AfxMessageBox(_T("No 87k module or 87k module is wrong or something wrong"));
		return;
	}
	   
	//Show 8k DI value
	sprintf(cTmp,"%lx",dwDIValue);
	csTmp=cTmp;
	m_editDIValue.SetWindowText (csTmp);

	//Show 87k DI value
	sprintf(cTmp,"%lx",lDIValue);
	csTmp=cTmp;
	m_DIValue2.SetWindowText (csTmp);

	//Close com port 87k
	uart_Close(hPort);
}

void CMy8k_87k_diDlg::OnBUTTONReadDI8k87k2() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	int Type;
	short iSlot=0,iDITotalCh;
	unsigned long lDIValue;
	char cTmp[10];

	//First open com port 87k
	HANDLE hPort;
	hPort = uart_Open("");

	//Get slot where the module is
	iDI_Slot=m_cmbDISlot.GetCurSel();

	//Get the slot where the 87K DI module is
	iSlot=m_cmbDISlot2.GetCurSel ();

	
	Type=pac_GetModuleType(iDI_Slot);
	
	if(Type==0xe3 || Type==0xc3)
	{
		//The module is DI module
	} 
	else 
	{
		AfxMessageBox(_T("No 8k module or 8k Module is wrong")); 
		return;
	}
	
	//Get 8k DI Channel value
	m_editDIChannels.GetWindowText (csTmp); 
	wcstombs(cTmp,csTmp,10); 
	iTotalCh=atoi(cTmp);

	//Get 87k DI Channel value
	UpdateData(true);
	wcstombs(cTmp,csTmp,10);
	iDITotalCh=atoi(cTmp);

	pac_ReadDI(0, iDI_Slot, iTotalCh, &dwDIValue); //8k

	bool res = pac_ReadDI_MF(hPort, iSlot, iDITotalCh, &lDIValue); //87k
    if(!res) {
		//Close com port
    	uart_Close(hPort);
		AfxMessageBox(_T("No 87k module or 87k module is wrong or something wrong"));
		return;
	}
	   
	//Show 8k DI value
	sprintf(cTmp,"%lx",dwDIValue);
	csTmp=cTmp;
	m_editDIValue.SetWindowText (csTmp);

	//Show 87k DI value
	sprintf(cTmp,"%lx",lDIValue);
	csTmp=cTmp;
	m_DIValue2.SetWindowText (csTmp);

	//Close com port 87k
	uart_Close(hPort);
}
