// 8k_87k_dioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_87k_dio.h"
#include "8k_87k_dioDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


int iDIO_Slot,iDITotalCh=0,iDOTotalCh=0;
CString csTmp;
//char cTmp[10];
DWORD dwDIValue;

//base variables
short iSlot,iDIChannels,iDOChannels;
char cTmp[15];
unsigned long lDIValue,lDOValue;


/////////////////////////////////////////////////////////////////////////////
// CMy8k_87k_dioDlg dialog

CMy8k_87k_dioDlg::CMy8k_87k_dioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_87k_dioDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy8k_87k_dioDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_87k_dioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy8k_87k_dioDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_EDITDOValue8k, m_editDOValue);
	DDX_Control(pDX, IDC_COMBODIOSlot8k, m_cmbDIOSlot);
	DDX_Control(pDX, IDC_EDITDOChannels8k, m_editDOChs);
	DDX_Control(pDX, IDC_EDITDIValue8k, m_editDIValue);
	DDX_Control(pDX, IDC_EDITDIChannels8k, m_editDIChs);

	DDX_Control(pDX, IDC_COMBODIOSlot87k, m_cmbDIOSlot2);

	DDX_Text(pDX, IDC_EDITDIChannels87k, m_DIChs);
	DDX_Text(pDX, IDC_EDITDIValue87k, m_DIValue);
	DDX_Text(pDX, IDC_EDITDOChannels87k, m_DOChs);
	DDX_Text(pDX, IDC_EDITDOValue87k, m_DOValue);

	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy8k_87k_dioDlg, CDialog)
	//{{AFX_MSG_MAP(CMy8k_87k_dioDlg)
	ON_BN_CLICKED(IDC_BUTTONReadDI8k87k, OnBUTTONReadDI8k87k)
	ON_BN_CLICKED(IDC_BUTTONWriteDO8k87k, OnBUTTONWriteDO8k87k)
	ON_BN_CLICKED(IDC_BUTTONClearDO8k87k, OnBUTTONClearDO8k87k)
	ON_BN_CLICKED(IDC_BUTTONReadDI8k87k2, OnBUTTONReadDI8k87k2)
	ON_BN_CLICKED(IDC_BUTTONWriteDO8k87k2, OnBUTTONWriteDO8k87k2)
	ON_BN_CLICKED(IDC_BUTTONClearDO8k87k2, OnBUTTONClearDO8k87k2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy8k_87k_dioDlg message handlers

BOOL CMy8k_87k_dioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbDIOSlot.SetCurSel(0);
	m_editDIChs.SetWindowText (_T("8"));
	m_editDOChs.SetWindowText (_T("8"));
	m_editDOValue.SetWindowText (_T("FF"));

	m_cmbDIOSlot2.SetCurSel(0);
	m_DOChs=m_DIChs=_T("8");
	m_DOValue=_T("FF");
	UpdateData(false);

	SetDlgItemText(IDC_EDIT1, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMy8k_87k_dioDlg::OnBUTTONReadDI8k87k() 
{
	// TODO: Add your control notification handler code here
	int Type;

	//First,Open com port 87k
	HANDLE hPort;
	hPort = uart_Open("");

	//Get slot where the 8k module is
	iDIO_Slot=m_cmbDIOSlot.GetCurSel();
	
	Type=pac_GetModuleType(iDIO_Slot);
	if(Type==0xe2 || Type==0xc2)
	{
			//The module is DIO module
	} 
	else 
	{
		AfxMessageBox(_T("No 8k module or 8k Module is wrong")); 
		return;
	}

	//Get the slot where the 87K DIO module is
	iSlot=m_cmbDIOSlot2.GetCurSel ();



	//Get 8k DI value
	m_editDIChs.GetWindowText (csTmp); 
	wcstombs(cTmp,csTmp,10); 
	iDITotalCh=atoi(cTmp);

	UpdateData(true);
	//Get 87k DI Channels
	wcstombs(cTmp,m_DIChs,15);
	iDIChannels=atoi(cTmp);

	//Get 87k DO Channels
	wcstombs(cTmp,m_DOChs,15);
	iDOChannels=atoi(cTmp);
	
	//8k
	pac_ReadDI(0, iDIO_Slot, iDITotalCh, &dwDIValue);

	//Read 87k DI,DO values
	bool res = pac_ReadDIO( hPort, iSlot,iDIChannels,iDOChannels,&lDIValue,&lDOValue);
	
	if(!res) 
	{
		AfxMessageBox(_T("No 87k module or 87k module is wrong or something wrong"));
		return;
	}
    
	//Show 8k DI value
	sprintf(cTmp,"%lx",dwDIValue);
	csTmp=cTmp;
	m_editDIValue.SetWindowText (csTmp);

	//Show 87k DI value
	sprintf(cTmp,"%lx",lDIValue);
	m_DIValue=cTmp;
	UpdateData(false);

	//Close com port
	uart_Close(hPort);
}




void CMy8k_87k_dioDlg::OnBUTTONWriteDO8k87k() 
{
	// TODO: Add your control notification handler code here
	DWORD dwDOData;
	int Type;

	//First,Open com port 87k
	HANDLE hPort;
	hPort = uart_Open("");
	
	//Get slot where the 8k module is
	iDIO_Slot=m_cmbDIOSlot.GetCurSel();
	
	Type=pac_GetModuleType(iDIO_Slot);
	if(Type==0xe2 || Type==0xc2)
	{
			//The module is DIO module
	} 
	else 
	{
		AfxMessageBox(_T("No 8k module or 8k Module is wrong")); 
		return;
	}

	//Get the slot where the 87K DIO module is
	iSlot=m_cmbDIOSlot2.GetCurSel ();

	//Get total channels of 8k DO
	m_editDOChs.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);

	//Set 8k DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);

	UpdateData(true);

	//Get 87k DO Channels
	wcstombs(cTmp,m_DOChs,15);
	iDOChannels=atoi(cTmp);

	//Get 87k DO value
	wcstombs(cTmp,m_DOValue,15);
	sscanf(cTmp,"%lx",&lDOValue);

	//8k
	pac_WriteDO(0, iDIO_Slot,iDOTotalCh,dwDOData);

	//Write 87k DO
	bool res=pac_WriteDO(hPort, iSlot,iDOChannels,lDOValue);
	if(!res) 
		AfxMessageBox(_T("No 87k module or 87k module is wrong or something wrong"));
	//Close com port
	uart_Close(hPort);
}

void CMy8k_87k_dioDlg::OnBUTTONClearDO8k87k() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort;
	hPort = uart_Open("");

	//8k
	pac_WriteDO( 0, iDIO_Slot, iDOTotalCh, 0);
	//87k
	bool res = pac_WriteDO(hPort, iSlot,iDOChannels,0);	

	uart_Close(hPort);	
}

void CMy8k_87k_dioDlg::OnBUTTONReadDI8k87k2() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	int Type;

	//First,Open com port 87k
	HANDLE hPort;
	hPort = uart_Open("");

	//Get slot where the 8k module is
	iDIO_Slot=m_cmbDIOSlot.GetCurSel();
	
	Type=pac_GetModuleType(iDIO_Slot);
	if(Type==0xe2 || Type==0xc2)
	{
			//The module is DIO module
	} 
	else 
	{
		AfxMessageBox(_T("No 8k module or 8k Module is wrong")); 
		return;
	}

	//Get the slot where the 87K DIO module is
	iSlot=m_cmbDIOSlot2.GetCurSel ();



	//Get 8k DI value
	m_editDIChs.GetWindowText (csTmp); 
	wcstombs(cTmp,csTmp,10); 
	iDITotalCh=atoi(cTmp);

	UpdateData(true);
	//Get 87k DI Channels
	wcstombs(cTmp,m_DIChs,15);
	iDIChannels=atoi(cTmp);

	//Get 87k DO Channels
	wcstombs(cTmp,m_DOChs,15);
	iDOChannels=atoi(cTmp);
	
	//8k
	pac_ReadDI(0, iDIO_Slot, iDITotalCh, &dwDIValue);

	//Read 87k DI,DO values
	bool res = pac_ReadDIO_MF( hPort, iSlot,iDIChannels,iDOChannels,&lDIValue,&lDOValue);
	
	if(!res) 
	{
		AfxMessageBox(_T("No 87k module or 87k module is wrong or something wrong"));
		return;
	}
    
	//Show 8k DI value
	sprintf(cTmp,"%lx",dwDIValue);
	csTmp=cTmp;
	m_editDIValue.SetWindowText (csTmp);

	//Show 87k DI value
	sprintf(cTmp,"%lx",lDIValue);
	m_DIValue=cTmp;
	UpdateData(false);

	//Close com port
	uart_Close(hPort);
}

void CMy8k_87k_dioDlg::OnBUTTONWriteDO8k87k2() 
{
	// TODO: Add your control notification handler code here
	DWORD dwDOData;
	int Type;

	//First,Open com port 87k
	HANDLE hPort;
	hPort = uart_Open("");
	
	//Get slot where the 8k module is
	iDIO_Slot=m_cmbDIOSlot.GetCurSel();
	
	Type=pac_GetModuleType(iDIO_Slot);
	if(Type==0xe2 || Type==0xc2)
	{
			//The module is DIO module
	} 
	else 
	{
		AfxMessageBox(_T("No 8k module or 8k Module is wrong")); 
		return;
	}

	//Get the slot where the 87K DIO module is
	iSlot=m_cmbDIOSlot2.GetCurSel ();

	//Get total channels of 8k DO
	m_editDOChs.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);

	//Set 8k DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);

	UpdateData(true);

	//Get 87k DO Channels
	wcstombs(cTmp,m_DOChs,15);
	iDOChannels=atoi(cTmp);

	//Get 87k DO value
	wcstombs(cTmp,m_DOValue,15);
	sscanf(cTmp,"%lx",&lDOValue);

	//8k
	pac_WriteDO(0, iDIO_Slot,iDOTotalCh,dwDOData);

	//Write 87k DO
	bool res=pac_WriteDO_MF(hPort, iSlot,iDOChannels,lDOValue);
	if(!res) 
		AfxMessageBox(_T("No 87k module or 87k module is wrong or something wrong"));
	//Close com port
	uart_Close(hPort);
	
}

void CMy8k_87k_dioDlg::OnBUTTONClearDO8k87k2() 
{
	// TODO: Add your control notification handler code here
	HANDLE hPort;
	hPort = uart_Open("");

	//8k
	pac_WriteDO( 0, iDIO_Slot, iDOTotalCh, 0);
	//87k
	bool res = pac_WriteDO_MF(hPort, iSlot,iDOChannels,0);	

	uart_Close(hPort);		
}
