// 8k_doDlg.cpp : implementation file
//

#include "stdafx.h"
#include "8k_do.h"
#include "8k_doDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Base variables
int iDO_Slot,iDOTotalCh=0;
CString csTmp;
char cTmp[10];
/////////////////////////////////////////////////////////////////////////////
// CMy8k_doDlg dialog

CMy8k_doDlg::CMy8k_doDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy8k_doDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy8k_doDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy8k_doDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy8k_doDlg)
	DDX_Control(pDX, IDC_BUTTONWriteDO, m_btnWriteDO);
	DDX_Control(pDX, IDC_BUTTONDOClear, m_btnClearDO);
	DDX_Control(pDX, IDC_EDITDOValue, m_editDOValue);
	DDX_Control(pDX, IDC_EDITDOChannels, m_editDOChannels);
	DDX_Control(pDX, IDC_COMBODOSlot, m_cmbDOSlot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy8k_doDlg, CDialog)
	//{{AFX_MSG_MAP(CMy8k_doDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnbtnWriteDO)
	ON_BN_CLICKED(IDC_BUTTONDOClear, OnBUTTONDOClear)
	ON_BN_CLICKED(IDC_BUTTONWriteDO, OnBUTTONWriteDO)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy8k_doDlg message handlers

BOOL CMy8k_doDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbDOSlot.SetCurSel(0);
	m_editDOChannels.SetWindowText (_T("4"));
	m_editDOValue.SetWindowText (_T("01"));
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CMy8k_doDlg::OnbtnWriteDO() 
{
	// TODO: Add your control notification handler code here
	DWORD dwDOData;
	int Type;
	HANDLE hPort;
	
	//Get slot where the module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();

	Type=pac_GetModuleType(iDO_Slot);
	if(Type==0xe0 || Type==0xc0){
			//The module is DO module
	} 
	else {
		AfxMessageBox(_T("No module or Module is wrong")); 
		return;
	}


	//Get total channels of DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);

	//Set DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);

	hPort = uart_Open("");
	pac_WriteDO( hPort, iDO_Slot, iDOTotalCh, dwDOData);	
	uart_Close(hPort);
  }


void CMy8k_doDlg::OnBUTTONDOClear() 
{
	// TODO: Add your control notification handler code here
	//Clear DO value

	pac_WriteDO( 0, iDO_Slot, iDOTotalCh,0);

	m_editDOValue.SetWindowText (_T("0"));
}

void CMy8k_doDlg::OnBUTTONWriteDO() 
{
	// TODO: Add your control notification handler code here
	DWORD dwDOData;
	
	//Get slot where the module is
	iDO_Slot=m_cmbDOSlot.GetCurSel();

	//Get total channels of DO
	m_editDOChannels.GetWindowText(csTmp); 
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	iDOTotalCh=atoi(cTmp);

	//Set DO data
	m_editDOValue.GetWindowText(csTmp);
	wcstombs(cTmp,csTmp,sizeof(cTmp));
	sscanf(cTmp,"%lx",&dwDOData);
	pac_WriteDO(0, iDO_Slot,iDOTotalCh,dwDOData);
}
