// find_ioDlg.cpp : implementation file
//

#include "stdafx.h"
#include "find_io.h"
#include "find_ioDlg.h"
#include "PACSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFind_ioDlg dialog

CFind_ioDlg::CFind_ioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFind_ioDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFind_ioDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFind_ioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFind_ioDlg)
	DDX_Control(pDX, IDC_EDITModuleType, m_editModuleType);
	DDX_Control(pDX, IDC_EDITModuleName, m_editModuleName);
	DDX_Control(pDX, IDC_BUTTONSearchIO, m_btnSearchIO);
	DDX_Control(pDX, IDC_COMBOSlot, m_cmbSlot);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFind_ioDlg, CDialog)
	//{{AFX_MSG_MAP(CFind_ioDlg)
	ON_BN_CLICKED(IDC_BUTTONSearchIO, OnBUTTONSearchIO)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFind_ioDlg message handlers

BOOL CFind_ioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	m_cmbSlot.SetCurSel(0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CFind_ioDlg::OnBUTTONSearchIO() 
{
	// TODO: Add your control notification handler code here
	int iSlot;
	int iModuleType;
	int res;
	CString csTmp;
	char cTmp[10];
	
	//Get Slot
	iSlot=m_cmbSlot.GetCurSel ();
	
	//Read Module Type
	iModuleType=pac_GetModuleType(iSlot);
	if(iModuleType==0) csTmp=_T("No module");
	else{
		sprintf(cTmp,"0x%02x",iModuleType);
		csTmp=cTmp;
	}
	m_editModuleType.SetWindowText (csTmp);

	//Read Module Name
	char ModuleName[10];
	res=pac_GetModuleName(iSlot,ModuleName);
	if(res!=0) csTmp=ModuleName;
	m_editModuleName.SetWindowText (csTmp);

}
