// 7k_di_cntDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k_di_cnt.h"
#include "7k_di_cntDlg.h"

#include "PACSDK.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMy7k_di_cntDlg dialog

CMy7k_di_cntDlg::CMy7k_di_cntDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k_di_cntDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7k_di_cntDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k_di_cntDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7k_di_cntDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7k_di_cntDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7k_di_cntDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7k_di_cntDlg message handlers

BOOL CMy7k_di_cntDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	SetDlgItemText(IDC_EDIT7, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

HANDLE hPort;

void CMy7k_di_cntDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	TCHAR OpenPort[10];
    TCHAR temp[20];
    char port[20];
    //get user set address
    GetDlgItemText(IDC_COMBO1, OpenPort, 10);

    //get user set total channel
    GetDlgItemText(IDC_EDIT2, temp, 20);
    int BuadRate = _wtoi(temp);

    //uart_Open parameter format is COMx,buadrate  , for ex will set COM3 port and baud rate 9600 to uart_Open,
    //parameter is "COM3,9600"
    sprintf(port, "%ls,%d", OpenPort, BuadRate);
    hPort = uart_Open(port);

    //if hPort value is INVALID_HANDLE_VALUE , that is error
    if(hPort == INVALID_HANDLE_VALUE)
    {
        ::MessageBox(NULL, L"Open Port Error", L"7k_di_cnt", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
    }
}

void CMy7k_di_cntDlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	if(!uart_Close(hPort))
    {
        ::MessageBox(NULL, L"Close Port Error", L"7k_di_cnt", MB_OK);
    }
    else
    {
        GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
        GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
        GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
    }
}

void CMy7k_di_cntDlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];
    DWORD DIValue = 0;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //use pac_ReadDI functio to read DI data
    BOOL iret = pac_ReadDI(hPort, PAC_REMOTE_IO(address), channel, &DIValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read DI error", L"7k_di_cnt", MB_OK);
    }
    else
    {
        wsprintf(temp, L"0x%lx", DIValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }
}

void CMy7k_di_cntDlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ClearDICNT(hPort, slot, DICNTchannel, channel);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_di_cnt", MB_OK);
    }
}

void CMy7k_di_cntDlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);
    DWORD DIValue;

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ReadDICNT(hPort, slot, DICNTchannel, channel, &DIValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_di_cnt", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%d", DIValue);
        SetDlgItemText(IDC_EDIT6, temp);
    }
}

void CMy7k_di_cntDlg::OnButton6() 
{
// TODO: Add your control notification handler code here
	TCHAR temp[20];
    DWORD DIValue = 0;

    //get user set address
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int address = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT3, temp, 20);
    int channel = _wtoi(temp);

    //use pac_ReadDI functio to read DI data
    BOOL iret = pac_ReadDI_MF(hPort, PAC_REMOTE_IO(address), channel, &DIValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read DI error", L"7k_di_cnt", MB_OK);
    }
    else
    {
        wsprintf(temp, L"0x%lx", DIValue);
        SetDlgItemText(IDC_EDIT4, temp);
    }	
}

void CMy7k_di_cntDlg::OnButton7() 
{
// TODO: Add your control notification handler code here
	TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ClearDICNT_MF(hPort, slot, DICNTchannel, channel);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_di_cnt", MB_OK);
    }	
}

void CMy7k_di_cntDlg::OnButton8() 
{
// TODO: Add your control notification handler code here
	TCHAR temp[20];

    //get user set slot
    GetDlgItemText(IDC_COMBO1, temp, 20);
    int slot = _wtoi(temp);

    //get user set total channel
    GetDlgItemText(IDC_EDIT1, temp, 20);
    int channel = _wtoi(temp);

    GetDlgItemText(IDC_EDIT5, temp, 20);
    int DICNTchannel = _wtoi(temp);
    DWORD DIValue;

    //use pac_ReadAI functio to read DI data
    BOOL iret = pac_ReadDICNT_MF(hPort, slot, DICNTchannel, channel, &DIValue);

    if(!iret)
    {
        ::MessageBox(NULL, L"Read data error", L"7k_di_cnt", MB_OK);
    }
    else
    {
        wsprintf(temp, L"%d", DIValue);
        SetDlgItemText(IDC_EDIT6, temp);
    }	
}
