// 7k87k_doDlg.cpp : implementation file
//

#include "stdafx.h"
#include "7k87k_do.h"
#include "7k87k_doDlg.h"

#include "PACSDK.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//Base variables
unsigned char cPort;
/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_doDlg dialog

CMy7k87k_doDlg::CMy7k87k_doDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMy7k87k_doDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMy7k87k_doDlg)
	m_strAddr = _T("");
	m_dwBaud = 0;
	m_iDOChs = 0;
	m_strDOValue = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMy7k87k_doDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMy7k87k_doDlg)
	DDX_Control(pDX, IDC_COMBOCom, m_cmbCom);
	DDX_Text(pDX, IDC_EDITAddr, m_strAddr);
	DDX_Text(pDX, IDC_EDITBaud, m_dwBaud);
	DDX_Text(pDX, IDC_EDITDOChs, m_iDOChs);
	DDX_Text(pDX, IDC_EDITDOValue, m_strDOValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMy7k87k_doDlg, CDialog)
	//{{AFX_MSG_MAP(CMy7k87k_doDlg)
	ON_BN_CLICKED(IDC_BUTTONWriteDO, OnBUTTONWriteDO)
	ON_BN_CLICKED(IDC_BUTTONWriteDO2, OnBUTTONWriteDO2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMy7k87k_doDlg message handlers

BOOL CMy7k87k_doDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	//Set default value
	m_cmbCom.SetCurSel(2);
	m_strAddr=_T("01");
	m_dwBaud=115200;
	m_iDOChs=8;
	UpdateData(false);
	SetDlgItemText(IDC_EDIT1, L"What is pac_xxx_MF?\r\nMF is the abbreviation of Multi-function.\r\npac_xxx_MF is used to access DIO channels of the Multi-function module.\r\nAIO or counter modules equipped with DI or DO channel is known as Multi-function module.\r\nCall pac_xxxx function to access DIO channels of the DCON module equipped only with DI or DO channel.\r\nCall pac_xxx_MF functions to access DIO channel of the Multi-function module.\r\n");

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMy7k87k_doDlg::OnBUTTONWriteDO() 
{
	// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[10];
	unsigned long lDO_Value=0;
	char ConnectionString[32];

	int cPort=m_cmbCom.GetCurSel();
	UpdateData(true);
	//Get module address
	wcstombs(cTmp,m_strAddr,10);
	sscanf(cTmp,"%x",&iAddr);
	
	//Get DO value
	wcstombs(cTmp,m_strDOValue,10);//m_strDOValue.GetLength());
	sscanf(cTmp,"%lx",&lDO_Value);

	
	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);

	//Write DO value to remote module
	HANDLE hPort = uart_Open(ConnectionString);
	if(hPort==INVALID_HANDLE_VALUE ) AfxMessageBox(_T("Open Com Error"));

	bool ret = pac_WriteDO(hPort, PAC_REMOTE_IO(iAddr), m_iDOChs, lDO_Value);	

	uart_Close(hPort);
}

void CMy7k87k_doDlg::OnBUTTONWriteDO2() 
{
	// TODO: Add your control notification handler code here
	short iAddr=0;
	char cTmp[10];
	unsigned long lDO_Value=0;
	char ConnectionString[32];

	int cPort=m_cmbCom.GetCurSel();
	UpdateData(true);
	//Get module address
	wcstombs(cTmp,m_strAddr,10);
	sscanf(cTmp,"%x",&iAddr);
	
	//Get DO value
	wcstombs(cTmp,m_strDOValue,10);//m_strDOValue.GetLength());
	sscanf(cTmp,"%lx",&lDO_Value);

	
	sprintf(ConnectionString, "COM%d:,%d,N,8,1", cPort, m_dwBaud);

	//Write DO value to remote module
	HANDLE hPort = uart_Open(ConnectionString);
	if(hPort==INVALID_HANDLE_VALUE ) AfxMessageBox(_T("Open Com Error"));

	bool ret = pac_WriteDO_MF(hPort, PAC_REMOTE_IO(iAddr), m_iDOChs, lDO_Value);	

	uart_Close(hPort);	
}
