// BPTIMERDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BPTIMER.h"
#include "BPTIMERDlg.h"
#include "winpacsdk.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/*extern bool pac_SetBPTimer_(int type,unsigned int uElapse, PAC_TIMEROUT_CALLBACK_FUNC f);
extern void pac_KillBPTimer_(int type);
extern bool pac_SetBPTimerOut_(unsigned int uHighElapse,unsigned int uLOwElapse, PAC_TIMEROUT_CALLBACK_FUNC f);*/

//#define _DEFAULT_V
/////////////////////////////////////////////////////////////////////////////
// CBPTIMERDlg dialog

CBPTIMERDlg::CBPTIMERDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBPTIMERDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBPTIMERDlg)
	m_timer1 = _T("50000"); //50ms
	m_timer2 = _T("1000"); //100 ms
	m_timerouthigh = _T("20000");//20ms
	m_timeroutLow = _T("30000");//30ms
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBPTIMERDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBPTIMERDlg)
	DDX_Control(pDX, IDC_COMBO1, m_slot);
	DDX_Text(pDX, IDC_EDIT2, m_timer1);
	DDX_Text(pDX, IDC_EDIT4, m_timer2);
	DDX_Text(pDX, IDC_EDIT1, m_timerouthigh);
	DDX_Text(pDX, IDC_EDIT3, m_timeroutLow);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBPTIMERDlg, CDialog)
	//{{AFX_MSG_MAP(CBPTIMERDlg)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBPTIMERDlg message handlers
int gislot=0;

BOOL CBPTIMERDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_slot.SetCurSel(1);
	gislot=1;

	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

unsigned int gbtrigger=0;

int CALLBACK CTIMER1() //Interrupt Function
{
	int ivalue;
	int i;

	if(!gbtrigger) //rising edge type
	{
		gbtrigger=1;		
		_pac_slot_outp(gislot,0,0xFF);
	

	}
	else//falling edge type
	{
		gbtrigger=0;
		_pac_slot_outp(gislot,0,0x0);

	}	


    return PAC_INTR_DONE;
}
//extern bool pac_SetBPTimerInterruptPriority(int type, int nPriority);
void CBPTIMERDlg::OnButton2() 
{
	TCHAR tcTemp[100]={0};
	unsigned int uitimeout=0;


	GetDlgItemText(IDC_EDIT2,tcTemp,100);
	//Get bp retrigger
	uitimeout= _wtoi(tcTemp);
#ifdef _DEFAULT_V
	uitimeout=50000;
#endif
	pac_SetBPTimer(1,uitimeout,CTIMER1); //1us
	
	pac_SetBPTimerInterruptPriority(1,5);

}

void CBPTIMERDlg::OnButton5() 
{

 pac_KillBPTimer(1);	

}

void CBPTIMERDlg::OnButton1() 
{
	TCHAR tcTemp[100]={0};
	unsigned int uitimeoutHigh=0;
	unsigned int uitimeoutLow=0;


	GetDlgItemText(IDC_EDIT1,tcTemp,100);
	//Get bp retrigger
	uitimeoutHigh= _wtoi(tcTemp);
#ifdef _DEFAULT_V
	uitimeoutHigh=20000;
#endif
	GetDlgItemText(IDC_EDIT3,tcTemp,100);
	//Get bp retrigger
	uitimeoutLow= _wtoi(tcTemp);
#ifdef _DEFAULT_V
	uitimeoutLow=30000;
#endif

	pac_SetBPTimerOut(uitimeoutHigh,uitimeoutLow,CTIMER1);
	pac_SetBPTimerInterruptPriority(0,5);
	
}

void CBPTIMERDlg::OnButton6() 
{
	pac_KillBPTimer(0);
	
}

void CBPTIMERDlg::OnButton3() 
{
	TCHAR tcTemp[100]={0};
	unsigned int uitimeout=0;

	GetDlgItemText(IDC_EDIT4,tcTemp,100);
	//Get bp retrigger
	uitimeout= _wtoi(tcTemp);
#ifdef _DEFAULT_V
	uitimeout=10000;
#endif

	pac_SetBPTimer(2,uitimeout,CTIMER1);	
	pac_SetBPTimerInterruptPriority(2,5);
}

void CBPTIMERDlg::OnButton7() 
{
 pac_KillBPTimer(2);	
}

void CBPTIMERDlg::OnSelchangeCombo1() 
{
	gislot= m_slot.GetCurSel();
	//printf("slot=%d",gislot);
}
