// BackplaneInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BackplaneInfo.h"
#include "BackplaneInfoDlg.h"

#include "WinPacSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBackplaneInfoDlg dialog

CBackplaneInfoDlg::CBackplaneInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBackplaneInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBackplaneInfoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBackplaneInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBackplaneInfoDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBackplaneInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CBackplaneInfoDlg)
	ON_BN_CLICKED(IDC_DIP, OnDip)
	ON_BN_CLICKED(IDC_BK, OnBk)
	ON_BN_CLICKED(IDC_SLOT, OnSlot)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBackplaneInfoDlg message handlers

BOOL CBackplaneInfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CBackplaneInfoDlg::OnDip() 
{
	// TODO: Add your control notification handler code here
	int DIP;
	TCHAR buf[1];
	DIP= pac_GetDIPSwitch();	
	swprintf(buf, TEXT("%d"), DIP);
	SetDlgItemText(IDC_DIPSWITCH, buf);
}

void CBackplaneInfoDlg::OnBk() 
{
	// TODO: Add your control notification handler code here
	char BK[64];
	TCHAR buf[64];
	pac_GetBackplaneID(BK);
	pac_AnsiToWideString(BK, buf);
	SetDlgItemText(IDC_BKID, buf);			
}

void CBackplaneInfoDlg::OnSlot() 
{
	// TODO: Add your control notification handler code here
	int Slot;
	TCHAR buf[1];
	Slot= pac_GetSlotCount();	
	swprintf(buf, TEXT("%d"), Slot);
	SetDlgItemText(IDC_SLOTCOUNT, buf);		
}
