// MicroSD_DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MicroSD_Demo.h"
#include "MicroSD_DemoDlg.h"


#include "WinPacSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMicroSD_DemoDlg dialog

CMicroSD_DemoDlg::CMicroSD_DemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMicroSD_DemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMicroSD_DemoDlg)
	m_Results = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMicroSD_DemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMicroSD_DemoDlg)
	DDX_Text(pDX, IDC_EDIT1, m_Results);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMicroSD_DemoDlg, CDialog)
	//{{AFX_MSG_MAP(CMicroSD_DemoDlg)
	ON_BN_CLICKED(IDC_Mount, OnMount)
	ON_BN_CLICKED(IDC_Unmount, OnUnmount)
	ON_BN_CLICKED(IDC_SDExist, OnSDExist)
	ON_BN_CLICKED(IDC_MicroSDOnside, OnMicroSDOnside)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMicroSD_DemoDlg message handlers

BOOL CMicroSD_DemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CMicroSD_DemoDlg::OnMount() 
{
	// TODO: Add your control notification handler code here
	m_Results = pac_SDMount(TEXT("Part00"));	//the partition name
	UpdateData(false);
}

void CMicroSD_DemoDlg::OnUnmount() 
{
	// TODO: Add your control notification handler code here
	m_Results = pac_SDUnmount();
	UpdateData(false);
}

void CMicroSD_DemoDlg::OnSDExist() 
{
	// TODO: Add your control notification handler code here
	m_Results = pac_SDExists();
	UpdateData(false);
}

void CMicroSD_DemoDlg::OnMicroSDOnside() 
{
	// TODO: Add your control notification handler code here
	m_Results = pac_SDOnside();
	UpdateData(false);
}

