// USB_driver_uninstallDlg.cpp : implementation file
//

#include "stdafx.h"
#include "USB_driver_uninstall.h"
#include "USB_driver_uninstallDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUSB_driver_uninstallDlg dialog

CUSB_driver_uninstallDlg::CUSB_driver_uninstallDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSB_driver_uninstallDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSB_driver_uninstallDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSB_driver_uninstallDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSB_driver_uninstallDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSB_driver_uninstallDlg, CDialog)
	//{{AFX_MSG_MAP(CUSB_driver_uninstallDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSB_driver_uninstallDlg message handlers

BOOL CUSB_driver_uninstallDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}
int LoadDriver(LPCWSTR strKeyPath)
{
 
            ActivateDevice(strKeyPath, 0);
            return 0;
}

BOOL UninstallDriver(CString strDev)  
{  
    BOOL bRes = FALSE;  
  
    HANDLE hFind = INVALID_HANDLE_VALUE;  
    try  
    {    
        if(strDev.IsEmpty()){  
            return FALSE;//__leave;   
        }  
  
        //Select the method to search the driver   
        DeviceSearchType searchType;  
        if(strDev.GetAt(strDev.GetLength() - 1) == ':'){  
            searchType = DeviceSearchByLegacyName;  
        }  
        else{  
            searchType = DeviceSearchByDeviceName;  
        }  
  
        DEVMGR_DEVICE_INFORMATION devInfo = {0};  
        devInfo.dwSize = sizeof(devInfo);  
  
        //find the handle  
		//printf("1");
        hFind = FindFirstDevice(searchType, strDev, &devInfo);  
		//printf("2");
        if(hFind == INVALID_HANDLE_VALUE){  
            return FALSE;//__leave;   
        }  
        //printf("3");
        //uninstall 
		//printf("%x\n",devInfo.hDevice);
        bRes = DeactivateDevice(devInfo.hDevice);
		
        //printf("4");
        FindClose(hFind);  
		hFind=NULL;
		//printf("5");
    }  
    //__finally{   
    catch(...){
		return FALSE;
    };  
    return bRes;  
 
}
void CUSB_driver_uninstallDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here

	        UninstallDriver(L"HCD1:");
			SetDlgItemText(IDC_EDIT1, TEXT("Uninstall the USB driver."));
            Sleep(1000);

			SetDlgItemText(IDC_EDIT1, TEXT("The driver will be reinstall after 10 seconds."));
            Sleep(9000);
			
			SetDlgItemText(IDC_EDIT1, TEXT("Reinstall the USB driver."));

            LoadDriver(_T("\\Drivers\\BuiltOut\\OHCI\\"));
            
			Sleep(1000);
			PostQuitMessage(0);//close the program
}
