// ErrorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Error.h"
#include "ErrorDlg.h"

#include "WinPacSDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CErrorDlg dialog

CErrorDlg::CErrorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CErrorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CErrorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CErrorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CErrorDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CErrorDlg, CDialog)
	//{{AFX_MSG_MAP(CErrorDlg)
	ON_BN_CLICKED(IDC_TEST, OnTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CErrorDlg message handlers

BOOL CErrorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CErrorDlg::OnTest() 
{
	HANDLE hPort;
	TCHAR errMessage[32];
	TCHAR BUF[128];
	char buf[32];
	bool ret;
	DWORD errno;

	//Generate an error envet
	hPort = uart_Open("COM7:");

	uart_SetTimeOut( hPort, 1000, 0);
	uart_EnableCheckSum( hPort, true);

	ret = uart_Recv( hPort, buf);
	
	if( ret == false)
	{
		// Retrieve the system error message for the last-error code
		errno = pac_GetLastError();
		pac_GetErrorMessage(errno, errMessage);
		swprintf(BUF, TEXT("Receive data faild with error %x: %s"), errno, errMessage);
		MessageBox( BUF, TEXT("Error"), MB_OK);
	}
}
